require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_CTYPE_H_)) {
    eval 'sub _CTYPE_H_ () {1;}' unless defined(&_CTYPE_H_);
    require 'sys/cdefs.ph';
    require 'sys/_types.ph';
    require '_ctype.ph';
    if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
    }
    if((defined(&__ISO_C_VISIBLE) ? &__ISO_C_VISIBLE : 0) >= 1999) {
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
    }
    eval 'sub isalnum {
        my($c) = @_;
	    eval q( &__istype(($c),  &_CTYPE_A| &_CTYPE_D));
    }' unless defined(&isalnum);
    eval 'sub isalpha {
        my($c) = @_;
	    eval q( &__istype(($c),  &_CTYPE_A));
    }' unless defined(&isalpha);
    eval 'sub iscntrl {
        my($c) = @_;
	    eval q( &__istype(($c),  &_CTYPE_C));
    }' unless defined(&iscntrl);
    eval 'sub isdigit {
        my($c) = @_;
	    eval q( &__isctype(($c),  &_CTYPE_D));
    }' unless defined(&isdigit);
    eval 'sub isgraph {
        my($c) = @_;
	    eval q( &__istype(($c),  &_CTYPE_G));
    }' unless defined(&isgraph);
    eval 'sub islower {
        my($c) = @_;
	    eval q( &__istype(($c),  &_CTYPE_L));
    }' unless defined(&islower);
    eval 'sub isprint {
        my($c) = @_;
	    eval q( &__istype(($c),  &_CTYPE_R));
    }' unless defined(&isprint);
    eval 'sub ispunct {
        my($c) = @_;
	    eval q( &__istype(($c),  &_CTYPE_P));
    }' unless defined(&ispunct);
    eval 'sub isspace {
        my($c) = @_;
	    eval q( &__istype(($c),  &_CTYPE_S));
    }' unless defined(&isspace);
    eval 'sub isupper {
        my($c) = @_;
	    eval q( &__istype(($c),  &_CTYPE_U));
    }' unless defined(&isupper);
    eval 'sub isxdigit {
        my($c) = @_;
	    eval q( &__isctype(($c),  &_CTYPE_X));
    }' unless defined(&isxdigit);
    eval 'sub tolower {
        my($c) = @_;
	    eval q( &__tolower($c));
    }' unless defined(&tolower);
    eval 'sub toupper {
        my($c) = @_;
	    eval q( &__toupper($c));
    }' unless defined(&toupper);
    if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub _tolower {
	    my($c) = @_;
    	    eval q( &__tolower($c));
	}' unless defined(&_tolower);
	eval 'sub _toupper {
	    my($c) = @_;
    	    eval q( &__toupper($c));
	}' unless defined(&_toupper);
	eval 'sub isascii {
	    my($c) = @_;
    	    eval q(((($c) & ~0x7f) == 0));
	}' unless defined(&isascii);
	eval 'sub toascii {
	    my($c) = @_;
    	    eval q((($c) & 0x7f));
	}' unless defined(&toascii);
    }
    if((defined(&__ISO_C_VISIBLE) ? &__ISO_C_VISIBLE : 0) >= 1999) {
	eval 'sub isblank {
	    my($c) = @_;
    	    eval q( &__istype(($c),  &_CTYPE_B));
	}' unless defined(&isblank);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub digittoint {
	    my($c) = @_;
    	    eval q( &__maskrune(($c), 0xff));
	}' unless defined(&digittoint);
	eval 'sub ishexnumber {
	    my($c) = @_;
    	    eval q( &__istype(($c),  &_CTYPE_X));
	}' unless defined(&ishexnumber);
	eval 'sub isideogram {
	    my($c) = @_;
    	    eval q( &__istype(($c),  &_CTYPE_I));
	}' unless defined(&isideogram);
	eval 'sub isnumber {
	    my($c) = @_;
    	    eval q( &__istype(($c),  &_CTYPE_D));
	}' unless defined(&isnumber);
	eval 'sub isphonogram {
	    my($c) = @_;
    	    eval q( &__istype(($c),  &_CTYPE_Q));
	}' unless defined(&isphonogram);
	eval 'sub isrune {
	    my($c) = @_;
    	    eval q( &__istype(($c), 0xffffff00));
	}' unless defined(&isrune);
	eval 'sub isspecial {
	    my($c) = @_;
    	    eval q( &__istype(($c),  &_CTYPE_T));
	}' unless defined(&isspecial);
    }
}
1;
