require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&M_ASYNC)) {
    sub M_ASYNC () {	0;}
}
unless(defined(&M_HDLC)) {
    sub M_HDLC () {	1;}
}
unless(defined(&M_G703)) {
    sub M_G703 () {	2;}
}
unless(defined(&M_E1)) {
    sub M_E1 () {	3;}
}
unless(defined(&ER_FRAMING)) {
    sub ER_FRAMING () {	1;}
}
unless(defined(&ER_CHECKSUM)) {
    sub ER_CHECKSUM () {	2;}
}
unless(defined(&ER_BREAK)) {
    sub ER_BREAK () {	3;}
}
unless(defined(&ER_OVERFLOW)) {
    sub ER_OVERFLOW () {	4;}
}
unless(defined(&ER_OVERRUN)) {
    sub ER_OVERRUN () {	5;}
}
unless(defined(&ER_UNDERRUN)) {
    sub ER_UNDERRUN () {	6;}
}
unless(defined(&ER_SCC_FRAMING)) {
    sub ER_SCC_FRAMING () {	7;}
}
unless(defined(&ER_SCC_OVERFLOW)) {
    sub ER_SCC_OVERFLOW () {	8;}
}
unless(defined(&ER_SCC_OVERRUN)) {
    sub ER_SCC_OVERRUN () {	9;}
}
unless(defined(&ER_SCC_UNDERRUN)) {
    sub ER_SCC_UNDERRUN () {	10;}
}
unless(defined(&ER_BUS)) {
    sub ER_BUS () {	11;}
}
unless(defined(&E1_NOALARM)) {
    sub E1_NOALARM () {	0x1;}
}
unless(defined(&E1_FARLOF)) {
    sub E1_FARLOF () {	0x2;}
}
unless(defined(&E1_CRC4E)) {
    sub E1_CRC4E () {	0x4;}
}
unless(defined(&E1_AIS)) {
    sub E1_AIS () {	0x8;}
}
unless(defined(&E1_LOF)) {
    sub E1_LOF () {	0x20;}
}
unless(defined(&E1_LOS)) {
    sub E1_LOS () {	0x40;}
}
unless(defined(&E1_AIS16)) {
    sub E1_AIS16 () {	0x100;}
}
unless(defined(&E1_FARLOMF)) {
    sub E1_FARLOMF () {	0x200;}
}
unless(defined(&E1_LOMF)) {
    sub E1_LOMF () {	0x400;}
}
unless(defined(&E1_TSTREQ)) {
    sub E1_TSTREQ () {	0x800;}
}
unless(defined(&E1_TSTERR)) {
    sub E1_TSTERR () {	0x1000;}
}
unless(defined(&E3_LOS)) {
    sub E3_LOS () {	0x2;}
}
unless(defined(&E3_TXE)) {
    sub E3_TXE () {	0x4;}
}
unless(defined(&SERIAL_GETREGISTERED)) {
    sub SERIAL_GETREGISTERED () {	 &_IOR (ord('x'), 0, 'char'[16]);}
}
unless(defined(&SERIAL_GETPROTO)) {
    sub SERIAL_GETPROTO () {	 &_IOR (ord('x'), 1, 'char' [8]);}
}
unless(defined(&SERIAL_SETPROTO)) {
    sub SERIAL_SETPROTO () {	 &_IOW (ord('x'), 1, 'char' [8]);}
}
unless(defined(&SERIAL_GETMODE)) {
    sub SERIAL_GETMODE () {	 &_IOR (ord('x'), 2, 'int');}
}
unless(defined(&SERIAL_SETMODE)) {
    sub SERIAL_SETMODE () {	 &_IOW (ord('x'), 2, 'int');}
}
unless(defined(&SERIAL_ASYNC)) {
    sub SERIAL_ASYNC () {	1;}
}
unless(defined(&SERIAL_HDLC)) {
    sub SERIAL_HDLC () {	2;}
}
unless(defined(&SERIAL_RAW)) {
    sub SERIAL_RAW () {	3;}
}
unless(defined(&SERIAL_GETSTAT)) {
    sub SERIAL_GETSTAT () {	 &_IOR (ord('x'), 3, 'struct serial_statistics');}
}
unless(defined(&SERIAL_GETESTAT)) {
    sub SERIAL_GETESTAT () {	 &_IOR (ord('x'), 3, 'struct e1_statistics');}
}
unless(defined(&SERIAL_GETE3STAT)) {
    sub SERIAL_GETE3STAT () {	 &_IOR (ord('x'), 3, 'struct e3_statistics');}
}
unless(defined(&SERIAL_CLRSTAT)) {
    sub SERIAL_CLRSTAT () {	 &_IO (ord('x'), 3);}
}
unless(defined(&SERIAL_GETBAUD)) {
    sub SERIAL_GETBAUD () {	 &_IOR (ord('x'), 4, 'long');}
}
unless(defined(&SERIAL_SETBAUD)) {
    sub SERIAL_SETBAUD () {	 &_IOW (ord('x'), 4, 'long');}
}
unless(defined(&SERIAL_GETLOOP)) {
    sub SERIAL_GETLOOP () {	 &_IOR (ord('x'), 5, 'int');}
}
unless(defined(&SERIAL_SETLOOP)) {
    sub SERIAL_SETLOOP () {	 &_IOW (ord('x'), 5, 'int');}
}
unless(defined(&SERIAL_GETDPLL)) {
    sub SERIAL_GETDPLL () {	 &_IOR (ord('x'), 6, 'int');}
}
unless(defined(&SERIAL_SETDPLL)) {
    sub SERIAL_SETDPLL () {	 &_IOW (ord('x'), 6, 'int');}
}
unless(defined(&SERIAL_GETNRZI)) {
    sub SERIAL_GETNRZI () {	 &_IOR (ord('x'), 7, 'int');}
}
unless(defined(&SERIAL_SETNRZI)) {
    sub SERIAL_SETNRZI () {	 &_IOW (ord('x'), 7, 'int');}
}
unless(defined(&SERIAL_GETINVCLK)) {
    sub SERIAL_GETINVCLK () {	 &_IOR (ord('x'), 8, 'int');}
}
unless(defined(&SERIAL_SETINVCLK)) {
    sub SERIAL_SETINVCLK () {	 &_IOW (ord('x'), 8, 'int');}
}
unless(defined(&SERIAL_GETCLK)) {
    sub SERIAL_GETCLK () {	 &_IOR (ord('x'), 9, 'int');}
}
unless(defined(&SERIAL_SETCLK)) {
    sub SERIAL_SETCLK () {	 &_IOW (ord('x'), 9, 'int');}
}
unless(defined(&E1CLK_RECOVERY)) {
    sub E1CLK_RECOVERY () {	-1;}
}
unless(defined(&E1CLK_INTERNAL)) {
    sub E1CLK_INTERNAL () {	0;}
}
unless(defined(&E1CLK_RECEIVE)) {
    sub E1CLK_RECEIVE () {	1;}
}
unless(defined(&E1CLK_RECEIVE_CHAN0)) {
    sub E1CLK_RECEIVE_CHAN0 () {	2;}
}
unless(defined(&E1CLK_RECEIVE_CHAN1)) {
    sub E1CLK_RECEIVE_CHAN1 () {	3;}
}
unless(defined(&E1CLK_RECEIVE_CHAN2)) {
    sub E1CLK_RECEIVE_CHAN2 () {	4;}
}
unless(defined(&E1CLK_RECEIVE_CHAN3)) {
    sub E1CLK_RECEIVE_CHAN3 () {	5;}
}
unless(defined(&SERIAL_GETTIMESLOTS)) {
    sub SERIAL_GETTIMESLOTS () {	 &_IOR (ord('x'), 10, 'long');}
}
unless(defined(&SERIAL_SETTIMESLOTS)) {
    sub SERIAL_SETTIMESLOTS () {	 &_IOW (ord('x'), 10, 'long');}
}
unless(defined(&SERIAL_GETSUBCHAN)) {
    sub SERIAL_GETSUBCHAN () {	 &_IOR (ord('x'), 11, 'long');}
}
unless(defined(&SERIAL_SETSUBCHAN)) {
    sub SERIAL_SETSUBCHAN () {	 &_IOW (ord('x'), 11, 'long');}
}
unless(defined(&SERIAL_GETHIGAIN)) {
    sub SERIAL_GETHIGAIN () {	 &_IOR (ord('x'), 12, 'int');}
}
unless(defined(&SERIAL_SETHIGAIN)) {
    sub SERIAL_SETHIGAIN () {	 &_IOW (ord('x'), 12, 'int');}
}
unless(defined(&SERIAL_GETLEVEL)) {
    sub SERIAL_GETLEVEL () {	 &_IOR (ord('x'), 13, 'int');}
}
unless(defined(&SERIAL_GETNAME)) {
    sub SERIAL_GETNAME () {	 &_IOR (ord('x'), 14, 'char' [32]);}
}
unless(defined(&SERIAL_GETVERSIONSTRING)) {
    sub SERIAL_GETVERSIONSTRING () {	 &_IOR (ord('x'), 15, 'char' [256]);}
}
unless(defined(&SERIAL_GETMASTER)) {
    sub SERIAL_GETMASTER () {	 &_IOR (ord('x'), 16, 'char' [16]);}
}
unless(defined(&SERIAL_SETMASTER)) {
    sub SERIAL_SETMASTER () {	 &_IOW (ord('x'), 16, 'char' [16]);}
}
unless(defined(&SERIAL_GETKEEPALIVE)) {
    sub SERIAL_GETKEEPALIVE () {	 &_IOR (ord('x'), 17, 'int');}
}
unless(defined(&SERIAL_SETKEEPALIVE)) {
    sub SERIAL_SETKEEPALIVE () {	 &_IOW (ord('x'), 17, 'int');}
}
unless(defined(&SERIAL_GETCFG)) {
    sub SERIAL_GETCFG () {	 &_IOR (ord('x'), 18, 'char');}
}
unless(defined(&SERIAL_SETCFG)) {
    sub SERIAL_SETCFG () {	 &_IOW (ord('x'), 18, 'char');}
}
unless(defined(&SERIAL_GETDEBUG)) {
    sub SERIAL_GETDEBUG () {	 &_IOR (ord('x'), 19, 'int');}
}
unless(defined(&SERIAL_SETDEBUG)) {
    sub SERIAL_SETDEBUG () {	 &_IOW (ord('x'), 19, 'int');}
}
unless(defined(&SERIAL_GETPHONY)) {
    sub SERIAL_GETPHONY () {	 &_IOR (ord('x'), 20, 'int');}
}
unless(defined(&SERIAL_SETPHONY)) {
    sub SERIAL_SETPHONY () {	 &_IOW (ord('x'), 20, 'int');}
}
unless(defined(&SERIAL_GETUSE16)) {
    sub SERIAL_GETUSE16 () {	 &_IOR (ord('x'), 21, 'int');}
}
unless(defined(&SERIAL_SETUSE16)) {
    sub SERIAL_SETUSE16 () {	 &_IOW (ord('x'), 21, 'int');}
}
unless(defined(&SERIAL_GETCRC4)) {
    sub SERIAL_GETCRC4 () {	 &_IOR (ord('x'), 22, 'int');}
}
unless(defined(&SERIAL_SETCRC4)) {
    sub SERIAL_SETCRC4 () {	 &_IOW (ord('x'), 22, 'int');}
}
unless(defined(&SERIAL_GETTIMO)) {
    sub SERIAL_GETTIMO () {	 &_IOR (ord('x'), 23, 'long');}
}
unless(defined(&SERIAL_SETTIMO)) {
    sub SERIAL_SETTIMO () {	 &_IOW (ord('x'), 23, 'long');}
}
unless(defined(&SERIAL_GETPORT)) {
    sub SERIAL_GETPORT () {	 &_IOR (ord('x'), 25, 'int');}
}
unless(defined(&SERIAL_SETPORT)) {
    sub SERIAL_SETPORT () {	 &_IOW (ord('x'), 25, 'int');}
}
unless(defined(&SERIAL_ADDDLCI)) {
    sub SERIAL_ADDDLCI () {	 &_IOW (ord('x'), 26, 'int');}
}
unless(defined(&SERIAL_GETINVRCLK)) {
    sub SERIAL_GETINVRCLK () {	 &_IOR (ord('x'), 27, 'int');}
}
unless(defined(&SERIAL_SETINVRCLK)) {
    sub SERIAL_SETINVRCLK () {	 &_IOW (ord('x'), 27, 'int');}
}
unless(defined(&SERIAL_GETINVTCLK)) {
    sub SERIAL_GETINVTCLK () {	 &_IOR (ord('x'), 28, 'int');}
}
unless(defined(&SERIAL_SETINVTCLK)) {
    sub SERIAL_SETINVTCLK () {	 &_IOW (ord('x'), 28, 'int');}
}
unless(defined(&SERIAL_GETUNFRAM)) {
    sub SERIAL_GETUNFRAM () {	 &_IOR (ord('x'), 29, 'int');}
}
unless(defined(&SERIAL_SETUNFRAM)) {
    sub SERIAL_SETUNFRAM () {	 &_IOW (ord('x'), 29, 'int');}
}
unless(defined(&SERIAL_GETMONITOR)) {
    sub SERIAL_GETMONITOR () {	 &_IOR (ord('x'), 30, 'int');}
}
unless(defined(&SERIAL_SETMONITOR)) {
    sub SERIAL_SETMONITOR () {	 &_IOW (ord('x'), 30, 'int');}
}
unless(defined(&SERIAL_GETIRQ)) {
    sub SERIAL_GETIRQ () {	 &_IOR (ord('x'), 31, 'int');}
}
unless(defined(&SERIAL_RESET)) {
    sub SERIAL_RESET () {	 &_IO (ord('x'), 32);}
}
unless(defined(&SERIAL_HARDRESET)) {
    sub SERIAL_HARDRESET () {	 &_IO (ord('x'), 33);}
}
unless(defined(&SERIAL_GETCABLE)) {
    sub SERIAL_GETCABLE () {	 &_IOR (ord('x'), 34, 'int');}
}
unless(defined(&SERIAL_GETDIR)) {
    sub SERIAL_GETDIR () {	 &_IOR (ord('x'), 35, 'int');}
}
unless(defined(&SERIAL_SETDIR)) {
    sub SERIAL_SETDIR () {	 &_IOW (ord('x'), 35, 'int');}
}
unless(defined(&SERIAL_GETDXC)) {
    sub SERIAL_GETDXC () {	 &_IOR (ord('x'), 36, 'struct dxc_table');}
}
unless(defined(&SERIAL_SETDXC)) {
    sub SERIAL_SETDXC () {	 &_IOW (ord('x'), 36, 'struct dxc_table');}
}
unless(defined(&SERIAL_GETSCRAMBLER)) {
    sub SERIAL_GETSCRAMBLER () {	 &_IOR (ord('x'), 37, 'int');}
}
unless(defined(&SERIAL_SETSCRAMBLER)) {
    sub SERIAL_SETSCRAMBLER () {	 &_IOW (ord('x'), 37, 'int');}
}
unless(defined(&SERIAL_GETCABLEN)) {
    sub SERIAL_GETCABLEN () {	 &_IOR (ord('x'), 38, 'int');}
}
unless(defined(&SERIAL_SETCABLEN)) {
    sub SERIAL_SETCABLEN () {	 &_IOW (ord('x'), 38, 'int');}
}
unless(defined(&SERIAL_GETRLOOP)) {
    sub SERIAL_GETRLOOP () {	 &_IOR (ord('x'), 39, 'int');}
}
unless(defined(&SERIAL_SETRLOOP)) {
    sub SERIAL_SETRLOOP () {	 &_IOW (ord('x'), 39, 'int');}
}
unless(defined(&SERIAL_GETLCODE)) {
    sub SERIAL_GETLCODE () {	 &_IOR (ord('x'), 40, 'int');}
}
unless(defined(&SERIAL_SETLCODE)) {
    sub SERIAL_SETLCODE () {	 &_IOW (ord('x'), 40, 'int');}
}
unless(defined(&SERIAL_GETMTU)) {
    sub SERIAL_GETMTU () {	 &_IOR (ord('x'), 41, 'int');}
}
unless(defined(&SERIAL_SETMTU)) {
    sub SERIAL_SETMTU () {	 &_IOW (ord('x'), 41, 'int');}
}
unless(defined(&SERIAL_GETRQLEN)) {
    sub SERIAL_GETRQLEN () {	 &_IOR (ord('x'), 42, 'int');}
}
unless(defined(&SERIAL_SETRQLEN)) {
    sub SERIAL_SETRQLEN () {	 &_IOW (ord('x'), 42, 'int');}
}
if(defined(&__KERNEL__)) {
    if(defined(&CRONYX_LYSAP)) {
	eval 'sub LYSAP_PEER_ADD () { &_IOWR(ord(\'x\'), 101,  &lysap_peer_config_t);}' unless defined(&LYSAP_PEER_ADD);
	eval 'sub LYSAP_PEER_REMOVE () { &_IOW(ord(\'x\'), 102, \'unsigned\');}' unless defined(&LYSAP_PEER_REMOVE);
	eval 'sub LYSAP_PEER_INFO () { &_IOWR(ord(\'x\'), 103,  &lysap_peer_info_t);}' unless defined(&LYSAP_PEER_INFO);
	eval 'sub LYSAP_PEER_COUNT () { &_IOR(ord(\'x\'), 104, \'unsigned\');}' unless defined(&LYSAP_PEER_COUNT);
	eval 'sub LYSAP_PEER_ENUM () { &_IOWR(ord(\'x\'), 105, \'unsigned\');}' unless defined(&LYSAP_PEER_ENUM);
	eval 'sub LYSAP_PEER_CLEAR () { &_IOW(ord(\'x\'), 106, \'unsigned\');}' unless defined(&LYSAP_PEER_CLEAR);
	eval 'sub LYSAP_CHAN_ADD () { &_IOWR(ord(\'x\'), 111,  &lysap_channel_config_t);}' unless defined(&LYSAP_CHAN_ADD);
	eval 'sub LYSAP_CHAN_REMOVE () { &_IO(ord(\'x\'), 112);}' unless defined(&LYSAP_CHAN_REMOVE);
	eval 'sub LYSAP_CHAN_INFO () { &_IOR(ord(\'x\'), 113,  &lysap_channel_info_t);}' unless defined(&LYSAP_CHAN_INFO);
	eval 'sub LYSAP_CHAN_COUNT () { &_IOR(ord(\'x\'), 114, \'unsigned\');}' unless defined(&LYSAP_CHAN_COUNT);
	eval 'sub LYSAP_CHAN_ENUM () { &_IOWR(ord(\'x\'), 115, \'unsigned\');}' unless defined(&LYSAP_CHAN_ENUM);
	eval 'sub LYSAP_CHAN_CLEAR () { &_IO(ord(\'x\'), 116);}' unless defined(&LYSAP_CHAN_CLEAR);
	require 'lysap-linux.ph';
    } else {
    }
}
1;
