require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MACHINE_ELF_H_)) {
    eval 'sub _MACHINE_ELF_H_ () {1;}' unless defined(&_MACHINE_ELF_H_);
    require 'sys/elf32.ph';
    if(defined( &__ELF_WORD_SIZE)  && (defined(&__ELF_WORD_SIZE) ? &__ELF_WORD_SIZE : 0) == 64) {
	require 'sys/elf64.ph';
    }
    unless(defined(&__ELF_WORD_SIZE)) {
	eval 'sub __ELF_WORD_SIZE () {32;}' unless defined(&__ELF_WORD_SIZE);
    }
    require 'sys/elf_generic.ph';
    eval 'sub ELF_ARCH () { &EM_386;}' unless defined(&ELF_ARCH);
    eval 'sub ELF_MACHINE_OK {
        my($x) = @_;
	    eval q((($x) ==  &EM_386 || ($x) ==  &EM_486));
    }' unless defined(&ELF_MACHINE_OK);
    if((defined(&__ELF_WORD_SIZE) ? &__ELF_WORD_SIZE : 0) == 64) {
    }
    eval 'sub AT_NULL () {0;}' unless defined(&AT_NULL);
    eval 'sub AT_IGNORE () {1;}' unless defined(&AT_IGNORE);
    eval 'sub AT_EXECFD () {2;}' unless defined(&AT_EXECFD);
    eval 'sub AT_PHDR () {3;}' unless defined(&AT_PHDR);
    eval 'sub AT_PHENT () {4;}' unless defined(&AT_PHENT);
    eval 'sub AT_PHNUM () {5;}' unless defined(&AT_PHNUM);
    eval 'sub AT_PAGESZ () {6;}' unless defined(&AT_PAGESZ);
    eval 'sub AT_BASE () {7;}' unless defined(&AT_BASE);
    eval 'sub AT_FLAGS () {8;}' unless defined(&AT_FLAGS);
    eval 'sub AT_ENTRY () {9;}' unless defined(&AT_ENTRY);
    eval 'sub AT_BRK () {10;}' unless defined(&AT_BRK);
    eval 'sub AT_DEBUG () {11;}' unless defined(&AT_DEBUG);
    eval 'sub AT_NOTELF () {10;}' unless defined(&AT_NOTELF);
    eval 'sub AT_UID () {11;}' unless defined(&AT_UID);
    eval 'sub AT_EUID () {12;}' unless defined(&AT_EUID);
    eval 'sub AT_GID () {13;}' unless defined(&AT_GID);
    eval 'sub AT_EGID () {14;}' unless defined(&AT_EGID);
    eval 'sub AT_COUNT () {15;}' unless defined(&AT_COUNT);
    eval 'sub R_386_NONE () {0;}' unless defined(&R_386_NONE);
    eval 'sub R_386_32 () {1;}' unless defined(&R_386_32);
    eval 'sub R_386_PC32 () {2;}' unless defined(&R_386_PC32);
    eval 'sub R_386_GOT32 () {3;}' unless defined(&R_386_GOT32);
    eval 'sub R_386_PLT32 () {4;}' unless defined(&R_386_PLT32);
    eval 'sub R_386_COPY () {5;}' unless defined(&R_386_COPY);
    eval 'sub R_386_GLOB_DAT () {6;}' unless defined(&R_386_GLOB_DAT);
    eval 'sub R_386_JMP_SLOT () {7;}' unless defined(&R_386_JMP_SLOT);
    eval 'sub R_386_RELATIVE () {8;}' unless defined(&R_386_RELATIVE);
    eval 'sub R_386_GOTOFF () {9;}' unless defined(&R_386_GOTOFF);
    eval 'sub R_386_GOTPC () {10;}' unless defined(&R_386_GOTPC);
    eval 'sub R_386_TLS_TPOFF () {14;}' unless defined(&R_386_TLS_TPOFF);
    eval 'sub R_386_TLS_IE () {15;}' unless defined(&R_386_TLS_IE);
    eval 'sub R_386_TLS_GOTIE () {16;}' unless defined(&R_386_TLS_GOTIE);
    eval 'sub R_386_TLS_LE () {17;}' unless defined(&R_386_TLS_LE);
    eval 'sub R_386_TLS_GD () {18;}' unless defined(&R_386_TLS_GD);
    eval 'sub R_386_TLS_LDM () {19;}' unless defined(&R_386_TLS_LDM);
    eval 'sub R_386_TLS_GD_32 () {24;}' unless defined(&R_386_TLS_GD_32);
    eval 'sub R_386_TLS_GD_PUSH () {25;}' unless defined(&R_386_TLS_GD_PUSH);
    eval 'sub R_386_TLS_GD_CALL () {26;}' unless defined(&R_386_TLS_GD_CALL);
    eval 'sub R_386_TLS_GD_POP () {27;}' unless defined(&R_386_TLS_GD_POP);
    eval 'sub R_386_TLS_LDM_32 () {28;}' unless defined(&R_386_TLS_LDM_32);
    eval 'sub R_386_TLS_LDM_PUSH () {29;}' unless defined(&R_386_TLS_LDM_PUSH);
    eval 'sub R_386_TLS_LDM_CALL () {30;}' unless defined(&R_386_TLS_LDM_CALL);
    eval 'sub R_386_TLS_LDM_POP () {31;}' unless defined(&R_386_TLS_LDM_POP);
    eval 'sub R_386_TLS_LDO_32 () {32;}' unless defined(&R_386_TLS_LDO_32);
    eval 'sub R_386_TLS_IE_32 () {33;}' unless defined(&R_386_TLS_IE_32);
    eval 'sub R_386_TLS_LE_32 () {34;}' unless defined(&R_386_TLS_LE_32);
    eval 'sub R_386_TLS_DTPMOD32 () {35;}' unless defined(&R_386_TLS_DTPMOD32);
    eval 'sub R_386_TLS_DTPOFF32 () {36;}' unless defined(&R_386_TLS_DTPOFF32);
    eval 'sub R_386_TLS_TPOFF32 () {37;}' unless defined(&R_386_TLS_TPOFF32);
    eval 'sub R_386_COUNT () {38;}' unless defined(&R_386_COUNT);
    eval 'sub ELF_TARG_CLASS () { &ELFCLASS32;}' unless defined(&ELF_TARG_CLASS);
    eval 'sub ELF_TARG_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_TARG_DATA);
    eval 'sub ELF_TARG_MACH () { &EM_386;}' unless defined(&ELF_TARG_MACH);
    eval 'sub ELF_TARG_VER () {1;}' unless defined(&ELF_TARG_VER);
}
1;
