require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MACHINE_IN_CKSUM_H_)) {
    eval 'sub _MACHINE_IN_CKSUM_H_ () {1;}' unless defined(&_MACHINE_IN_CKSUM_H_);
    unless(defined(&_SYS_CDEFS_H_)) {
	die("this\ file\ needs\ sys\/cdefs\.h\ as\ a\ prerequisite");
    }
    require 'sys/cdefs.ph';
    eval 'sub in_cksum {
        my($m, $len) = @_;
	    eval q( &in_cksum_skip($m, $len, 0));
    }' unless defined(&in_cksum);
    if(defined( &__GNUCLIKE_ASM)  && !defined( &__INTEL_COMPILER)) {
	eval 'sub in_cksum_hdr {
	    my($ip) = @_;
    	    eval q({  &register \'u_int\'  &sum = 0;  &__asm  &__volatile ( \\"addl %1, %0\\\\n\\" \\"adcl %2, %0\\\\n\\" \\"adcl %3, %0\\\\n\\" \\"adcl %4, %0\\\\n\\" \\"adcl %5, %0\\\\n\\" \\"adcl $0, %0\\" : \\"+r\\" ( &sum) : \\"g\\" ((( &const  &u_int32_t *)$ip)[0]), \\"g\\" ((( &const  &u_int32_t *)$ip)[1]), \\"g\\" ((( &const  &u_int32_t *)$ip)[2]), \\"g\\" ((( &const  &u_int32_t *)$ip)[3]), \\"g\\" ((( &const  &u_int32_t *)$ip)[4]) );  &sum = ( &sum & 0xffff) + ( &sum >> 16);  &if ( &sum > 0xffff)  &sum -= 0xffff; ~ &sum & 0xffff; });
	}' unless defined(&in_cksum_hdr);
	eval 'sub in_cksum_update {
	    my($ip) = @_;
    	    eval q({ \'int\'  &__tmpsum;  &__tmpsum =  &ntohs( ($ip->{ip_sum})) + 256;  ($ip->{ip_sum}) =  &htons( &__tmpsum + ( &__tmpsum >> 16)); });
	}' unless defined(&in_cksum_update);
	eval 'sub in_addword {
	    my($sum,$b) = @_;
    	    eval q({  &__asm  &__volatile (\\"addw %1, %0\\" : \\"+r\\" ($sum) : \\"r\\" ($b));  &__asm  &__volatile (\\"adcw $0, %0\\" : \\"+r\\" ($sum)); ($sum); });
	}' unless defined(&in_addword);
	eval 'sub in_pseudo {
	    my($sum,$b,$c) = @_;
    	    eval q({  &__asm  &__volatile (\\"addl %1, %0\\" : \\"+r\\" ($sum) : \\"g\\" ($b));  &__asm  &__volatile (\\"adcl %1, %0\\" : \\"+r\\" ($sum) : \\"g\\" ($c));  &__asm  &__volatile (\\"adcl $0, %0\\" : \\"+r\\" ($sum)); $sum = ($sum & 0xffff) + ($sum >> 16);  &if ($sum > 0xffff) $sum -= 0xffff; ($sum); });
	}' unless defined(&in_pseudo);
    } else {
	eval 'sub in_cksum_update {
	    my($ip) = @_;
    	    eval q( &do { \'int\'  &__tmpsum;  &__tmpsum =  &ntohs( ($ip->{ip_sum})) + 256;  ($ip->{ip_sum}) =  &htons( &__tmpsum + ( &__tmpsum >> 16)); }  &while(0));
	}' unless defined(&in_cksum_update);
    }
    if(defined(&_KERNEL)) {
	if(!defined( &__GNUCLIKE_ASM) || defined( &__INTEL_COMPILER)) {
	}
    }
}
1;
