require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MACHINE_VMPARAM_H_)) {
    eval 'sub _MACHINE_VMPARAM_H_ () {1;}' unless defined(&_MACHINE_VMPARAM_H_);
    eval 'sub VM_PROT_READ_IS_EXEC () {1;}' unless defined(&VM_PROT_READ_IS_EXEC);
    eval 'sub MAXTSIZ () {(128*1024*1024);}' unless defined(&MAXTSIZ);
    unless(defined(&DFLDSIZ)) {
	eval 'sub DFLDSIZ () {(128*1024*1024);}' unless defined(&DFLDSIZ);
    }
    unless(defined(&MAXDSIZ)) {
	eval 'sub MAXDSIZ () {(512*1024*1024);}' unless defined(&MAXDSIZ);
    }
    unless(defined(&DFLSSIZ)) {
	eval 'sub DFLSSIZ () {(8*1024*1024);}' unless defined(&DFLSSIZ);
    }
    unless(defined(&MAXSSIZ)) {
	eval 'sub MAXSSIZ () {(64*1024*1024);}' unless defined(&MAXSSIZ);
    }
    unless(defined(&SGROWSIZ)) {
	eval 'sub SGROWSIZ () {(128*1024);}' unless defined(&SGROWSIZ);
    }
    eval 'sub USRTEXT () {(1* &PAGE_SIZE);}' unless defined(&USRTEXT);
    eval 'sub MAXSLP () {20;}' unless defined(&MAXSLP);
    unless(defined(&KERNLOAD)) {
	eval 'sub KERNLOAD () {(1<<  &PDRSHIFT);}' unless defined(&KERNLOAD);
    }
    eval 'sub VM_MAX_KERNEL_ADDRESS () { &VADDR( &KPTDI+ &NKPDE-1,  &NPTEPG-1);}' unless defined(&VM_MAX_KERNEL_ADDRESS);
    eval 'sub VM_MIN_KERNEL_ADDRESS () { &VADDR( &PTDPTDI,  &PTDPTDI);}' unless defined(&VM_MIN_KERNEL_ADDRESS);
    eval 'sub KERNBASE () { &VADDR( &KPTDI, 0);}' unless defined(&KERNBASE);
    eval 'sub UPT_MAX_ADDRESS () { &VADDR( &PTDPTDI,  &PTDPTDI);}' unless defined(&UPT_MAX_ADDRESS);
    eval 'sub UPT_MIN_ADDRESS () { &VADDR( &PTDPTDI, 0);}' unless defined(&UPT_MIN_ADDRESS);
    eval 'sub VM_MAXUSER_ADDRESS () { &VADDR( &PTDPTDI, 0);}' unless defined(&VM_MAXUSER_ADDRESS);
    eval 'sub USRSTACK () { &VM_MAXUSER_ADDRESS;}' unless defined(&USRSTACK);
    eval 'sub VM_MAX_ADDRESS () { &VADDR( &PTDPTDI,  &PTDPTDI);}' unless defined(&VM_MAX_ADDRESS);
    eval 'sub VM_MIN_ADDRESS () {(( &vm_offset_t)0);}' unless defined(&VM_MIN_ADDRESS);
    unless(defined(&VM_KMEM_SIZE)) {
	eval 'sub VM_KMEM_SIZE () {(12* 1024* 1024);}' unless defined(&VM_KMEM_SIZE);
    }
    unless(defined(&VM_KMEM_SIZE_SCALE)) {
	eval 'sub VM_KMEM_SIZE_SCALE () {(3);}' unless defined(&VM_KMEM_SIZE_SCALE);
    }
    unless(defined(&VM_KMEM_SIZE_MAX)) {
	eval 'sub VM_KMEM_SIZE_MAX () {(320* 1024* 1024);}' unless defined(&VM_KMEM_SIZE_MAX);
    }
    unless(defined(&VM_INITIAL_PAGEIN)) {
	eval 'sub VM_INITIAL_PAGEIN () {16;}' unless defined(&VM_INITIAL_PAGEIN);
    }
}
1;
