require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_STDLIB_H_)) {
    eval 'sub _STDLIB_H_ () {1;}' unless defined(&_STDLIB_H_);
    require 'sys/cdefs.ph';
    require 'sys/_null.ph';
    require 'sys/_types.ph';
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	unless(defined(&_RUNE_T_DECLARED)) {
	    eval 'sub _RUNE_T_DECLARED () {1;}' unless defined(&_RUNE_T_DECLARED);
	}
    }
    unless(defined(&_SIZE_T_DECLARED)) {
	eval 'sub _SIZE_T_DECLARED () {1;}' unless defined(&_SIZE_T_DECLARED);
    }
    unless(defined(&__cplusplus)) {
	unless(defined(&_WCHAR_T_DECLARED)) {
	    eval 'sub _WCHAR_T_DECLARED () {1;}' unless defined(&_WCHAR_T_DECLARED);
	}
    }
    eval 'sub EXIT_FAILURE () {1;}' unless defined(&EXIT_FAILURE);
    eval 'sub EXIT_SUCCESS () {0;}' unless defined(&EXIT_SUCCESS);
    eval 'sub RAND_MAX () {0x7fffffff;}' unless defined(&RAND_MAX);
    eval 'sub MB_CUR_MAX () { &__mb_cur_max;}' unless defined(&MB_CUR_MAX);
    if((defined(&__ISO_C_VISIBLE) ? &__ISO_C_VISIBLE : 0) >= 1999) {
	if(defined(&__LONG_LONG_SUPPORTED)) {
	}
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) ) {
    }
    if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	unless(defined(&_MKSTEMP_DECLARED)) {
	    eval 'sub _MKSTEMP_DECLARED () {1;}' unless defined(&_MKSTEMP_DECLARED);
	}
	unless(defined(&_MKTEMP_DECLARED)) {
	    eval 'sub _MKTEMP_DECLARED () {1;}' unless defined(&_MKTEMP_DECLARED);
	}
	unless(defined(&_SETKEY_DECLARED)) {
	    eval 'sub _SETKEY_DECLARED () {1;}' unless defined(&_SETKEY_DECLARED);
	}
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	if((defined(&__GNUC__) ? &__GNUC__ : 0) >= 2|| defined( &__INTEL_COMPILER)) {
	    undef(&alloca) if defined(&alloca);
	    eval 'sub alloca {
	        my($sz) = @_;
    		eval q( &__builtin_alloca($sz));
	    }' unless defined(&alloca);
	}
 elsif(defined( &lint)) {
	}
    }
}
1;
