require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_ACL_H_)) {
    eval 'sub _SYS_ACL_H_ () {1;}' unless defined(&_SYS_ACL_H_);
    require 'sys/param.ph';
    require 'sys/queue.ph';
    require 'vm/uma.ph';
    eval 'sub POSIX1E_ACL_ACCESS_EXTATTR_NAMESPACE () { &EXTATTR_NAMESPACE_SYSTEM;}' unless defined(&POSIX1E_ACL_ACCESS_EXTATTR_NAMESPACE);
    eval 'sub POSIX1E_ACL_ACCESS_EXTATTR_NAME () {"posix1e.acl_access";}' unless defined(&POSIX1E_ACL_ACCESS_EXTATTR_NAME);
    eval 'sub POSIX1E_ACL_DEFAULT_EXTATTR_NAMESPACE () { &EXTATTR_NAMESPACE_SYSTEM;}' unless defined(&POSIX1E_ACL_DEFAULT_EXTATTR_NAMESPACE);
    eval 'sub POSIX1E_ACL_DEFAULT_EXTATTR_NAME () {"posix1e.acl_default";}' unless defined(&POSIX1E_ACL_DEFAULT_EXTATTR_NAME);
    eval 'sub ACL_MAX_ENTRIES () {32;}' unless defined(&ACL_MAX_ENTRIES);
    eval 'sub ACL_UNDEFINED_TAG () {0x;}' unless defined(&ACL_UNDEFINED_TAG);
    eval 'sub ACL_USER_OBJ () {0x1;}' unless defined(&ACL_USER_OBJ);
    eval 'sub ACL_USER () {0x2;}' unless defined(&ACL_USER);
    eval 'sub ACL_GROUP_OBJ () {0x4;}' unless defined(&ACL_GROUP_OBJ);
    eval 'sub ACL_GROUP () {0x8;}' unless defined(&ACL_GROUP);
    eval 'sub ACL_MASK () {0x10;}' unless defined(&ACL_MASK);
    eval 'sub ACL_OTHER () {0x20;}' unless defined(&ACL_OTHER);
    eval 'sub ACL_OTHER_OBJ () { &ACL_OTHER;}' unless defined(&ACL_OTHER_OBJ);
    eval 'sub ACL_TYPE_ACCESS () {0x;}' unless defined(&ACL_TYPE_ACCESS);
    eval 'sub ACL_TYPE_DEFAULT () {0x1;}' unless defined(&ACL_TYPE_DEFAULT);
    eval 'sub ACL_EXECUTE () {0x1;}' unless defined(&ACL_EXECUTE);
    eval 'sub ACL_WRITE () {0x2;}' unless defined(&ACL_WRITE);
    eval 'sub ACL_READ () {0x4;}' unless defined(&ACL_READ);
    eval 'sub ACL_PERM_NONE () {0x;}' unless defined(&ACL_PERM_NONE);
    eval 'sub ACL_PERM_BITS () {( &ACL_EXECUTE |  &ACL_WRITE |  &ACL_READ);}' unless defined(&ACL_PERM_BITS);
    eval 'sub ACL_POSIX1E_BITS () {( &ACL_EXECUTE |  &ACL_WRITE |  &ACL_READ);}' unless defined(&ACL_POSIX1E_BITS);
    eval 'sub ACL_FIRST_ENTRY () {0;}' unless defined(&ACL_FIRST_ENTRY);
    eval 'sub ACL_NEXT_ENTRY () {1;}' unless defined(&ACL_NEXT_ENTRY);
    eval 'sub ACL_UNDEFINED_ID () {(( &uid_t)-1);}' unless defined(&ACL_UNDEFINED_ID);
    if(defined(&_KERNEL)) {
	eval 'sub ACL_OVERRIDE_MASK () {( &S_IRWXU |  &S_IRWXG |  &S_IRWXO);}' unless defined(&ACL_OVERRIDE_MASK);
	eval 'sub ACL_PRESERVE_MASK () {(~ &ACL_OVERRIDE_MASK);}' unless defined(&ACL_PRESERVE_MASK);
    } else {
    }
}
1;
