require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_BUFOBJ_H_)) {
    eval 'sub _SYS_BUFOBJ_H_ () {1;}' unless defined(&_SYS_BUFOBJ_H_);
    if(defined( &_KERNEL) || defined( &_KVM_VNODE)) {
	require 'sys/queue.ph';
	eval 'sub BO_STRATEGY {
	    my($bo, $bp) = @_;
    	    eval q((($bo)-> ($bo_ops->{bop_strategy})(($bo), ($bp))));
	}' unless defined(&BO_STRATEGY);
	eval 'sub BO_SYNC {
	    my($bo, $w, $td) = @_;
    	    eval q((($bo)-> ($bo_ops->{bop_sync})(($bo), ($w), ($td))));
	}' unless defined(&BO_SYNC);
	eval 'sub BO_WRITE {
	    my($bo, $bp) = @_;
    	    eval q((($bo)-> ($bo_ops->{bop_write})(($bp))));
	}' unless defined(&BO_WRITE);
	eval 'sub BO_BDFLUSH {
	    my($bo, $bp) = @_;
    	    eval q((($bo)-> ($bo_ops->{bop_bdflush})(($bo), ($bp))));
	}' unless defined(&BO_BDFLUSH);
	eval 'sub BO_ONWORKLST () {(1<< 0);}' unless defined(&BO_ONWORKLST);
	eval 'sub BO_WWAIT () {(1<< 1);}' unless defined(&BO_WWAIT);
	eval 'sub BO_LOCK {
	    my($bo) = @_;
    	    eval q( &do {  &KASSERT(($bo)-> &bo_mtx !=  &NULL, (\\"No lock in bufobj\\"));  &mtx_lock(($bo)-> &bo_mtx); }  &while (0));
	}' unless defined(&BO_LOCK);
	eval 'sub BO_UNLOCK {
	    my($bo) = @_;
    	    eval q( &do {  &KASSERT(($bo)-> &bo_mtx !=  &NULL, (\\"No lock in bufobj\\"));  &mtx_unlock(($bo)-> &bo_mtx); }  &while (0));
	}' unless defined(&BO_UNLOCK);
	eval 'sub BO_MTX {
	    my($bo) = @_;
    	    eval q((($bo)-> &bo_mtx));
	}' unless defined(&BO_MTX);
	eval 'sub ASSERT_BO_LOCKED {
	    my($bo) = @_;
    	    eval q( &mtx_assert( ($bo->{bo_mtx}),  &MA_OWNED));
	}' unless defined(&ASSERT_BO_LOCKED);
	eval 'sub ASSERT_BO_UNLOCKED {
	    my($bo) = @_;
    	    eval q( &mtx_assert( ($bo->{bo_mtx}),  &MA_NOTOWNED));
	}' unless defined(&ASSERT_BO_UNLOCKED);
    }
}
1;
