require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_BUS_H_)) {
    eval 'sub _SYS_BUS_H_ () {1;}' unless defined(&_SYS_BUS_H_);
    eval 'sub BUS_USER_VERSION () {1;}' unless defined(&BUS_USER_VERSION);
    eval("sub DS_NOTPRESENT () { 0; }") unless defined(&DS_NOTPRESENT);
    eval("sub DS_ALIVE () { 1; }") unless defined(&DS_ALIVE);
    eval("sub DS_ATTACHED () { 2; }") unless defined(&DS_ATTACHED);
    eval("sub DS_BUSY () { 3; }") unless defined(&DS_BUSY);
    if(defined(&_KERNEL)) {
	require 'sys/queue.ph';
	require 'sys/kobj.ph';
	eval 'sub device_method_t () { &kobj_method_t;}' unless defined(&device_method_t);
	eval("sub INTR_TYPE_TTY () { 1; }") unless defined(&INTR_TYPE_TTY);
	eval("sub INTR_TYPE_BIO () { 2; }") unless defined(&INTR_TYPE_BIO);
	eval("sub INTR_TYPE_NET () { 4; }") unless defined(&INTR_TYPE_NET);
	eval("sub INTR_TYPE_CAM () { 8; }") unless defined(&INTR_TYPE_CAM);
	eval("sub INTR_TYPE_MISC () { 16; }") unless defined(&INTR_TYPE_MISC);
	eval("sub INTR_TYPE_CLK () { 32; }") unless defined(&INTR_TYPE_CLK);
	eval("sub INTR_TYPE_AV () { 64; }") unless defined(&INTR_TYPE_AV);
	eval("sub INTR_FAST () { 128; }") unless defined(&INTR_FAST);
	eval("sub INTR_EXCL () { 256; }") unless defined(&INTR_EXCL);
	eval("sub INTR_MPSAFE () { 512; }") unless defined(&INTR_MPSAFE);
	eval("sub INTR_ENTROPY () { 1024; }") unless defined(&INTR_ENTROPY);
	eval("sub INTR_TRIGGER_CONFORM () { 0; }") unless defined(&INTR_TRIGGER_CONFORM);
	eval("sub INTR_TRIGGER_EDGE () { 1; }") unless defined(&INTR_TRIGGER_EDGE);
	eval("sub INTR_TRIGGER_LEVEL () { 2; }") unless defined(&INTR_TRIGGER_LEVEL);
	eval("sub INTR_POLARITY_CONFORM () { 0; }") unless defined(&INTR_POLARITY_CONFORM);
	eval("sub INTR_POLARITY_HIGH () { 1; }") unless defined(&INTR_POLARITY_HIGH);
	eval("sub INTR_POLARITY_LOW () { 2; }") unless defined(&INTR_POLARITY_LOW);
	eval 'sub bus_alloc_resource_any {
	    my($dev,$type,$rid,$flags) = @_;
    	    eval q({ ( &bus_alloc_resource($dev, $type, $rid, 0, ~0, 1, $flags)); });
	}' unless defined(&bus_alloc_resource_any);
	eval 'sub bus_get_dma_tag {
	    my($a) = @_;
    	    eval q( &NULL);
	}' unless defined(&bus_get_dma_tag);
	eval 'sub BUS_PROBE_SPECIFIC () {0;}' unless defined(&BUS_PROBE_SPECIFIC);
	eval 'sub BUS_PROBE_VENDOR () {(-10);}' unless defined(&BUS_PROBE_VENDOR);
	eval 'sub BUS_PROBE_DEFAULT () {(-20);}' unless defined(&BUS_PROBE_DEFAULT);
	eval 'sub BUS_PROBE_LOW_PRIORITY () {(-40);}' unless defined(&BUS_PROBE_LOW_PRIORITY);
	eval 'sub BUS_PROBE_GENERIC () {(-100);}' unless defined(&BUS_PROBE_GENERIC);
	eval 'sub BUS_PROBE_HOOVER () {(-500);}' unless defined(&BUS_PROBE_HOOVER);
	eval 'sub DEVMETHOD () { &KOBJMETHOD;}' unless defined(&DEVMETHOD);
	require 'device_if.ph';
	require 'bus_if.ph';
	eval 'sub DRIVER_MODULE {
	    my($name, $busname, $driver, $devclass, $evh, $arg) = @_;
    	    eval q( &static \'struct driver_module_data\' $name &_$busname &_driver_mod = { $evh, $arg, $busname, ( &kobj_class_t) $driver, $devclass };  &static  &moduledata_t $name &_$busname &_mod = { $busname \\"/\\" $name,  &driver_module_handler, $name &_$busname &_driver_mod };  &DECLARE_MODULE($name &_$busname, $name &_$busname &_mod,  &SI_SUB_DRIVERS,  &SI_ORDER_MIDDLE));
	}' unless defined(&DRIVER_MODULE);
	eval 'sub __BUS_ACCESSOR {
	    my($varp, $var, $ivarp, $ivar, $type) = @_;
    	    eval q( &static  &__inline $type $varp   &_get_  $var( &device_t  &dev) {  &uintptr_t  &v;  &BUS_READ_IVAR( &device_get_parent( &dev),  &dev, $ivarp   &_IVAR_  $ivar,  &v);  &return (($type)  &v); }  &static  &__inline  &void $varp   &_set_  $var( &device_t  &dev, $type  &t) {  &uintptr_t  &v = ( &uintptr_t)  &t;  &BUS_WRITE_IVAR( &device_get_parent( &dev),  &dev, $ivarp   &_IVAR_  $ivar,  &v); });
	}' unless defined(&__BUS_ACCESSOR);
	eval 'sub bus_barrier {
	    my($r, $o, $l, $f) = @_;
    	    eval q( &bus_space_barrier( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($l), ($f)));
	}' unless defined(&bus_barrier);
	eval 'sub bus_read_1 {
	    my($r, $o) = @_;
    	    eval q( &bus_space_read_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o)));
	}' unless defined(&bus_read_1);
	eval 'sub bus_read_multi_1 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_multi_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_multi_1);
	eval 'sub bus_read_region_1 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_region_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_region_1);
	eval 'sub bus_set_multi_1 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_multi_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_multi_1);
	eval 'sub bus_set_region_1 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_region_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_region_1);
	eval 'sub bus_write_1 {
	    my($r, $o, $v) = @_;
    	    eval q( &bus_space_write_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v)));
	}' unless defined(&bus_write_1);
	eval 'sub bus_write_multi_1 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_multi_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_multi_1);
	eval 'sub bus_write_region_1 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_region_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_region_1);
	eval 'sub bus_read_stream_1 {
	    my($r, $o) = @_;
    	    eval q( &bus_space_read_stream_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o)));
	}' unless defined(&bus_read_stream_1);
	eval 'sub bus_read_multi_stream_1 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_multi_stream_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_multi_stream_1);
	eval 'sub bus_read_region_stream_1 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_region_stream_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_region_stream_1);
	eval 'sub bus_set_multi_stream_1 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_multi_stream_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_multi_stream_1);
	eval 'sub bus_set_region_stream_1 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_region_stream_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_region_stream_1);
	eval 'sub bus_write_stream_1 {
	    my($r, $o, $v) = @_;
    	    eval q( &bus_space_write_stream_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v)));
	}' unless defined(&bus_write_stream_1);
	eval 'sub bus_write_multi_stream_1 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_multi_stream_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_multi_stream_1);
	eval 'sub bus_write_region_stream_1 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_region_stream_1( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_region_stream_1);
	eval 'sub bus_read_2 {
	    my($r, $o) = @_;
    	    eval q( &bus_space_read_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o)));
	}' unless defined(&bus_read_2);
	eval 'sub bus_read_multi_2 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_multi_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_multi_2);
	eval 'sub bus_read_region_2 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_region_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_region_2);
	eval 'sub bus_set_multi_2 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_multi_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_multi_2);
	eval 'sub bus_set_region_2 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_region_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_region_2);
	eval 'sub bus_write_2 {
	    my($r, $o, $v) = @_;
    	    eval q( &bus_space_write_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v)));
	}' unless defined(&bus_write_2);
	eval 'sub bus_write_multi_2 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_multi_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_multi_2);
	eval 'sub bus_write_region_2 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_region_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_region_2);
	eval 'sub bus_read_stream_2 {
	    my($r, $o) = @_;
    	    eval q( &bus_space_read_stream_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o)));
	}' unless defined(&bus_read_stream_2);
	eval 'sub bus_read_multi_stream_2 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_multi_stream_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_multi_stream_2);
	eval 'sub bus_read_region_stream_2 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_region_stream_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_region_stream_2);
	eval 'sub bus_set_multi_stream_2 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_multi_stream_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_multi_stream_2);
	eval 'sub bus_set_region_stream_2 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_region_stream_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_region_stream_2);
	eval 'sub bus_write_stream_2 {
	    my($r, $o, $v) = @_;
    	    eval q( &bus_space_write_stream_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v)));
	}' unless defined(&bus_write_stream_2);
	eval 'sub bus_write_multi_stream_2 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_multi_stream_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_multi_stream_2);
	eval 'sub bus_write_region_stream_2 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_region_stream_2( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_region_stream_2);
	eval 'sub bus_read_4 {
	    my($r, $o) = @_;
    	    eval q( &bus_space_read_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o)));
	}' unless defined(&bus_read_4);
	eval 'sub bus_read_multi_4 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_multi_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_multi_4);
	eval 'sub bus_read_region_4 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_region_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_region_4);
	eval 'sub bus_set_multi_4 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_multi_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_multi_4);
	eval 'sub bus_set_region_4 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_region_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_region_4);
	eval 'sub bus_write_4 {
	    my($r, $o, $v) = @_;
    	    eval q( &bus_space_write_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v)));
	}' unless defined(&bus_write_4);
	eval 'sub bus_write_multi_4 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_multi_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_multi_4);
	eval 'sub bus_write_region_4 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_region_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_region_4);
	eval 'sub bus_read_stream_4 {
	    my($r, $o) = @_;
    	    eval q( &bus_space_read_stream_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o)));
	}' unless defined(&bus_read_stream_4);
	eval 'sub bus_read_multi_stream_4 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_multi_stream_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_multi_stream_4);
	eval 'sub bus_read_region_stream_4 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_region_stream_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_region_stream_4);
	eval 'sub bus_set_multi_stream_4 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_multi_stream_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_multi_stream_4);
	eval 'sub bus_set_region_stream_4 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_region_stream_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_region_stream_4);
	eval 'sub bus_write_stream_4 {
	    my($r, $o, $v) = @_;
    	    eval q( &bus_space_write_stream_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v)));
	}' unless defined(&bus_write_stream_4);
	eval 'sub bus_write_multi_stream_4 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_multi_stream_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_multi_stream_4);
	eval 'sub bus_write_region_stream_4 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_region_stream_4( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_region_stream_4);
	eval 'sub bus_read_8 {
	    my($r, $o) = @_;
    	    eval q( &bus_space_read_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o)));
	}' unless defined(&bus_read_8);
	eval 'sub bus_read_multi_8 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_multi_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_multi_8);
	eval 'sub bus_read_region_8 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_region_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_region_8);
	eval 'sub bus_set_multi_8 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_multi_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_multi_8);
	eval 'sub bus_set_region_8 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_region_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_region_8);
	eval 'sub bus_write_8 {
	    my($r, $o, $v) = @_;
    	    eval q( &bus_space_write_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v)));
	}' unless defined(&bus_write_8);
	eval 'sub bus_write_multi_8 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_multi_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_multi_8);
	eval 'sub bus_write_region_8 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_region_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_region_8);
	eval 'sub bus_read_stream_8 {
	    my($r, $o) = @_;
    	    eval q( &bus_space_read_stream_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o)));
	}' unless defined(&bus_read_stream_8);
	eval 'sub bus_read_multi_stream_8 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_multi_stream_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_multi_stream_8);
	eval 'sub bus_read_region_stream_8 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_read_region_stream_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_read_region_stream_8);
	eval 'sub bus_set_multi_stream_8 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_multi_stream_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_multi_stream_8);
	eval 'sub bus_set_region_stream_8 {
	    my($r, $o, $v, $c) = @_;
    	    eval q( &bus_space_set_region_stream_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v), ($c)));
	}' unless defined(&bus_set_region_stream_8);
	eval 'sub bus_write_stream_8 {
	    my($r, $o, $v) = @_;
    	    eval q( &bus_space_write_stream_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($v)));
	}' unless defined(&bus_write_stream_8);
	eval 'sub bus_write_multi_stream_8 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_multi_stream_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_multi_stream_8);
	eval 'sub bus_write_region_stream_8 {
	    my($r, $o, $d, $c) = @_;
    	    eval q( &bus_space_write_region_stream_8( &rman_get_bustag($r),  &rman_get_bushandle($r), ($o), ($d), ($c)));
	}' unless defined(&bus_write_region_stream_8);
    }
}
1;
