require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_CALLOUT_H_)) {
    eval 'sub _SYS_CALLOUT_H_ () {1;}' unless defined(&_SYS_CALLOUT_H_);
    require 'sys/queue.ph';
    eval 'sub CALLOUT_LOCAL_ALLOC () {0x1;}' unless defined(&CALLOUT_LOCAL_ALLOC);
    eval 'sub CALLOUT_ACTIVE () {0x2;}' unless defined(&CALLOUT_ACTIVE);
    eval 'sub CALLOUT_PENDING () {0x4;}' unless defined(&CALLOUT_PENDING);
    eval 'sub CALLOUT_MPSAFE () {0x8;}' unless defined(&CALLOUT_MPSAFE);
    eval 'sub CALLOUT_RETURNUNLOCKED () {0x10;}' unless defined(&CALLOUT_RETURNUNLOCKED);
    if(defined(&_KERNEL)) {
	eval 'sub callout_active {
	    my($c) = @_;
    	    eval q((($c)-> &c_flags &  &CALLOUT_ACTIVE));
	}' unless defined(&callout_active);
	eval 'sub callout_deactivate {
	    my($c) = @_;
    	    eval q((($c)-> &c_flags &= ~ &CALLOUT_ACTIVE));
	}' unless defined(&callout_deactivate);
	eval 'sub callout_drain {
	    my($c) = @_;
    	    eval q( &_callout_stop_safe($c, 1));
	}' unless defined(&callout_drain);
	eval 'sub callout_pending {
	    my($c) = @_;
    	    eval q((($c)-> &c_flags &  &CALLOUT_PENDING));
	}' unless defined(&callout_pending);
	eval 'sub callout_stop {
	    my($c) = @_;
    	    eval q( &_callout_stop_safe($c, 0));
	}' unless defined(&callout_stop);
    }
}
1;
