require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_CONF_H_)) {
    eval 'sub _SYS_CONF_H_ () {1;}' unless defined(&_SYS_CONF_H_);
    if(defined(&_KERNEL)) {
	require 'sys/eventhandler.ph';
    } else {
	require 'sys/queue.ph';
    }
    eval 'sub SI_ALIAS () {0x2;}' unless defined(&SI_ALIAS);
    eval 'sub SI_NAMED () {0x4;}' unless defined(&SI_NAMED);
    eval 'sub SI_CHEAPCLONE () {0x8;}' unless defined(&SI_CHEAPCLONE);
    eval 'sub SI_CHILD () {0x10;}' unless defined(&SI_CHILD);
    eval 'sub SI_DEVOPEN () {0x20;}' unless defined(&SI_DEVOPEN);
    eval 'sub SI_CONSOPEN () {0x40;}' unless defined(&SI_CONSOPEN);
    eval 'sub SI_DUMPDEV () {0x80;}' unless defined(&SI_DUMPDEV);
    eval 'sub SI_CANDELETE () {0x100;}' unless defined(&SI_CANDELETE);
    eval 'sub SI_CLONELIST () {0x200;}' unless defined(&SI_CLONELIST);
    eval 'sub si_tty () { ($__si_u->{__sit_tty});}' unless defined(&si_tty);
    eval 'sub si_snapdata () { ($__si_u->{__sid_snapdata});}' unless defined(&si_snapdata);
    if(defined(&_KERNEL)) {
    }
    eval 'sub D_TAPE () {0x1;}' unless defined(&D_TAPE);
    eval 'sub D_DISK () {0x2;}' unless defined(&D_DISK);
    eval 'sub D_TTY () {0x4;}' unless defined(&D_TTY);
    eval 'sub D_MEM () {0x8;}' unless defined(&D_MEM);
    if(defined(&_KERNEL)) {
	eval 'sub D_TYPEMASK () {0xffff;}' unless defined(&D_TYPEMASK);
	eval 'sub D_MEMDISK () {0x10000;}' unless defined(&D_MEMDISK);
	eval 'sub D_TRACKCLOSE () {0x80000;}' unless defined(&D_TRACKCLOSE);
	eval 'sub D_MMAP_ANON () {0x100000;}' unless defined(&D_MMAP_ANON);
	eval 'sub D_PSEUDO () {0x200000;}' unless defined(&D_PSEUDO);
	eval 'sub D_NEEDGIANT () {0x400000;}' unless defined(&D_NEEDGIANT);
	eval 'sub D_VERSION_00 () {0x20011966;}' unless defined(&D_VERSION_00);
	eval 'sub D_VERSION_01 () {0x17032005;}' unless defined(&D_VERSION_01);
	eval 'sub D_VERSION () { &D_VERSION_01;}' unless defined(&D_VERSION);
	eval 'sub D_INIT () {0x80000000;}' unless defined(&D_INIT);
	eval 'sub NUMCDEVSW () {256;}' unless defined(&NUMCDEVSW);
	eval 'sub MAXMINOR () {0xffff00ff;}' unless defined(&MAXMINOR);
	eval 'sub DEV_MODULE {
	    my($name, $evh, $arg) = @_;
    	    eval q( &static  &moduledata_t $name &_mod = { $name, $evh, $arg };  &DECLARE_MODULE($name, $name &_mod,  &SI_SUB_DRIVERS,  &SI_ORDER_MIDDLE));
	}' unless defined(&DEV_MODULE);
	eval 'sub CLONE_UNITMASK () {0xfffff;}' unless defined(&CLONE_UNITMASK);
	eval 'sub CLONE_FLAG0 () {( &CLONE_UNITMASK + 1);}' unless defined(&CLONE_FLAG0);
	eval 'sub UID_ROOT () {0;}' unless defined(&UID_ROOT);
	eval 'sub UID_BIN () {3;}' unless defined(&UID_BIN);
	eval 'sub UID_UUCP () {66;}' unless defined(&UID_UUCP);
	eval 'sub GID_WHEEL () {0;}' unless defined(&GID_WHEEL);
	eval 'sub GID_KMEM () {2;}' unless defined(&GID_KMEM);
	eval 'sub GID_OPERATOR () {5;}' unless defined(&GID_OPERATOR);
	eval 'sub GID_BIN () {7;}' unless defined(&GID_BIN);
	eval 'sub GID_GAMES () {13;}' unless defined(&GID_GAMES);
	eval 'sub GID_DIALER () {68;}' unless defined(&GID_DIALER);
    }
}
1;
