require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_LOCKMGR_H_)) {
    eval 'sub _SYS_LOCKMGR_H_ () {1;}' unless defined(&_SYS_LOCKMGR_H_);
    if(defined(&DEBUG_LOCKS)) {
	require 'sys/stack.ph';
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    eval 'sub LK_TYPE_MASK () {0xf;}' unless defined(&LK_TYPE_MASK);
    eval 'sub LK_SHARED () {0x1;}' unless defined(&LK_SHARED);
    eval 'sub LK_EXCLUSIVE () {0x2;}' unless defined(&LK_EXCLUSIVE);
    eval 'sub LK_UPGRADE () {0x3;}' unless defined(&LK_UPGRADE);
    eval 'sub LK_EXCLUPGRADE () {0x4;}' unless defined(&LK_EXCLUPGRADE);
    eval 'sub LK_DOWNGRADE () {0x5;}' unless defined(&LK_DOWNGRADE);
    eval 'sub LK_RELEASE () {0x6;}' unless defined(&LK_RELEASE);
    eval 'sub LK_DRAIN () {0x7;}' unless defined(&LK_DRAIN);
    eval 'sub LK_EXCLOTHER () {0x8;}' unless defined(&LK_EXCLOTHER);
    eval 'sub LK_EXTFLG_MASK () {0xff0;}' unless defined(&LK_EXTFLG_MASK);
    eval 'sub LK_NOWAIT () {0x10;}' unless defined(&LK_NOWAIT);
    eval 'sub LK_SLEEPFAIL () {0x20;}' unless defined(&LK_SLEEPFAIL);
    eval 'sub LK_CANRECURSE () {0x40;}' unless defined(&LK_CANRECURSE);
    eval 'sub LK_NOSHARE () {0x80;}' unless defined(&LK_NOSHARE);
    eval 'sub LK_TIMELOCK () {0x100;}' unless defined(&LK_TIMELOCK);
    eval 'sub LK_RETRY () {0x1000;}' unless defined(&LK_RETRY);
    eval 'sub LK_INTERLOCK () {0x2000;}' unless defined(&LK_INTERLOCK);
    eval 'sub LK_WANT_UPGRADE () {0x10000;}' unless defined(&LK_WANT_UPGRADE);
    eval 'sub LK_WANT_EXCL () {0x20000;}' unless defined(&LK_WANT_EXCL);
    eval 'sub LK_HAVE_EXCL () {0x40000;}' unless defined(&LK_HAVE_EXCL);
    eval 'sub LK_WAITDRAIN () {0x80000;}' unless defined(&LK_WAITDRAIN);
    eval 'sub LK_DRAINING () {0x100000;}' unless defined(&LK_DRAINING);
    eval 'sub LK_INTERNAL () {0x200000;}' unless defined(&LK_INTERNAL);
    eval 'sub LK_SHARE_NONZERO () {0x1000000;}' unless defined(&LK_SHARE_NONZERO);
    eval 'sub LK_WAIT_NONZERO () {0x2000000;}' unless defined(&LK_WAIT_NONZERO);
    eval 'sub LK_KERNPROC () {(-2);}' unless defined(&LK_KERNPROC);
    eval 'sub LK_NOPROC () {( -1);}' unless defined(&LK_NOPROC);
    if(defined(&INVARIANTS)) {
	eval 'sub LOCKMGR_ASSERT {
	    my($lkp, $what, $p) = @_;
    	    eval q( &do {  &switch (($what)) {  &case  &LK_SHARED:  &if ( &lockstatus(($lkp), ($p)) ==  &LK_SHARED)  &break;  &case  &LK_EXCLUSIVE:  &if ( &lockstatus(($lkp), ($p)) !=  &LK_EXCLUSIVE)  &panic(\\"lock %s %s not held at %s:%d\\", ($lkp)-> &lk_wmesg, $what,  &__FILE__,  &__LINE__);  &break;  &default:  &panic(\\"unknown LOCKMGR_ASSERT at %s:%d\\",  &__FILE__,  &__LINE__); } }  &while (0));
	}' unless defined(&LOCKMGR_ASSERT);
    } else {
	eval 'sub LOCKMGR_ASSERT {
	    my($lkp, $p, $what) = @_;
    	    eval q();
	}' unless defined(&LOCKMGR_ASSERT);
    }
    if(defined(&DDB)) {
    }
}
1;
