require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PROC_H_)) {
    eval 'sub _SYS_PROC_H_ () {1;}' unless defined(&_SYS_PROC_H_);
    require 'sys/callout.ph';
    require 'sys/event.ph';
    unless(defined(&_KERNEL)) {
	require 'sys/filedesc.ph';
    }
    require 'sys/queue.ph';
    require 'sys/_lock.ph';
    require 'sys/_mutex.ph';
    require 'sys/priority.ph';
    require 'sys/rtprio.ph';
    require 'sys/runq.ph';
    require 'sys/sigio.ph';
    require 'sys/signal.ph';
    unless(defined(&_KERNEL)) {
	require 'sys/time.ph';
    } else {
	require 'sys/pcpu.ph';
    }
    require 'sys/ucontext.ph';
    require 'sys/ucred.ph';
    require 'machine/proc.ph';
    eval 'sub td_startzero () { &td_flags;}' unless defined(&td_startzero);
    eval 'sub td_endzero () { &td_base_pri;}' unless defined(&td_endzero);
    eval 'sub td_startcopy () { &td_endzero;}' unless defined(&td_startcopy);
    eval 'sub td_endcopy () { &td_pcb;}' unless defined(&td_endcopy);
    eval("sub TDS_INACTIVE () { 0x0; }") unless defined(&TDS_INACTIVE);
    eval("sub TDS_INHIBITED () { 1; }") unless defined(&TDS_INHIBITED);
    eval("sub TDS_CAN_RUN () { 2; }") unless defined(&TDS_CAN_RUN);
    eval("sub TDS_RUNQ () { 3; }") unless defined(&TDS_RUNQ);
    eval("sub TDS_RUNNING () { 4; }") unless defined(&TDS_RUNNING);
    eval 'sub TDF_BORROWING () {0x1;}' unless defined(&TDF_BORROWING);
    eval 'sub TDF_INPANIC () {0x2;}' unless defined(&TDF_INPANIC);
    eval 'sub TDF_SINTR () {0x8;}' unless defined(&TDF_SINTR);
    eval 'sub TDF_TIMEOUT () {0x10;}' unless defined(&TDF_TIMEOUT);
    eval 'sub TDF_IDLETD () {0x20;}' unless defined(&TDF_IDLETD);
    eval 'sub TDF_SELECT () {0x40;}' unless defined(&TDF_SELECT);
    eval 'sub TDF_SLEEPABORT () {0x80;}' unless defined(&TDF_SLEEPABORT);
    eval 'sub TDF_TSNOBLOCK () {0x100;}' unless defined(&TDF_TSNOBLOCK);
    eval 'sub TDF_UNUSED9 () {0x200;}' unless defined(&TDF_UNUSED9);
    eval 'sub TDF_BOUNDARY () {0x400;}' unless defined(&TDF_BOUNDARY);
    eval 'sub TDF_ASTPENDING () {0x800;}' unless defined(&TDF_ASTPENDING);
    eval 'sub TDF_TIMOFAIL () {0x1000;}' unless defined(&TDF_TIMOFAIL);
    eval 'sub TDF_INTERRUPT () {0x2000;}' unless defined(&TDF_INTERRUPT);
    eval 'sub TDF_UNUSED14 () {0x4000;}' unless defined(&TDF_UNUSED14);
    eval 'sub TDF_UNUSED15 () {0x8000;}' unless defined(&TDF_UNUSED15);
    eval 'sub TDF_NEEDRESCHED () {0x10000;}' unless defined(&TDF_NEEDRESCHED);
    eval 'sub TDF_NEEDSIGCHK () {0x20000;}' unless defined(&TDF_NEEDSIGCHK);
    eval 'sub TDF_XSIG () {0x40000;}' unless defined(&TDF_XSIG);
    eval 'sub TDF_UMTXQ () {0x80000;}' unless defined(&TDF_UMTXQ);
    eval 'sub TDF_THRWAKEUP () {0x100000;}' unless defined(&TDF_THRWAKEUP);
    eval 'sub TDF_DBSUSPEND () {0x200000;}' unless defined(&TDF_DBSUSPEND);
    eval 'sub TDF_UNUSED22 () {0x400000;}' unless defined(&TDF_UNUSED22);
    eval 'sub TDF_UNUSED23 () {0x800000;}' unless defined(&TDF_UNUSED23);
    eval 'sub TDF_SCHED0 () {0x1000000;}' unless defined(&TDF_SCHED0);
    eval 'sub TDF_SCHED1 () {0x2000000;}' unless defined(&TDF_SCHED1);
    eval 'sub TDF_SCHED2 () {0x4000000;}' unless defined(&TDF_SCHED2);
    eval 'sub TDF_SCHED3 () {0x8000000;}' unless defined(&TDF_SCHED3);
    eval 'sub TDP_OLDMASK () {0x1;}' unless defined(&TDP_OLDMASK);
    eval 'sub TDP_INKTR () {0x2;}' unless defined(&TDP_INKTR);
    eval 'sub TDP_INKTRACE () {0x4;}' unless defined(&TDP_INKTRACE);
    eval 'sub TDP_UPCALLING () {0x8;}' unless defined(&TDP_UPCALLING);
    eval 'sub TDP_COWINPROGRESS () {0x10;}' unless defined(&TDP_COWINPROGRESS);
    eval 'sub TDP_ALTSTACK () {0x20;}' unless defined(&TDP_ALTSTACK);
    eval 'sub TDP_DEADLKTREAT () {0x40;}' unless defined(&TDP_DEADLKTREAT);
    eval 'sub TDP_SA () {0x80;}' unless defined(&TDP_SA);
    eval 'sub TDP_NOSLEEPING () {0x100;}' unless defined(&TDP_NOSLEEPING);
    eval 'sub TDP_OWEUPC () {0x200;}' unless defined(&TDP_OWEUPC);
    eval 'sub TDP_ITHREAD () {0x400;}' unless defined(&TDP_ITHREAD);
    eval 'sub TDP_CAN_UNBIND () {0x800;}' unless defined(&TDP_CAN_UNBIND);
    eval 'sub TDP_SCHED1 () {0x1000;}' unless defined(&TDP_SCHED1);
    eval 'sub TDP_SCHED2 () {0x2000;}' unless defined(&TDP_SCHED2);
    eval 'sub TDP_SCHED3 () {0x4000;}' unless defined(&TDP_SCHED3);
    eval 'sub TDP_SCHED4 () {0x8000;}' unless defined(&TDP_SCHED4);
    eval 'sub TDP_GEOM () {0x10000;}' unless defined(&TDP_GEOM);
    eval 'sub TDP_SOFTDEP () {0x20000;}' unless defined(&TDP_SOFTDEP);
    eval 'sub TDP_NORUNNINGBUF () {0x40000;}' unless defined(&TDP_NORUNNINGBUF);
    eval 'sub TDP_INBDFLUSH () {0x100000;}' unless defined(&TDP_INBDFLUSH);
    eval 'sub TDI_SUSPENDED () {0x1;}' unless defined(&TDI_SUSPENDED);
    eval 'sub TDI_SLEEPING () {0x2;}' unless defined(&TDI_SLEEPING);
    eval 'sub TDI_SWAPPED () {0x4;}' unless defined(&TDI_SWAPPED);
    eval 'sub TDI_LOCK () {0x8;}' unless defined(&TDI_LOCK);
    eval 'sub TDI_IWAIT () {0x10;}' unless defined(&TDI_IWAIT);
    eval 'sub TDK_KSEREL () {0x1;}' unless defined(&TDK_KSEREL);
    eval 'sub TDK_KSERELSIG () {0x2;}' unless defined(&TDK_KSERELSIG);
    eval 'sub TDK_WAKEUP () {0x4;}' unless defined(&TDK_WAKEUP);
    eval 'sub TD_CAN_UNBIND {
        my($td) = @_;
	    eval q(((($td)-> &td_pflags &  &TDP_CAN_UNBIND)  && (($td)-> &td_upcall !=  &NULL)));
    }' unless defined(&TD_CAN_UNBIND);
    eval 'sub TD_IS_SLEEPING {
        my($td) = @_;
	    eval q((($td)-> &td_inhibitors &  &TDI_SLEEPING));
    }' unless defined(&TD_IS_SLEEPING);
    eval 'sub TD_ON_SLEEPQ {
        my($td) = @_;
	    eval q((($td)-> &td_wchan !=  &NULL));
    }' unless defined(&TD_ON_SLEEPQ);
    eval 'sub TD_IS_SUSPENDED {
        my($td) = @_;
	    eval q((($td)-> &td_inhibitors &  &TDI_SUSPENDED));
    }' unless defined(&TD_IS_SUSPENDED);
    eval 'sub TD_IS_SWAPPED {
        my($td) = @_;
	    eval q((($td)-> &td_inhibitors &  &TDI_SWAPPED));
    }' unless defined(&TD_IS_SWAPPED);
    eval 'sub TD_ON_LOCK {
        my($td) = @_;
	    eval q((($td)-> &td_inhibitors &  &TDI_LOCK));
    }' unless defined(&TD_ON_LOCK);
    eval 'sub TD_AWAITING_INTR {
        my($td) = @_;
	    eval q((($td)-> &td_inhibitors &  &TDI_IWAIT));
    }' unless defined(&TD_AWAITING_INTR);
    eval 'sub TD_IS_RUNNING {
        my($td) = @_;
	    eval q((($td)-> &td_state ==  &TDS_RUNNING));
    }' unless defined(&TD_IS_RUNNING);
    eval 'sub TD_ON_RUNQ {
        my($td) = @_;
	    eval q((($td)-> &td_state ==  &TDS_RUNQ));
    }' unless defined(&TD_ON_RUNQ);
    eval 'sub TD_CAN_RUN {
        my($td) = @_;
	    eval q((($td)-> &td_state ==  &TDS_CAN_RUN));
    }' unless defined(&TD_CAN_RUN);
    eval 'sub TD_IS_INHIBITED {
        my($td) = @_;
	    eval q((($td)-> &td_state ==  &TDS_INHIBITED));
    }' unless defined(&TD_IS_INHIBITED);
    eval 'sub TD_SET_INHIB {
        my($td, $inhib) = @_;
	    eval q( &do { ($td)-> &td_state =  &TDS_INHIBITED; ($td)-> &td_inhibitors |= ($inhib); }  &while (0));
    }' unless defined(&TD_SET_INHIB);
    eval 'sub TD_CLR_INHIB {
        my($td, $inhib) = @_;
	    eval q( &do {  &if ((($td)-> &td_inhibitors & ($inhib))  && ((($td)-> &td_inhibitors &= ~($inhib)) == 0)) ($td)-> &td_state =  &TDS_CAN_RUN; }  &while (0));
    }' unless defined(&TD_CLR_INHIB);
    eval 'sub TD_SET_SLEEPING {
        my($td) = @_;
	    eval q( &TD_SET_INHIB(($td),  &TDI_SLEEPING));
    }' unless defined(&TD_SET_SLEEPING);
    eval 'sub TD_SET_SWAPPED {
        my($td) = @_;
	    eval q( &TD_SET_INHIB(($td),  &TDI_SWAPPED));
    }' unless defined(&TD_SET_SWAPPED);
    eval 'sub TD_SET_LOCK {
        my($td) = @_;
	    eval q( &TD_SET_INHIB(($td),  &TDI_LOCK));
    }' unless defined(&TD_SET_LOCK);
    eval 'sub TD_SET_SUSPENDED {
        my($td) = @_;
	    eval q( &TD_SET_INHIB(($td),  &TDI_SUSPENDED));
    }' unless defined(&TD_SET_SUSPENDED);
    eval 'sub TD_SET_IWAIT {
        my($td) = @_;
	    eval q( &TD_SET_INHIB(($td),  &TDI_IWAIT));
    }' unless defined(&TD_SET_IWAIT);
    eval 'sub TD_SET_EXITING {
        my($td) = @_;
	    eval q( &TD_SET_INHIB(($td),  &TDI_EXITING));
    }' unless defined(&TD_SET_EXITING);
    eval 'sub TD_CLR_SLEEPING {
        my($td) = @_;
	    eval q( &TD_CLR_INHIB(($td),  &TDI_SLEEPING));
    }' unless defined(&TD_CLR_SLEEPING);
    eval 'sub TD_CLR_SWAPPED {
        my($td) = @_;
	    eval q( &TD_CLR_INHIB(($td),  &TDI_SWAPPED));
    }' unless defined(&TD_CLR_SWAPPED);
    eval 'sub TD_CLR_LOCK {
        my($td) = @_;
	    eval q( &TD_CLR_INHIB(($td),  &TDI_LOCK));
    }' unless defined(&TD_CLR_LOCK);
    eval 'sub TD_CLR_SUSPENDED {
        my($td) = @_;
	    eval q( &TD_CLR_INHIB(($td),  &TDI_SUSPENDED));
    }' unless defined(&TD_CLR_SUSPENDED);
    eval 'sub TD_CLR_IWAIT {
        my($td) = @_;
	    eval q( &TD_CLR_INHIB(($td),  &TDI_IWAIT));
    }' unless defined(&TD_CLR_IWAIT);
    eval 'sub TD_SET_RUNNING {
        my($td) = @_;
	    eval q(($td)-> &td_state =  &TDS_RUNNING);
    }' unless defined(&TD_SET_RUNNING);
    eval 'sub TD_SET_RUNQ {
        my($td) = @_;
	    eval q(($td)-> &td_state =  &TDS_RUNQ);
    }' unless defined(&TD_SET_RUNQ);
    eval 'sub TD_SET_CAN_RUN {
        my($td) = @_;
	    eval q(($td)-> &td_state =  &TDS_CAN_RUN);
    }' unless defined(&TD_SET_CAN_RUN);
    eval 'sub KUF_DOUPCALL () {0x1;}' unless defined(&KUF_DOUPCALL);
    eval 'sub KUF_EXITING () {0x2;}' unless defined(&KUF_EXITING);
    eval 'sub kg_startzero () { &kg_estcpu;}' unless defined(&kg_startzero);
    eval 'sub kg_endzero () { &kg_pri_class;}' unless defined(&kg_endzero);
    eval 'sub kg_startcopy () { &kg_endzero;}' unless defined(&kg_startcopy);
    eval 'sub kg_endcopy () { &kg_numthreads;}' unless defined(&kg_endcopy);
    eval("sub PRS_NEW () { 0; }") unless defined(&PRS_NEW);
    eval("sub PRS_NORMAL () { 1; }") unless defined(&PRS_NORMAL);
    eval("sub PRS_ZOMBIE () { 2; }") unless defined(&PRS_ZOMBIE);
    eval 'sub p_startzero () { &p_oppid;}' unless defined(&p_startzero);
    eval 'sub p_endzero () { &p_magic;}' unless defined(&p_endzero);
    eval 'sub p_startcopy () { &p_endzero;}' unless defined(&p_startcopy);
    eval 'sub p_endcopy () { &p_xstat;}' unless defined(&p_endcopy);
    eval 'sub p_session () { ($p_pgrp->{pg_session});}' unless defined(&p_session);
    eval 'sub p_pgid () { ($p_pgrp->{pg_id});}' unless defined(&p_pgid);
    eval 'sub NOCPU () {0xff;}' unless defined(&NOCPU);
    eval 'sub P_ADVLOCK () {0x1;}' unless defined(&P_ADVLOCK);
    eval 'sub P_CONTROLT () {0x2;}' unless defined(&P_CONTROLT);
    eval 'sub P_KTHREAD () {0x4;}' unless defined(&P_KTHREAD);
    eval 'sub P_NOLOAD () {0x8;}' unless defined(&P_NOLOAD);
    eval 'sub P_PPWAIT () {0x10;}' unless defined(&P_PPWAIT);
    eval 'sub P_PROFIL () {0x20;}' unless defined(&P_PROFIL);
    eval 'sub P_STOPPROF () {0x40;}' unless defined(&P_STOPPROF);
    eval 'sub P_HADTHREADS () {0x80;}' unless defined(&P_HADTHREADS);
    eval 'sub P_SUGID () {0x100;}' unless defined(&P_SUGID);
    eval 'sub P_SYSTEM () {0x200;}' unless defined(&P_SYSTEM);
    eval 'sub P_SINGLE_EXIT () {0x400;}' unless defined(&P_SINGLE_EXIT);
    eval 'sub P_TRACED () {0x800;}' unless defined(&P_TRACED);
    eval 'sub P_WAITED () {0x1000;}' unless defined(&P_WAITED);
    eval 'sub P_WEXIT () {0x2000;}' unless defined(&P_WEXIT);
    eval 'sub P_EXEC () {0x4000;}' unless defined(&P_EXEC);
    eval 'sub P_SA () {0x8000;}' unless defined(&P_SA);
    eval 'sub P_CONTINUED () {0x10000;}' unless defined(&P_CONTINUED);
    eval 'sub P_STOPPED_SIG () {0x20000;}' unless defined(&P_STOPPED_SIG);
    eval 'sub P_STOPPED_TRACE () {0x40000;}' unless defined(&P_STOPPED_TRACE);
    eval 'sub P_STOPPED_SINGLE () {0x80000;}' unless defined(&P_STOPPED_SINGLE);
    eval 'sub P_PROTECTED () {0x100000;}' unless defined(&P_PROTECTED);
    eval 'sub P_SIGEVENT () {0x200000;}' unless defined(&P_SIGEVENT);
    eval 'sub P_SINGLE_BOUNDARY () {0x400000;}' unless defined(&P_SINGLE_BOUNDARY);
    eval 'sub P_HWPMC () {0x800000;}' unless defined(&P_HWPMC);
    eval 'sub P_JAILED () {0x1000000;}' unless defined(&P_JAILED);
    eval 'sub P_INEXEC () {0x4000000;}' unless defined(&P_INEXEC);
    eval 'sub P_STATCHILD () {0x8000000;}' unless defined(&P_STATCHILD);
    eval 'sub P_STOPPED () {( &P_STOPPED_SIG| &P_STOPPED_SINGLE| &P_STOPPED_TRACE);}' unless defined(&P_STOPPED);
    eval 'sub P_SHOULDSTOP {
        my($p) = @_;
	    eval q((($p)-> &p_flag &  &P_STOPPED));
    }' unless defined(&P_SHOULDSTOP);
    eval 'sub PS_INMEM () {0x1;}' unless defined(&PS_INMEM);
    eval 'sub PS_XCPU () {0x2;}' unless defined(&PS_XCPU);
    eval 'sub PS_ALRMPEND () {0x20;}' unless defined(&PS_ALRMPEND);
    eval 'sub PS_PROFPEND () {0x40;}' unless defined(&PS_PROFPEND);
    eval 'sub PS_SWAPINREQ () {0x100;}' unless defined(&PS_SWAPINREQ);
    eval 'sub PS_SWAPPINGOUT () {0x200;}' unless defined(&PS_SWAPPINGOUT);
    eval 'sub PS_SWAPPINGIN () {0x4000;}' unless defined(&PS_SWAPPINGIN);
    eval 'sub PS_MACPEND () {0x8000;}' unless defined(&PS_MACPEND);
    eval 'sub SIDL () {1;}' unless defined(&SIDL);
    eval 'sub SRUN () {2;}' unless defined(&SRUN);
    eval 'sub SSLEEP () {3;}' unless defined(&SSLEEP);
    eval 'sub SSTOP () {4;}' unless defined(&SSTOP);
    eval 'sub SZOMB () {5;}' unless defined(&SZOMB);
    eval 'sub SWAIT () {6;}' unless defined(&SWAIT);
    eval 'sub SLOCK () {7;}' unless defined(&SLOCK);
    eval 'sub P_MAGIC () {0xbeefface;}' unless defined(&P_MAGIC);
    if(defined(&_KERNEL)) {
	eval 'sub SW_VOL () {0x1;}' unless defined(&SW_VOL);
	eval 'sub SW_INVOL () {0x2;}' unless defined(&SW_INVOL);
	eval 'sub SW_PREEMPT () {0x4;}' unless defined(&SW_PREEMPT);
	eval 'sub SRQ_BORING () {0x;}' unless defined(&SRQ_BORING);
	eval 'sub SRQ_YIELDING () {0x1;}' unless defined(&SRQ_YIELDING);
	eval 'sub SRQ_OURSELF () {0x2;}' unless defined(&SRQ_OURSELF);
	eval 'sub SRQ_INTR () {0x4;}' unless defined(&SRQ_INTR);
	eval 'sub SRQ_PREEMPTED () {0x8;}' unless defined(&SRQ_PREEMPTED);
	eval 'sub SINGLE_NO_EXIT () {0;}' unless defined(&SINGLE_NO_EXIT);
	eval 'sub SINGLE_EXIT () {1;}' unless defined(&SINGLE_EXIT);
	eval 'sub SINGLE_BOUNDARY () {2;}' unless defined(&SINGLE_BOUNDARY);
	if(defined(&MALLOC_DECLARE)) {
	}
	eval 'sub FOREACH_PROC_IN_SYSTEM {
	    my($p) = @_;
    	    eval q( &LIST_FOREACH(($p),  &allproc,  &p_list));
	}' unless defined(&FOREACH_PROC_IN_SYSTEM);
	eval 'sub FOREACH_KSEGRP_IN_PROC {
	    my($p, $kg) = @_;
    	    eval q( &TAILQ_FOREACH(($kg), ($p)-> &p_ksegrps,  &kg_ksegrp));
	}' unless defined(&FOREACH_KSEGRP_IN_PROC);
	eval 'sub FOREACH_THREAD_IN_GROUP {
	    my($kg, $td) = @_;
    	    eval q( &TAILQ_FOREACH(($td), ($kg)-> &kg_threads,  &td_kglist));
	}' unless defined(&FOREACH_THREAD_IN_GROUP);
	eval 'sub FOREACH_UPCALL_IN_GROUP {
	    my($kg, $ku) = @_;
    	    eval q( &TAILQ_FOREACH(($ku), ($kg)-> &kg_upcalls,  &ku_link));
	}' unless defined(&FOREACH_UPCALL_IN_GROUP);
	eval 'sub FOREACH_THREAD_IN_PROC {
	    my($p, $td) = @_;
    	    eval q( &TAILQ_FOREACH(($td), ($p)-> &p_threads,  &td_plist));
	}' unless defined(&FOREACH_THREAD_IN_PROC);
	eval 'sub FIRST_THREAD_IN_PROC {
	    my($p) = @_;
    	    eval q( &TAILQ_FIRST(($p)-> &p_threads));
	}' unless defined(&FIRST_THREAD_IN_PROC);
	eval 'sub FIRST_KSEGRP_IN_PROC {
	    my($p) = @_;
    	    eval q( &TAILQ_FIRST(($p)-> &p_ksegrps));
	}' unless defined(&FIRST_KSEGRP_IN_PROC);
	eval 'sub PID_MAX () {99999;}' unless defined(&PID_MAX);
	eval 'sub NO_PID () {100000;}' unless defined(&NO_PID);
	eval 'sub SESS_LEADER {
	    my($p) = @_;
    	    eval q((($p)-> ($p_session->{s_leader}) == ($p)));
	}' unless defined(&SESS_LEADER);
	eval 'sub SESSHOLD {
	    my($s) = @_;
    	    eval q((($s)-> &s_count++));
	}' unless defined(&SESSHOLD);
	eval 'sub SESSRELE {
	    my($s) = @_;
    	    eval q( &sessrele($s));
	}' unless defined(&SESSRELE);
	eval 'sub STOPEVENT {
	    my($p, $e, $v) = @_;
    	    eval q( &do {  &if (($p)-> &p_stops & ($e)) {  &PROC_LOCK($p);  &stopevent(($p), ($e), ($v));  &PROC_UNLOCK($p); } }  &while (0));
	}' unless defined(&STOPEVENT);
	eval 'sub _STOPEVENT {
	    my($p, $e, $v) = @_;
    	    eval q( &do {  &PROC_LOCK_ASSERT($p,  &MA_OWNED);  &WITNESS_WARN( &WARN_GIANTOK |  &WARN_SLEEPOK,  ($p->{p_mtx}->{mtx_object}), \\"checking stopevent %d\\", ($e));  &if (($p)-> &p_stops & ($e))  &stopevent(($p), ($e), ($v)); }  &while (0));
	}' unless defined(&_STOPEVENT);
	eval 'sub PROC_LOCK {
	    my($p) = @_;
    	    eval q( &mtx_lock(($p)-> &p_mtx));
	}' unless defined(&PROC_LOCK);
	eval 'sub PROC_TRYLOCK {
	    my($p) = @_;
    	    eval q( &mtx_trylock(($p)-> &p_mtx));
	}' unless defined(&PROC_TRYLOCK);
	eval 'sub PROC_UNLOCK {
	    my($p) = @_;
    	    eval q( &mtx_unlock(($p)-> &p_mtx));
	}' unless defined(&PROC_UNLOCK);
	eval 'sub PROC_LOCKED {
	    my($p) = @_;
    	    eval q( &mtx_owned(($p)-> &p_mtx));
	}' unless defined(&PROC_LOCKED);
	eval 'sub PROC_LOCK_ASSERT {
	    my($p, $type) = @_;
    	    eval q( &mtx_assert(($p)-> &p_mtx, ($type)));
	}' unless defined(&PROC_LOCK_ASSERT);
	eval 'sub PGRP_LOCK {
	    my($pg) = @_;
    	    eval q( &mtx_lock(($pg)-> &pg_mtx));
	}' unless defined(&PGRP_LOCK);
	eval 'sub PGRP_UNLOCK {
	    my($pg) = @_;
    	    eval q( &mtx_unlock(($pg)-> &pg_mtx));
	}' unless defined(&PGRP_UNLOCK);
	eval 'sub PGRP_LOCKED {
	    my($pg) = @_;
    	    eval q( &mtx_owned(($pg)-> &pg_mtx));
	}' unless defined(&PGRP_LOCKED);
	eval 'sub PGRP_LOCK_ASSERT {
	    my($pg, $type) = @_;
    	    eval q( &mtx_assert(($pg)-> &pg_mtx, ($type)));
	}' unless defined(&PGRP_LOCK_ASSERT);
	eval 'sub PGRP_LOCK_PGSIGNAL {
	    my($pg) = @_;
    	    eval q( &do {  &if (($pg) !=  &NULL)  &PGRP_LOCK($pg); }  &while (0));
	}' unless defined(&PGRP_LOCK_PGSIGNAL);
	eval 'sub PGRP_UNLOCK_PGSIGNAL {
	    my($pg) = @_;
    	    eval q( &do {  &if (($pg) !=  &NULL)  &PGRP_UNLOCK($pg); }  &while (0));
	}' unless defined(&PGRP_UNLOCK_PGSIGNAL);
	eval 'sub SESS_LOCK {
	    my($s) = @_;
    	    eval q( &mtx_lock(($s)-> &s_mtx));
	}' unless defined(&SESS_LOCK);
	eval 'sub SESS_UNLOCK {
	    my($s) = @_;
    	    eval q( &mtx_unlock(($s)-> &s_mtx));
	}' unless defined(&SESS_UNLOCK);
	eval 'sub SESS_LOCKED {
	    my($s) = @_;
    	    eval q( &mtx_owned(($s)-> &s_mtx));
	}' unless defined(&SESS_LOCKED);
	eval 'sub SESS_LOCK_ASSERT {
	    my($s, $type) = @_;
    	    eval q( &mtx_assert(($s)-> &s_mtx, ($type)));
	}' unless defined(&SESS_LOCK_ASSERT);
	eval 'sub PHOLD {
	    my($p) = @_;
    	    eval q( &do {  &PROC_LOCK($p);  &_PHOLD($p);  &PROC_UNLOCK($p); }  &while (0));
	}' unless defined(&PHOLD);
	eval 'sub _PHOLD {
	    my($p) = @_;
    	    eval q( &do {  &PROC_LOCK_ASSERT(($p),  &MA_OWNED);  &KASSERT(!(($p)-> &p_flag &  &P_WEXIT) || ($p) ==  &curproc, (\\"PHOLD of exiting process\\")); ($p)-> &p_lock++;  &if ((($p)-> &p_sflag &  &PS_INMEM) == 0)  &faultin(($p)); }  &while (0));
	}' unless defined(&_PHOLD);
	eval 'sub PROC_ASSERT_HELD {
	    my($p) = @_;
    	    eval q( &do {  &KASSERT(($p)-> &p_lock > 0, (\\"process not held\\")); }  &while (0));
	}' unless defined(&PROC_ASSERT_HELD);
	eval 'sub PRELE {
	    my($p) = @_;
    	    eval q( &do {  &PROC_LOCK(($p));  &_PRELE(($p));  &PROC_UNLOCK(($p)); }  &while (0));
	}' unless defined(&PRELE);
	eval 'sub _PRELE {
	    my($p) = @_;
    	    eval q( &do {  &PROC_LOCK_ASSERT(($p),  &MA_OWNED); (--($p)-> &p_lock);  &if ((($p)-> &p_flag &  &P_WEXIT)  && ($p)-> &p_lock == 0)  &wakeup(($p)-> &p_lock); }  &while (0));
	}' unless defined(&_PRELE);
	eval 'sub PROC_ASSERT_NOT_HELD {
	    my($p) = @_;
    	    eval q( &do {  &KASSERT(($p)-> &p_lock == 0, (\\"process held\\")); }  &while (0));
	}' unless defined(&PROC_ASSERT_NOT_HELD);
	eval 'sub thread_safetoswapout {
	    my($td) = @_;
    	    eval q(( &TD_IS_SLEEPING($td) ||  &TD_IS_SUSPENDED($td)));
	}' unless defined(&thread_safetoswapout);
	eval 'sub THREAD_NO_SLEEPING () {
	    eval q( &do {  &KASSERT(!( ($curthread->{td_pflags}) &  &TDP_NOSLEEPING), (\\"nested no sleeping\\"));  ($curthread->{td_pflags}) |=  &TDP_NOSLEEPING; }  &while (0));
	}' unless defined(&THREAD_NO_SLEEPING);
	eval 'sub THREAD_SLEEPING_OK () {
	    eval q( &do {  &KASSERT(( ($curthread->{td_pflags}) &  &TDP_NOSLEEPING), (\\"nested sleeping ok\\"));  ($curthread->{td_pflags}) &= ~ &TDP_NOSLEEPING; }  &while (0));
	}' unless defined(&THREAD_SLEEPING_OK);
	eval 'sub PARGS_LOCK {
	    my($p) = @_;
    	    eval q( &mtx_lock( &pargs_ref_lock));
	}' unless defined(&PARGS_LOCK);
	eval 'sub PARGS_UNLOCK {
	    my($p) = @_;
    	    eval q( &mtx_unlock( &pargs_ref_lock));
	}' unless defined(&PARGS_UNLOCK);
	eval 'sub PIDHASH {
	    my($pid) = @_;
    	    eval q(( $pidhashtbl[($pid) &  &pidhash]));
	}' unless defined(&PIDHASH);
	eval 'sub PGRPHASH {
	    my($pgid) = @_;
    	    eval q(( $pgrphashtbl[($pgid) &  &pgrphash]));
	}' unless defined(&PGRPHASH);
    }
}
1;
