require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_RESOURCEVAR_H_)) {
    eval 'sub _SYS_RESOURCEVAR_H_ () {1;}' unless defined(&_SYS_RESOURCEVAR_H_);
    require 'sys/resource.ph';
    require 'sys/queue.ph';
    if(defined(&_KERNEL)) {
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
    }
    eval 'sub pstat_startzero () { &p_ru;}' unless defined(&pstat_startzero);
    eval 'sub pstat_endzero () { &pstat_startcopy;}' unless defined(&pstat_endzero);
    eval 'sub pstat_startcopy () { &p_prof;}' unless defined(&pstat_startcopy);
    eval 'sub pstat_endcopy () { &p_start;}' unless defined(&pstat_endcopy);
    if(defined(&_KERNEL)) {
	eval 'sub LIM_LOCK {
	    my($lim) = @_;
    	    eval q( &mtx_lock(($lim)-> &pl_mtx));
	}' unless defined(&LIM_LOCK);
	eval 'sub LIM_UNLOCK {
	    my($lim) = @_;
    	    eval q( &mtx_unlock(($lim)-> &pl_mtx));
	}' unless defined(&LIM_UNLOCK);
	eval 'sub LIM_LOCK_ASSERT {
	    my($lim, $f) = @_;
    	    eval q( &mtx_assert(($lim)-> &pl_mtx, ($f)));
	}' unless defined(&LIM_LOCK_ASSERT);
	eval 'sub UIDINFO_LOCK {
	    my($ui) = @_;
    	    eval q( &mtx_lock(($ui)-> &ui_mtxp));
	}' unless defined(&UIDINFO_LOCK);
	eval 'sub UIDINFO_UNLOCK {
	    my($ui) = @_;
    	    eval q( &mtx_unlock(($ui)-> &ui_mtxp));
	}' unless defined(&UIDINFO_UNLOCK);
    }
}
1;
