require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SX_H_)) {
    eval 'sub _SYS_SX_H_ () {1;}' unless defined(&_SYS_SX_H_);
    require 'sys/queue.ph';
    require 'sys/_lock.ph';
    require 'sys/condvar.ph';
    if(defined(&_KERNEL)) {
	if(defined( &INVARIANTS) || defined( &INVARIANT_SUPPORT)) {
	}
	if(defined(&DDB)) {
	}
	eval 'sub SX_SYSINIT {
	    my($name, $sxa, $desc) = @_;
    	    eval q( &static \'struct sx_args\' $name &_args = { ($sxa), ($desc) };  &SYSINIT($name &_sx_sysinit,  &SI_SUB_LOCK,  &SI_ORDER_MIDDLE,  &sx_sysinit, $name &_args);  &SYSUNINIT($name &_sx_sysuninit,  &SI_SUB_LOCK,  &SI_ORDER_MIDDLE,  &sx_destroy, ($sxa)));
	}' unless defined(&SX_SYSINIT);
	eval 'sub sx_xlocked {
	    my($sx) = @_;
    	    eval q((($sx)-> &sx_cnt < 0 && ($sx)-> &sx_xholder ==  &curthread));
	}' unless defined(&sx_xlocked);
	eval 'sub sx_slock {
	    my($sx) = @_;
    	    eval q( &_sx_slock(($sx),  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&sx_slock);
	eval 'sub sx_xlock {
	    my($sx) = @_;
    	    eval q( &_sx_xlock(($sx),  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&sx_xlock);
	eval 'sub sx_try_slock {
	    my($sx) = @_;
    	    eval q( &_sx_try_slock(($sx),  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&sx_try_slock);
	eval 'sub sx_try_xlock {
	    my($sx) = @_;
    	    eval q( &_sx_try_xlock(($sx),  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&sx_try_xlock);
	eval 'sub sx_sunlock {
	    my($sx) = @_;
    	    eval q( &_sx_sunlock(($sx),  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&sx_sunlock);
	eval 'sub sx_xunlock {
	    my($sx) = @_;
    	    eval q( &_sx_xunlock(($sx),  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&sx_xunlock);
	eval 'sub sx_try_upgrade {
	    my($sx) = @_;
    	    eval q( &_sx_try_upgrade(($sx),  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&sx_try_upgrade);
	eval 'sub sx_downgrade {
	    my($sx) = @_;
    	    eval q( &_sx_downgrade(($sx),  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&sx_downgrade);
	eval 'sub sx_unlock {
	    my($sx) = @_;
    	    eval q( &do {  &if ( &sx_xlocked($sx))  &sx_xunlock($sx);  &else  &sx_sunlock($sx); }  &while (0));
	}' unless defined(&sx_unlock);
	if(defined( &INVARIANTS) || defined( &INVARIANT_SUPPORT)) {
	    eval 'sub SX_LOCKED () { &LA_LOCKED;}' unless defined(&SX_LOCKED);
	    eval 'sub SX_SLOCKED () { &LA_SLOCKED;}' unless defined(&SX_SLOCKED);
	    eval 'sub SX_XLOCKED () { &LA_XLOCKED;}' unless defined(&SX_XLOCKED);
	    eval 'sub SX_UNLOCKED () { &LA_UNLOCKED;}' unless defined(&SX_UNLOCKED);
	}
	if(defined(&INVARIANTS)) {
	    eval 'sub sx_assert {
	        my($sx, $what) = @_;
    		eval q( &_sx_assert(($sx), ($what),  &LOCK_FILE,  &LOCK_LINE));
	    }' unless defined(&sx_assert);
	} else {
	    eval 'sub sx_assert {
	        my($sx, $what) = @_;
    		eval q();
	    }' unless defined(&sx_assert);
	}
    }
}
1;
