require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_USER_H_)) {
    eval 'sub _SYS_USER_H_ () {1;}' unless defined(&_SYS_USER_H_);
    require 'machine/pcb.ph';
    unless(defined(&_KERNEL)) {
	require 'sys/errno.ph';
	require 'sys/time.ph';
	require 'sys/resource.ph';
	require 'sys/ucred.ph';
	require 'sys/uio.ph';
	require 'sys/queue.ph';
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
	require 'sys/proc.ph';
	require 'vm/vm.ph';
	require 'vm/vm_param.ph';
	require 'vm/pmap.ph';
	require 'vm/vm_map.ph';
    }
    unless(defined(&_SYS_RESOURCEVAR_H_)) {
	require 'sys/resourcevar.ph';
    }
    unless(defined(&_SYS_SIGNALVAR_H_)) {
	require 'sys/signalvar.ph';
    }
    eval 'sub KI_NSPARE_INT () {10;}' unless defined(&KI_NSPARE_INT);
    eval 'sub KI_NSPARE_LONG () {12;}' unless defined(&KI_NSPARE_LONG);
    eval 'sub KI_NSPARE_PTR () {7;}' unless defined(&KI_NSPARE_PTR);
    if(defined(&__alpha__)) {
	eval 'sub KINFO_PROC_SIZE () {1088;}' unless defined(&KINFO_PROC_SIZE);
    }
    if(defined(&__amd64__)) {
	eval 'sub KINFO_PROC_SIZE () {1088;}' unless defined(&KINFO_PROC_SIZE);
    }
    if(defined(&__arm__)) {
	eval 'sub KINFO_PROC_SIZE () {792;}' unless defined(&KINFO_PROC_SIZE);
    }
    if(defined(&__ia64__)) {
	eval 'sub KINFO_PROC_SIZE () {1088;}' unless defined(&KINFO_PROC_SIZE);
    }
    if(defined(&__i386__)) {
	eval 'sub KINFO_PROC_SIZE () {768;}' unless defined(&KINFO_PROC_SIZE);
    }
    if(defined(&__powerpc__)) {
	eval 'sub KINFO_PROC_SIZE () {768;}' unless defined(&KINFO_PROC_SIZE);
    }
    if(defined(&__sparc64__)) {
	eval 'sub KINFO_PROC_SIZE () {1088;}' unless defined(&KINFO_PROC_SIZE);
    }
    unless(defined(&KINFO_PROC_SIZE)) {
	die("Unknown architecture");
    }
    eval 'sub WMESGLEN () {8;}' unless defined(&WMESGLEN);
    eval 'sub LOCKNAMELEN () {8;}' unless defined(&LOCKNAMELEN);
    eval 'sub OCOMMLEN () {16;}' unless defined(&OCOMMLEN);
    eval 'sub COMMLEN () {19;}' unless defined(&COMMLEN);
    eval 'sub KI_EMULNAMELEN () {16;}' unless defined(&KI_EMULNAMELEN);
    eval 'sub KI_NGROUPS () {16;}' unless defined(&KI_NGROUPS);
    eval 'sub LOGNAMELEN () {17;}' unless defined(&LOGNAMELEN);
    eval 'sub ki_childstime () { ($ki_rusage_ch->{ru_stime});}' unless defined(&ki_childstime);
    eval 'sub ki_childutime () { ($ki_rusage_ch->{ru_utime});}' unless defined(&ki_childutime);
    eval 'sub KI_CTTY () {0x1;}' unless defined(&KI_CTTY);
    eval 'sub KI_SLEADER () {0x2;}' unless defined(&KI_SLEADER);
    eval 'sub KI_LOCKBLOCK () {0x4;}' unless defined(&KI_LOCKBLOCK);
}
1;
