<?

class classifieds { 
    var $conn;
    var $sql;
    var $result;
    var $error;
    var $debug = false;
    var $arguments = array();

    function __construct() {
        $this->parseArgs();
        if(is_null($this->arguments["action"])){
            $this->arguments["action"] = "nothing";
        }
        if(!is_null($this->arguments["PHPSESSID"])){
            $_GET["PHPSESSID"]=$this->arguments["PHPSESSID"];
        }
        $this->dbConnect();

    }

    function engine(){
            switch($this->arguments["action"]){
                case 'Post':
                    $this->post();
        
                    echo $this->getMain();                
                    break;
                case 'Register':
                    $this->createuser();
                    $this->getMain(); 
                    break;
                case 'Login':
                    $this->login();
                    echo $this->getMain();
                    break;
                case 'Logout':
                    $this->logout();
                    echo "<script langauge=\"javascript\">window.location.href=\"index.php\";</script>";
                    break;
                default:
                    echo $this->getMain();      
                    break;
        }

        

    }

    
 
    function getMain(){
        $html.="<div id=\"main\">";
        $html.= $this->createUserHTML();
        $html .= $this->getLoginHTML();
        $html .= $this->getContactHTML();
        $html .= $this->postHTML();
        $html .="<div id=\"page\">";
        $html .= $this->getMenu();
        $html .= $this->getClassifieds(10);
        $html .= $this->getFooter();
        $html .= "</div></div>";

        return $html;
    } 
       
    function getMenu(){
        if($_SESSION["userid"]){
        $html = "<table align=center class=\"menu\" width=75%><tr><td onClick=\"show('Post');\"  class=\"menu\" >Post </td><td class=\"menu\" onClick=\"go('Logout','".$_GET["PHPSESSID"]."');\"> Logout </td><td class=\"menu\" onClick=\"show('Contact');\"> Contact </td> </tr></table>";
        
          }else{
        
        $html = "<table align=center class=\"menu\" width=75%><tr><td class=\"menu\" onClick=\"show('Register');\"> Register </td><td class=\"menu\" onClick=\"show('Login');\"> Login </td><td class=\"menu\" onClick=\"show('Contact');\"> Contact</td></tr></table>";

        }

        return $html;


    }

    function getFooter(){
$html .=  "Footer Footer Footer";
    }   

 
    function dbConnect(){
        $connstr = "host=192.168.{{teamid}}.1 dbname=xserver user={{teamid}}_xserver password={{teamid}};
        if($this->conn = pg_connect($connstr)){
            return true;
        }else{
            return false;
        }
    }

 

    function getClassifieds($limit){
        $this->sql = sprintf("select u.username , p.postid,p.date,p.title,p.post from postings p, xs_users u where p.userid = u.userid  ORDER BY p.date DESC   limit %s;",pg_escape_string($limit));
        $this->query();
        $html = "<table class=\"posttable\" cellspacing=1 cellpadding=1 width=75% align=center>";

        while($row = pg_fetch_array($this->result,null,PGSQL_ASSOC)){
        $t =  date("F j, Y, g:i a",$row["date"]);
        $html .= "<tr><td>
                    <table width=100% align=center cellspacing=0 cellpadding=0>

                        <tr><td width=35% class=\"postheaderleft\">".$t."</td>
                            <td class=\"postheaderright\" >".$row["title"]."</td>
                        </tr>
                        <tr><td colspan=3 class=\"post\">".$row["post"]."</td>
                        </tr>
                        <tr>
                            <td class=\"postfooter\" colspan=3>Posted by : ".$row["username"]."</td>

                        </tr>
                    </table>
                   </tr></td>
                    ";
           }
        $html .= "</table>";
        return $html;
        }

    function getContactHTML(){
        
            $html = "<form method=\"GET\" action=\"index.php\"> 
            <div class=\"contactBox\" id=\"Contact\"><table cellspacing=0 cellpadding=0 class=\"blah\"> 
                    <tr><Td colspan=2 class=\"loginHeader\"> .:Contact Info:. </td></tr>
                    <tr>
                     <td> <p>
                    Klassifieds is brought you by kenshoto on rails. </br>
                    This small php app was inspired by people who are looking for there long term partner. </br>
                        The Kenshoto Klassifieds ( Personal add) wasn\'t just made for midgets.</br> It was made for transys , staight , gay , unsure, and all alike. </br>
            Please feel free to post your want add on the page. Make sure to include contact information.</br> 
                    </br><b>
                    IF you have any quetions at all please contact us as  :
                    sysop@putkevinback.org
                    </b>
                    </P>
                    </td> 
                   <tr>
                    <td class=\"loginFooter\">
                    <input type=\"button\" value=\"close\" onClick=\"show('Contact')\">
                    </td>
                    </tr>
                    <input type=\"hidden\" name=\"action\" value=\"Register\">  
               </table>
            </div>
        </form>
        ";
        return $html;
        }    

    function postHTML(){
    
            $html = "<form method=\"GET\" action=\"index.php\"> 
            <div class=\"loginShadow\" id=\"loginShadow\">
            </div>
            <div class=\"loginBox\" id=\"Post\"><table cellspacing=0 cellpadding=0 class=\"blah\"> 
                    <tr><Td colspan=2 class=\"loginHeader\"> .:Post:. </td></tr>
                    <tr>
                        <td class=\"loginBox\"> Title </td><td> <input type=\"text\" name=\"Title\"> </td>
                    </tr>
                    <tr>
                        <td colspan=2><textarea name=\"Post\" cols=50 rows=20></textarea>
                    </tr>
                    <tr><td class=\"loginFooter\" colspan=2> <input type=\"submit\" value=\"Post\">  <input type=\"button\" value=\"Cancel\" onClick=\"show('Post');\"></tr>
                    <input type=\"hidden\" name=\"action\" value=\"Post\">  
                    <input type=\"hidden\" name=\"PHPSESSID\" value=\"".$_GET["PHPSESSID"]."\">
               </table>
            </div>
        </form>
        ";



            return $html;
    }
 
    function post(){
        $userid = $_SESSION["userid"];
        $post = $this->arguments["Post"];
        $title = $this->arguments["Title"];
        $title = urldecode($title);
        $post = urldecode($post);
        $time = time();

        $this->sql = sprintf("insert into postings (UserID, Date ,Title ,Post )  values (%s,%s,'%s','%s')",pg_escape_string($userid),pg_escape_string($time),pg_escape_string($title),pg_escape_string($post));
        $this->query();
        print "Posted  </br>";
    }

    function delClassifiedHTML(){

    }

    function delClassified(){

    }

    function editClassifiedHTML(){

    }

    function editClassified(){

    }


    function query(){
    
    if($this->result = pg_query($this->sql)){
            return true;
        }else{
            echo $this->sql." </br> ".pg_last_error($this->conn);
            return false; 
        }
    }      
    function createUserHTML(){

            $html = "<form method=\"GET\" action=\"index.php\"> 
            <div class=\"loginShadow\"  id=\"loginShadow\"></div>
            <div class=\"loginBox\" id=\"Register\"><table cellspacing=0 cellpadding=0 class=\"blah\"> 
                    <tr><Td colspan=2 class=\"loginHeader\"> .:Register:. </td></tr>
                    <tr>
                        <td> Login </td><td> <input type=\"text\" name=\"username\"> </td>
                    </tr>
                    <tr>
                        <td> Password </td><td><input type=\"password\" name=\"password\"></td>
                    </tr>
                    <tr><td  class=\"loginFooter\" colspan=2> <input type=\"submit\" value=\"Register\"><input type=\"button\" value=\"Cancel\" onClick=\"show('Register');\"></tr>
                    <input type=\"hidden\" name=\"action\" value=\"Register\">  
               </table>
            </div>
            </div>
        </form>
        ";

        return $html;
    } 
    function createUser(){
        $username = $this->arguments["username"];
        $userpassword = $this->arguments["password"];
        if(!$this->userExists($username)){
            echo " User Added!!";
            $password = md5($userpassword);
            $this->sql = sprintf("insert into xs_users (username , password ) values ('%s','%s');",pg_escape_string($username),pg_escape_string($password));
            if($this->query()){
                return true;
            }else{
                print $this->error;
                return false;
            }

       
        }else{
            $this->error = "Sorry can't create user";
            print $this->error;
            return false;
    } 
}
    
    function userExists($username){
        $this->sql = sprintf("select count(username) from xs_users where username = '%s';",pg_escape_string($username));
        echo $this->sql;
        $this->query();
        $row = pg_fetch_row($this->result);
        if($row[0] == 1){    
           return true;
        }else{
            return false;
        }
        
        
    }

    function authUser($username,$password){
        $password = md5($password);
        $this->sql = sprintf("select userid from xs_users where username = '%s' and password = '%s';",pg_escape_string($username),pg_escape_string($password));

        $this->query();
        $rowCount = pg_num_rows($this->result);
        if($rowCount == 1){
        
            $row = pg_fetch_array($this->result);
            $this->userid = $row[0];
            return true ;
        }
        return false;
 
    }
   
    function getLoginHTML(){
    $html ="
            <form method=\"GET\" action=\"index.php\"> 
            <div class=\"loginShadow\" id=\"loginShadow\"></div>
            <div class=\"loginBox\" id=\"Login\"><table cellspacing=0 cellpadding=0 class=\"blah\"> 
                    <tr><Td colspan=2 class=\"loginHeader\"> .:Login:. </td></tr>
                    <tr>
                        <td> Login </td><td> <input type=\"text\" name=\"username\"> </td>
                    </tr>
                    <tr>
                        <td> Password </td><td><input type=\"password\" name=\"password\"></td>
                    </tr>
                    <tr><td  class=\"loginFooter\" colspan=2> <input type=\"submit\" value=\"Login\">  <input type=\"button\" value=\"Cancel\" onClick=\"show('Login');\"></tr>
                    <input type=\"hidden\" name=\"action\" value=\"Login\">  
               </table>
            </div>
            </div>
        </form>
        ";

        return $html;

    }
    

    function login(){
        $username = $this->arguments["username"];
        $password = $this->arguments["password"];
        if($this->authUser($username,$password)){
            $_SESSION["userid"] = $this->userid;   
            echo "User Authed!!";
            return true;
        }else{
            $this->error = "Sorry can't authenticate snatch ";
            return false;
        }
 
    }
        
    function logout(){
        session_destroy();
        return true; 
    }

    function parseArgs(){
        $argsArray = split("&",$_SERVER["argv"][1]);
        foreach ($argsArray as $key => $value){
            $eleArray = split("=",$value);
            $this->arguments[$eleArray[0]] = $eleArray[1];
        }
    }



}


?>
