require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ARCHIVE_H_INCLUDED)) {
    eval 'sub ARCHIVE_H_INCLUDED () {1;}' unless defined(&ARCHIVE_H_INCLUDED);
    require 'sys/types.ph';
    require 'inttypes.ph';
    require 'stdio.ph';
    unless(defined(&_WIN32)) {
	require 'unistd.ph';
    } else {
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub ARCHIVE_LIBRARY_VERSION () {"libarchive 1.9.1";}' unless defined(&ARCHIVE_LIBRARY_VERSION);
    eval 'sub ARCHIVE_API_VERSION () {1;}' unless defined(&ARCHIVE_API_VERSION);
    eval 'sub ARCHIVE_API_FEATURE () {9;}' unless defined(&ARCHIVE_API_FEATURE);
    eval 'sub ARCHIVE_VERSION_STAMP () {1009001;}' unless defined(&ARCHIVE_VERSION_STAMP);
    eval 'sub ARCHIVE_BYTES_PER_RECORD () {512;}' unless defined(&ARCHIVE_BYTES_PER_RECORD);
    eval 'sub ARCHIVE_DEFAULT_BYTES_PER_BLOCK () {10240;}' unless defined(&ARCHIVE_DEFAULT_BYTES_PER_BLOCK);
    eval 'sub ARCHIVE_EOF () {1;}' unless defined(&ARCHIVE_EOF);
    eval 'sub ARCHIVE_OK () {0;}' unless defined(&ARCHIVE_OK);
    eval 'sub ARCHIVE_RETRY () {(-10);}' unless defined(&ARCHIVE_RETRY);
    eval 'sub ARCHIVE_WARN () {(-20);}' unless defined(&ARCHIVE_WARN);
    eval 'sub ARCHIVE_FAILED () {(-25);}' unless defined(&ARCHIVE_FAILED);
    eval 'sub ARCHIVE_FATAL () {(-30);}' unless defined(&ARCHIVE_FATAL);
    if((defined(&ARCHIVE_API_VERSION) ? &ARCHIVE_API_VERSION : 0) < 2) {
    } else {
    }
    eval 'sub ARCHIVE_COMPRESSION_NONE () {0;}' unless defined(&ARCHIVE_COMPRESSION_NONE);
    eval 'sub ARCHIVE_COMPRESSION_GZIP () {1;}' unless defined(&ARCHIVE_COMPRESSION_GZIP);
    eval 'sub ARCHIVE_COMPRESSION_BZIP2 () {2;}' unless defined(&ARCHIVE_COMPRESSION_BZIP2);
    eval 'sub ARCHIVE_COMPRESSION_COMPRESS () {3;}' unless defined(&ARCHIVE_COMPRESSION_COMPRESS);
    eval 'sub ARCHIVE_COMPRESSION_PROGRAM () {4;}' unless defined(&ARCHIVE_COMPRESSION_PROGRAM);
    eval 'sub ARCHIVE_FORMAT_BASE_MASK () {0xff0000;}' unless defined(&ARCHIVE_FORMAT_BASE_MASK);
    eval 'sub ARCHIVE_FORMAT_CPIO () {0x10000;}' unless defined(&ARCHIVE_FORMAT_CPIO);
    eval 'sub ARCHIVE_FORMAT_CPIO_POSIX () {( &ARCHIVE_FORMAT_CPIO | 1);}' unless defined(&ARCHIVE_FORMAT_CPIO_POSIX);
    eval 'sub ARCHIVE_FORMAT_CPIO_BIN_LE () {( &ARCHIVE_FORMAT_CPIO | 2);}' unless defined(&ARCHIVE_FORMAT_CPIO_BIN_LE);
    eval 'sub ARCHIVE_FORMAT_CPIO_BIN_BE () {( &ARCHIVE_FORMAT_CPIO | 3);}' unless defined(&ARCHIVE_FORMAT_CPIO_BIN_BE);
    eval 'sub ARCHIVE_FORMAT_CPIO_SVR4_NOCRC () {( &ARCHIVE_FORMAT_CPIO | 4);}' unless defined(&ARCHIVE_FORMAT_CPIO_SVR4_NOCRC);
    eval 'sub ARCHIVE_FORMAT_CPIO_SVR4_CRC () {( &ARCHIVE_FORMAT_CPIO | 5);}' unless defined(&ARCHIVE_FORMAT_CPIO_SVR4_CRC);
    eval 'sub ARCHIVE_FORMAT_SHAR () {0x20000;}' unless defined(&ARCHIVE_FORMAT_SHAR);
    eval 'sub ARCHIVE_FORMAT_SHAR_BASE () {( &ARCHIVE_FORMAT_SHAR | 1);}' unless defined(&ARCHIVE_FORMAT_SHAR_BASE);
    eval 'sub ARCHIVE_FORMAT_SHAR_DUMP () {( &ARCHIVE_FORMAT_SHAR | 2);}' unless defined(&ARCHIVE_FORMAT_SHAR_DUMP);
    eval 'sub ARCHIVE_FORMAT_TAR () {0x30000;}' unless defined(&ARCHIVE_FORMAT_TAR);
    eval 'sub ARCHIVE_FORMAT_TAR_USTAR () {( &ARCHIVE_FORMAT_TAR | 1);}' unless defined(&ARCHIVE_FORMAT_TAR_USTAR);
    eval 'sub ARCHIVE_FORMAT_TAR_PAX_INTERCHANGE () {( &ARCHIVE_FORMAT_TAR | 2);}' unless defined(&ARCHIVE_FORMAT_TAR_PAX_INTERCHANGE);
    eval 'sub ARCHIVE_FORMAT_TAR_PAX_RESTRICTED () {( &ARCHIVE_FORMAT_TAR | 3);}' unless defined(&ARCHIVE_FORMAT_TAR_PAX_RESTRICTED);
    eval 'sub ARCHIVE_FORMAT_TAR_GNUTAR () {( &ARCHIVE_FORMAT_TAR | 4);}' unless defined(&ARCHIVE_FORMAT_TAR_GNUTAR);
    eval 'sub ARCHIVE_FORMAT_ISO9660 () {0x40000;}' unless defined(&ARCHIVE_FORMAT_ISO9660);
    eval 'sub ARCHIVE_FORMAT_ISO9660_ROCKRIDGE () {( &ARCHIVE_FORMAT_ISO9660 | 1);}' unless defined(&ARCHIVE_FORMAT_ISO9660_ROCKRIDGE);
    eval 'sub ARCHIVE_FORMAT_ZIP () {0x50000;}' unless defined(&ARCHIVE_FORMAT_ZIP);
    eval 'sub ARCHIVE_FORMAT_EMPTY () {0x60000;}' unless defined(&ARCHIVE_FORMAT_EMPTY);
    eval 'sub ARCHIVE_FORMAT_AR () {0x70000;}' unless defined(&ARCHIVE_FORMAT_AR);
    eval 'sub ARCHIVE_FORMAT_AR_GNU () {( &ARCHIVE_FORMAT_AR | 1);}' unless defined(&ARCHIVE_FORMAT_AR_GNU);
    eval 'sub ARCHIVE_FORMAT_AR_BSD () {( &ARCHIVE_FORMAT_AR | 2);}' unless defined(&ARCHIVE_FORMAT_AR_BSD);
    eval 'sub ARCHIVE_EXTRACT_OWNER () {(1);}' unless defined(&ARCHIVE_EXTRACT_OWNER);
    eval 'sub ARCHIVE_EXTRACT_PERM () {(2);}' unless defined(&ARCHIVE_EXTRACT_PERM);
    eval 'sub ARCHIVE_EXTRACT_TIME () {(4);}' unless defined(&ARCHIVE_EXTRACT_TIME);
    eval 'sub ARCHIVE_EXTRACT_NO_OVERWRITE () {(8);}' unless defined(&ARCHIVE_EXTRACT_NO_OVERWRITE);
    eval 'sub ARCHIVE_EXTRACT_UNLINK () {(16);}' unless defined(&ARCHIVE_EXTRACT_UNLINK);
    eval 'sub ARCHIVE_EXTRACT_ACL () {(32);}' unless defined(&ARCHIVE_EXTRACT_ACL);
    eval 'sub ARCHIVE_EXTRACT_FFLAGS () {(64);}' unless defined(&ARCHIVE_EXTRACT_FFLAGS);
    eval 'sub ARCHIVE_EXTRACT_XATTR () {(128);}' unless defined(&ARCHIVE_EXTRACT_XATTR);
    eval 'sub ARCHIVE_EXTRACT_SECURE_SYMLINKS () {(256);}' unless defined(&ARCHIVE_EXTRACT_SECURE_SYMLINKS);
    eval 'sub ARCHIVE_EXTRACT_SECURE_NODOTDOT () {(512);}' unless defined(&ARCHIVE_EXTRACT_SECURE_NODOTDOT);
    eval 'sub ARCHIVE_EXTRACT_NO_AUTODIR () {(1024);}' unless defined(&ARCHIVE_EXTRACT_NO_AUTODIR);
    eval 'sub ARCHIVE_EXTRACT_NO_OVERWRITE_NEWER () {(2048);}' unless defined(&ARCHIVE_EXTRACT_NO_OVERWRITE_NEWER);
    if((defined(&ARCHIVE_API_VERSION) ? &ARCHIVE_API_VERSION : 0) > 1) {
    } else {
    }
    if((defined(&ARCHIVE_API_VERSION) ? &ARCHIVE_API_VERSION : 0) > 1) {
    } else {
    }
    if((defined(&ARCHIVE_API_VERSION) ? &ARCHIVE_API_VERSION : 0) > 1) {
    } else {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
