require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_BLUETOOTH_H_)) {
    eval 'sub _BLUETOOTH_H_ () {1;}' unless defined(&_BLUETOOTH_H_);
    require 'sys/types.ph';
    require 'sys/bitstring.ph';
    require 'sys/endian.ph';
    require 'sys/socket.ph';
    require 'sys/un.ph';
    require 'netdb.ph';
    require 'netgraph/bluetooth/include/ng_hci.ph';
    require 'netgraph/bluetooth/include/ng_l2cap.ph';
    require 'netgraph/bluetooth/include/ng_btsocket.ph';
    eval 'sub bacmp {
        my($ba1, $ba2) = @_;
	    eval q( &memcmp(($ba1), ($ba2), $sizeof{ &bdaddr_t}));
    }' unless defined(&bacmp);
    eval 'sub bacpy {
        my($dst, $src) = @_;
	    eval q( &memcpy(($dst), ($src), $sizeof{ &bdaddr_t}));
    }' unless defined(&bacpy);
    eval 'sub ba2str {
        my($ba, $str) = @_;
	    eval q( &bt_ntoa(($ba), ($str)));
    }' unless defined(&ba2str);
    eval 'sub str2ba {
        my($str, $ba) = @_;
	    eval q(( &bt_aton(($str), ($ba)) == 1? 0: -1));
    }' unless defined(&str2ba);
}
1;
