require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MACHINE_CPU_H_)) {
    eval 'sub _MACHINE_CPU_H_ () {1;}' unless defined(&_MACHINE_CPU_H_);
    require 'machine/psl.ph';
    require 'machine/frame.ph';
    require 'machine/segments.ph';
    undef(&COPY_SIGCODE) if defined(&COPY_SIGCODE);
    eval 'sub cpu_exec {
        my($p) = @_;
	    eval q();
    }' unless defined(&cpu_exec);
    eval 'sub cpu_swapin {
        my($p) = @_;
	    eval q();
    }' unless defined(&cpu_swapin);
    eval 'sub cpu_getstack {
        my($td) = @_;
	    eval q((($td)-> ($td_frame->{tf_esp})));
    }' unless defined(&cpu_getstack);
    eval 'sub cpu_setstack {
        my($td, $ap) = @_;
	    eval q((($td)-> ($td_frame->{tf_esp}) = ($ap)));
    }' unless defined(&cpu_setstack);
    eval 'sub cpu_spinwait () {
        eval q( &ia32_pause());
    }' unless defined(&cpu_spinwait);
    eval 'sub TRAPF_USERMODE {
        my($framep) = @_;
	    eval q((( &ISPL(($framep)-> &tf_cs) ==  &SEL_UPL) || (($framep)-> &tf_eflags &  &PSL_VM)));
    }' unless defined(&TRAPF_USERMODE);
    eval 'sub TRAPF_PC {
        my($framep) = @_;
	    eval q((($framep)-> &tf_eip));
    }' unless defined(&TRAPF_PC);
    eval 'sub CLKF_USERMODE {
        my($framep) = @_;
	    eval q((( &ISPL(($framep)-> &cf_cs) ==  &SEL_UPL) || (($framep)-> &cf_eflags &  &PSL_VM)));
    }' unless defined(&CLKF_USERMODE);
    eval 'sub CLKF_PC {
        my($framep) = @_;
	    eval q((($framep)-> &cf_eip));
    }' unless defined(&CLKF_PC);
    eval 'sub CPU_CONSDEV () {1;}' unless defined(&CPU_CONSDEV);
    eval 'sub CPU_ADJKERNTZ () {2;}' unless defined(&CPU_ADJKERNTZ);
    eval 'sub CPU_DISRTCSET () {3;}' unless defined(&CPU_DISRTCSET);
    eval 'sub CPU_BOOTINFO () {4;}' unless defined(&CPU_BOOTINFO);
    eval 'sub CPU_WALLCLOCK () {5;}' unless defined(&CPU_WALLCLOCK);
    eval 'sub CPU_MAXID () {6;}' unless defined(&CPU_MAXID);
    eval 'sub CTL_MACHDEP_NAMES () {{ { 0, 0}, { "console_device",  &CTLTYPE_STRUCT }, { "adjkerntz",  &CTLTYPE_INT }, { "disable_rtc_set",  &CTLTYPE_INT }, { "bootinfo",  &CTLTYPE_STRUCT }, { "wall_cmos_clock",  &CTLTYPE_INT }, };}' unless defined(&CTL_MACHDEP_NAMES);
    if(defined(&_KERNEL)) {
	if(defined( &I486_CPU) || defined( &KLD_MODULE)) {
	}
    }
}
1;
