require '_h2ph_pre.ph';

no warnings 'redefine';

if(!defined (defined(&DO_I4B_DEBUG) ? &DO_I4B_DEBUG : 0)) {
    eval 'sub DO_I4B_DEBUG () {1;}' unless defined(&DO_I4B_DEBUG);
}
 elsif((defined(&DO_I4B_DEBUG) ? &DO_I4B_DEBUG : 0) != 0) {
    undef(&DO_I4B_DEBUG) if defined(&DO_I4B_DEBUG);
    eval 'sub DO_I4B_DEBUG () {1;}' unless defined(&DO_I4B_DEBUG);
}
undef(&DO_I4B_MAXDEBUG) if defined(&DO_I4B_MAXDEBUG);
if((defined(&DO_I4B_DEBUG) ? &DO_I4B_DEBUG : 0)) {
    eval 'sub NDBGL1 () {( &bits,  &fmt,  &args...)  &if( &bits &  &i4b_l1_debug) {  &printf("i4b-L1 %s: "  &fmt "\\n",  &__func__ ,  &args ); };}' unless defined(&NDBGL1);
    eval 'sub NDBGL2 () {( &bits,  &fmt,  &args...)  &if( &bits &  &i4b_l2_debug) {  &printf("i4b-L2 %s: "  &fmt "\\n",  &__func__ ,  &args ); };}' unless defined(&NDBGL2);
    eval 'sub NDBGL3 () {( &bits,  &fmt,  &args...)  &if( &bits &  &i4b_l3_debug) {  &printf("i4b-L3 %s: "  &fmt "\\n",  &__func__ ,  &args ); };}' unless defined(&NDBGL3);
    eval 'sub NDBGL4 () {( &bits,  &fmt,  &args...)  &if( &bits &  &i4b_l4_debug) {  &printf("i4b-L4 %s: "  &fmt "\\n",  &__func__ ,  &args ); };}' unless defined(&NDBGL4);
} else {
    eval 'sub NDBGL1 () {( &bits,  &fmt,  &args...);;}' unless defined(&NDBGL1);
    eval 'sub NDBGL2 () {( &bits,  &fmt,  &args...);;}' unless defined(&NDBGL2);
    eval 'sub NDBGL3 () {( &bits,  &fmt,  &args...);;}' unless defined(&NDBGL3);
    eval 'sub NDBGL4 () {( &bits,  &fmt,  &args...);;}' unless defined(&NDBGL4);
}
unless(defined(&L1_ERROR)) {
    sub L1_ERROR () {	0x1;}
}
unless(defined(&L1_PRIM)) {
    sub L1_PRIM () {	0x2;}
}
unless(defined(&L1_BCHAN)) {
    sub L1_BCHAN () {	0x4;}
}
unless(defined(&L1_H_ERR)) {
    sub L1_H_ERR () {	0x8;}
}
unless(defined(&L1_H_IRQ)) {
    sub L1_H_IRQ () {	0x10;}
}
unless(defined(&L1_I_ERR)) {
    sub L1_I_ERR () {	0x20;}
}
unless(defined(&L1_I_MSG)) {
    sub L1_I_MSG () {	0x40;}
}
unless(defined(&L1_I_SETUP)) {
    sub L1_I_SETUP () {	0x80;}
}
unless(defined(&L1_F_MSG)) {
    sub L1_F_MSG () {	0x100;}
}
unless(defined(&L1_F_ERR)) {
    sub L1_F_ERR () {	0x200;}
}
unless(defined(&L1_T_MSG)) {
    sub L1_T_MSG () {	0x400;}
}
unless(defined(&L1_T_ERR)) {
    sub L1_T_ERR () {	0x800;}
}
unless(defined(&L1_H_XFRERR)) {
    sub L1_H_XFRERR () {	0x1000;}
}
unless(defined(&L1_I_CICO)) {
    sub L1_I_CICO () {	0x2000;}
}
unless(defined(&L1_S_MSG)) {
    sub L1_S_MSG () {	0x4000;}
}
unless(defined(&L1_S_ERR)) {
    sub L1_S_ERR () {	0x8000;}
}
unless(defined(&L1_HFC_DBG)) {
    sub L1_HFC_DBG () {	0x10000;}
}
unless(defined(&L1_DEBUG_MAX)) {
    sub L1_DEBUG_MAX () {	0x1ffef;}
}
unless(defined(&L1_DEBUG_ERR)) {
    sub L1_DEBUG_ERR () {	( &L1_S_ERR |  &L1_H_ERR |  &L1_I_ERR |  &L1_F_ERR |  &L1_T_ERR |  &L1_ERROR);}
}
unless(defined(&L1_DEBUG_DEFAULT)) {
    if(defined(&DO_I4B_MAXDEBUG)) {
	eval 'sub L1_DEBUG_DEFAULT () { &L1_DEBUG_MAX;}' unless defined(&L1_DEBUG_DEFAULT);
    } else {
	eval 'sub L1_DEBUG_DEFAULT () { &L1_DEBUG_ERR;}' unless defined(&L1_DEBUG_DEFAULT);
    }
}
unless(defined(&L2_ERROR)) {
    sub L2_ERROR () {	0x1;}
}
unless(defined(&L2_PRIM)) {
    sub L2_PRIM () {	0x2;}
}
unless(defined(&L2_U_MSG)) {
    sub L2_U_MSG () {	0x4;}
}
unless(defined(&L2_U_ERR)) {
    sub L2_U_ERR () {	0x8;}
}
unless(defined(&L2_S_MSG)) {
    sub L2_S_MSG () {	0x10;}
}
unless(defined(&L2_S_ERR)) {
    sub L2_S_ERR () {	0x20;}
}
unless(defined(&L2_I_MSG)) {
    sub L2_I_MSG () {	0x40;}
}
unless(defined(&L2_I_ERR)) {
    sub L2_I_ERR () {	0x80;}
}
unless(defined(&L2_F_MSG)) {
    sub L2_F_MSG () {	0x100;}
}
unless(defined(&L2_F_ERR)) {
    sub L2_F_ERR () {	0x200;}
}
unless(defined(&L2_T_MSG)) {
    sub L2_T_MSG () {	0x400;}
}
unless(defined(&L2_T_ERR)) {
    sub L2_T_ERR () {	0x800;}
}
unless(defined(&L2_TEI_MSG)) {
    sub L2_TEI_MSG () {	0x1000;}
}
unless(defined(&L2_TEI_ERR)) {
    sub L2_TEI_ERR () {	0x2000;}
}
unless(defined(&L2_DEBUG_MAX)) {
    sub L2_DEBUG_MAX () {	0x3fff;}
}
unless(defined(&L2_DEBUG_ERR)) {
    sub L2_DEBUG_ERR () {	( &L2_ERROR |  &L2_I_ERR |  &L2_F_ERR |  &L2_T_ERR |  &L2_S_ERR |  &L2_TEI_ERR |  &L2_U_ERR );}
}
unless(defined(&L2_DEBUG_DEFAULT)) {
    if(defined(&DO_I4B_MAXDEBUG)) {
	eval 'sub L2_DEBUG_DEFAULT () { &L2_DEBUG_MAX;}' unless defined(&L2_DEBUG_DEFAULT);
    } else {
	eval 'sub L2_DEBUG_DEFAULT () { &L2_DEBUG_ERR;}' unless defined(&L2_DEBUG_DEFAULT);
    }
}
unless(defined(&L3_ERR)) {
    sub L3_ERR () {	0x1;}
}
unless(defined(&L3_MSG)) {
    sub L3_MSG () {	0x2;}
}
unless(defined(&L3_F_MSG)) {
    sub L3_F_MSG () {	0x4;}
}
unless(defined(&L3_F_ERR)) {
    sub L3_F_ERR () {	0x8;}
}
unless(defined(&L3_T_MSG)) {
    sub L3_T_MSG () {	0x10;}
}
unless(defined(&L3_T_ERR)) {
    sub L3_T_ERR () {	0x20;}
}
unless(defined(&L3_P_MSG)) {
    sub L3_P_MSG () {	0x40;}
}
unless(defined(&L3_P_ERR)) {
    sub L3_P_ERR () {	0x80;}
}
unless(defined(&L3_A_MSG)) {
    sub L3_A_MSG () {	0x100;}
}
unless(defined(&L3_A_ERR)) {
    sub L3_A_ERR () {	0x200;}
}
unless(defined(&L3_PRIM)) {
    sub L3_PRIM () {	0x400;}
}
unless(defined(&L3_DEBUG_MAX)) {
    sub L3_DEBUG_MAX () {	0x7ff;}
}
unless(defined(&L3_DEBUG_ERR)) {
    sub L3_DEBUG_ERR () {	( &L3_ERR |  &L3_F_ERR |  &L3_T_ERR |  &L3_P_ERR |  &L3_A_ERR);}
}
unless(defined(&L3_DEBUG_DEFAULT)) {
    if(defined(&DO_I4B_MAXDEBUG)) {
	eval 'sub L3_DEBUG_DEFAULT () { &L3_DEBUG_MAX;}' unless defined(&L3_DEBUG_DEFAULT);
    } else {
	eval 'sub L3_DEBUG_DEFAULT () { &L3_DEBUG_ERR;}' unless defined(&L3_DEBUG_DEFAULT);
    }
}
unless(defined(&L4_ERR)) {
    sub L4_ERR () {	0x1;}
}
unless(defined(&L4_MSG)) {
    sub L4_MSG () {	0x2;}
}
unless(defined(&L4_TIMO)) {
    sub L4_TIMO () {	0x4;}
}
unless(defined(&L4_DIALST)) {
    sub L4_DIALST () {	0x8;}
}
unless(defined(&L4_IPRDBG)) {
    sub L4_IPRDBG () {	0x10;}
}
unless(defined(&L4_RBCHDBG)) {
    sub L4_RBCHDBG () {	0x20;}
}
unless(defined(&L4_ISPDBG)) {
    sub L4_ISPDBG () {	0x40;}
}
unless(defined(&L4_TELDBG)) {
    sub L4_TELDBG () {	0x80;}
}
unless(defined(&L4_INGDBG)) {
    sub L4_INGDBG () {	0x100;}
}
unless(defined(&L4_IAVCDBG)) {
    sub L4_IAVCDBG () {	0x200;}
}
unless(defined(&L4_CAPIDBG)) {
    sub L4_CAPIDBG () {	0x400;}
}
unless(defined(&L4_DEBUG_MAX)) {
    sub L4_DEBUG_MAX () {	0xfff;}
}
unless(defined(&L4_DEBUG_ERR)) {
    sub L4_DEBUG_ERR () {	 &L4_ERR;}
}
unless(defined(&L4_DEBUG_DEFAULT)) {
    if(defined(&DO_I4B_MAXDEBUG)) {
	eval 'sub L4_DEBUG_DEFAULT () { &L4_DEBUG_MAX;}' unless defined(&L4_DEBUG_DEFAULT);
    } else {
	eval 'sub L4_DEBUG_DEFAULT () { &L4_DEBUG_ERR;}' unless defined(&L4_DEBUG_DEFAULT);
    }
}
unless(defined(&I4B_CTL_GET_DEBUG)) {
    sub I4B_CTL_GET_DEBUG () {	 &_IOR(ord('C'), 0,  &ctl_debug_t);}
}
unless(defined(&I4B_CTL_SET_DEBUG)) {
    sub I4B_CTL_SET_DEBUG () {	 &_IOW(ord('C'), 1,  &ctl_debug_t);}
}
unless(defined(&I4B_CTL_GET_CHIPSTAT)) {
    sub I4B_CTL_GET_CHIPSTAT () {	 &_IOWR(ord('C'), 2, 'struct chipstat');}
}
unless(defined(&I4B_CTL_CLR_CHIPSTAT)) {
    sub I4B_CTL_CLR_CHIPSTAT () {	 &_IOW(ord('C'), 3, 'struct chipstat');}
}
unless(defined(&I4B_CTL_GET_LAPDSTAT)) {
    sub I4B_CTL_GET_LAPDSTAT () {	 &_IOWR(ord('C'), 4,  &l2stat_t);}
}
unless(defined(&I4B_CTL_CLR_LAPDSTAT)) {
    sub I4B_CTL_CLR_LAPDSTAT () {	 &_IOW(ord('C'), 5, 'int');}
}
1;
