require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MACHINE_IEEEFP_H_)) {
    eval 'sub _MACHINE_IEEEFP_H_ () {1;}' unless defined(&_MACHINE_IEEEFP_H_);
    unless(defined(&_SYS_CDEFS_H_)) {
	die("this\ file\ needs\ sys\/cdefs\.h\ as\ a\ prerequisite");
    }
    eval("sub FP_RN () { 0; }") unless defined(&FP_RN);
    eval("sub FP_RM () { 1; }") unless defined(&FP_RM);
    eval("sub FP_RP () { 2; }") unless defined(&FP_RP);
    eval("sub FP_RZ () { 3; }") unless defined(&FP_RZ);
    eval("sub FP_PS () { 0; }") unless defined(&FP_PS);
    eval("sub FP_PRS () { 1; }") unless defined(&FP_PRS);
    eval("sub FP_PD () { 2; }") unless defined(&FP_PD);
    eval("sub FP_PE () { 3; }") unless defined(&FP_PE);
    eval 'sub fp_except_t () {\'int\';}' unless defined(&fp_except_t);
    eval 'sub FP_X_INV () {0x1;}' unless defined(&FP_X_INV);
    eval 'sub FP_X_DNML () {0x2;}' unless defined(&FP_X_DNML);
    eval 'sub FP_X_DZ () {0x4;}' unless defined(&FP_X_DZ);
    eval 'sub FP_X_OFL () {0x8;}' unless defined(&FP_X_OFL);
    eval 'sub FP_X_UFL () {0x10;}' unless defined(&FP_X_UFL);
    eval 'sub FP_X_IMP () {0x20;}' unless defined(&FP_X_IMP);
    eval 'sub FP_X_STK () {0x40;}' unless defined(&FP_X_STK);
    eval 'sub FP_MSKS_REG () {0;}' unless defined(&FP_MSKS_REG);
    eval 'sub FP_PRC_REG () {0;}' unless defined(&FP_PRC_REG);
    eval 'sub FP_RND_REG () {0;}' unless defined(&FP_RND_REG);
    eval 'sub FP_STKY_REG () {1;}' unless defined(&FP_STKY_REG);
    eval 'sub FP_MSKS_FLD () {0x3f;}' unless defined(&FP_MSKS_FLD);
    eval 'sub FP_PRC_FLD () {0x300;}' unless defined(&FP_PRC_FLD);
    eval 'sub FP_RND_FLD () {0xc00;}' unless defined(&FP_RND_FLD);
    eval 'sub FP_STKY_FLD () {0x3f;}' unless defined(&FP_STKY_FLD);
    eval 'sub FP_MSKS_OFF () {0;}' unless defined(&FP_MSKS_OFF);
    eval 'sub FP_PRC_OFF () {8;}' unless defined(&FP_PRC_OFF);
    eval 'sub FP_RND_OFF () {10;}' unless defined(&FP_RND_OFF);
    eval 'sub FP_STKY_OFF () {0;}' unless defined(&FP_STKY_OFF);
    if(defined(&__GNUCLIKE_ASM)) {
	eval 'sub __fldenv {
	    my($addr) = @_;
    	    eval q( &__asm  &__volatile(\\"fldenv %0\\" : : \\"m\\" (*($addr))));
	}' unless defined(&__fldenv);
	eval 'sub __fnstenv {
	    my($addr) = @_;
    	    eval q( &__asm  &__volatile(\\"fnstenv %0\\" : \\"=m\\" (*($addr))));
	}' unless defined(&__fnstenv);
	eval 'sub __fnstcw {
	    my($addr) = @_;
    	    eval q( &__asm  &__volatile(\\"fnstcw %0\\" : \\"=m\\" (*($addr))));
	}' unless defined(&__fnstcw);
	eval 'sub __fnstsw {
	    my($addr) = @_;
    	    eval q( &__asm  &__volatile(\\"fnstsw %0\\" : \\"=m\\" (*($addr))));
	}' unless defined(&__fnstsw);
    }
    eval 'sub fpgetround () {
        eval q((( &fp_rnd_t) (( &__fpgetreg( &FP_RND_REG) &  &FP_RND_FLD) >>  &FP_RND_OFF)));
    }' unless defined(&fpgetround);
    eval 'sub fpsetround {
        my($m) = @_;
	    eval q((( &fp_rnd_t)  &__fpsetreg(($m),  &FP_RND_REG,  &FP_RND_FLD,  &FP_RND_OFF)));
    }' unless defined(&fpsetround);
    eval 'sub fpgetprec () {
        eval q((( &fp_prec_t) (( &__fpgetreg( &FP_PRC_REG) &  &FP_PRC_FLD) >>  &FP_PRC_OFF)));
    }' unless defined(&fpgetprec);
    eval 'sub fpsetprec {
        my($m) = @_;
	    eval q((( &fp_prec_t)  &__fpsetreg(($m),  &FP_PRC_REG,  &FP_PRC_FLD,  &FP_PRC_OFF)));
    }' unless defined(&fpsetprec);
    eval 'sub fpgetmask () {
        eval q((( &fp_except_t) ((~ &__fpgetreg( &FP_MSKS_REG) &  &FP_MSKS_FLD) >>  &FP_MSKS_OFF)));
    }' unless defined(&fpgetmask);
    eval 'sub fpsetmask {
        my($m) = @_;
	    eval q((( &fp_except_t) (~ &__fpsetreg(~($m),  &FP_MSKS_REG,  &FP_MSKS_FLD,  &FP_MSKS_OFF)) & ( &FP_MSKS_FLD >>  &FP_MSKS_OFF)));
    }' unless defined(&fpsetmask);
    eval 'sub fpgetsticky () {
        eval q((( &fp_except_t) (( &__fpgetreg( &FP_STKY_REG) &  &FP_STKY_FLD) >>  &FP_STKY_OFF)));
    }' unless defined(&fpgetsticky);
    eval 'sub fpresetsticky {
        my($m) = @_;
	    eval q((( &fp_except_t)  &__fpsetreg(0,  &FP_STKY_REG, ($m),  &FP_STKY_OFF)));
    }' unless defined(&fpresetsticky);
    eval 'sub _IEEEFP_INLINED_ () {1;}' unless defined(&_IEEEFP_INLINED_);
}
1;
