require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MACHINE_PCPU_H_)) {
    eval 'sub _MACHINE_PCPU_H_ () {1;}' unless defined(&_MACHINE_PCPU_H_);
    unless(defined(&_SYS_CDEFS_H_)) {
	die("this\ file\ needs\ sys\/cdefs\.h\ as\ a\ prerequisite");
    }
    if(defined(&_KERNEL)) {
	require 'machine/segments.ph';
	require 'machine/tss.ph';
	eval 'sub PCPU_MD_FIELDS () {\'struct pcpu\' * &pc_prvspace; \'struct pmap\' * &pc_curpmap; \'struct i386tss\'  &pc_common_tss; \'struct segment_descriptor\'  &pc_common_tssd; \'struct segment_descriptor\' * &pc_tss_gdt; \'struct segment_descriptor\' * &pc_fsgs_gdt; \'int\'  &pc_currentldt; \'u_int\'  &pc_acpi_id; \'u_int\'  &pc_apic_id;}' unless defined(&PCPU_MD_FIELDS);
	if(defined( &lint)) {
	    eval 'sub PCPU_GET {
	        my($member) = @_;
    		eval q(( ($pcpup->{pc_})  $member));
	    }' unless defined(&PCPU_GET);
	    eval 'sub PCPU_PTR {
	        my($member) = @_;
    		eval q(( ($pcpup->{pc_})  $member));
	    }' unless defined(&PCPU_PTR);
	    eval 'sub PCPU_SET {
	        my($member,$value) = @_;
    		eval q(( ($pcpup->{pc_})  $member = ($value)));
	    }' unless defined(&PCPU_SET);
	}
 elsif(defined( &__GNUCLIKE_ASM)  && defined( &__GNUCLIKE___TYPEOF)  && defined( &__GNUCLIKE___OFFSETOF)) {
	    eval 'sub __pcpu_offset {
	        my($name) = @_;
    		eval q( &__offsetof(\'struct pcpu\', $name));
	    }' unless defined(&__pcpu_offset);
	    eval 'sub __pcpu_type {
	        my($name) = @_;
    		eval q( &__typeof((0)->$name));
	    }' unless defined(&__pcpu_type);
	    eval 'sub __PCPU_PTR {
	        my($name) = @_;
    		eval q( &__extension__ ({  &__pcpu_type($name) * &__p;  &__asm  &__volatile(\\"movl %%fs:%1,%0; addl %2,%0\\" : \\"=r\\" ( &__p) : \\"m\\" (*( &__pcpu_offset( &pc_prvspace))), \\"i\\" ( &__pcpu_offset($name)));  &__p; }));
	    }' unless defined(&__PCPU_PTR);
	    eval 'sub __PCPU_GET {
	        my($name) = @_;
    		eval q( &__extension__ ({  &__pcpu_type($name)  &__result;  &if ( &sizeof == 1) { \'u_char\'  &__b;  &__asm  &__volatile(\\"movb %%fs:%1,%0\\" : \\"=r\\" : \\"m\\" (*));  &__result = *( &__pcpu_type *)& &__b; }  &else  &if ( &sizeof == 2) { \'u_short __w\';  &__asm  &__volatile(\\"movw %%fs:%1,%0\\" : \\"=r\\" : \\"m\\" (*));  &__result = *( &__pcpu_type *)& &__w; }  &else  &if ( &sizeof == 4) { \'u_int\'  &__i;  &__asm  &__volatile(\\"movl %%fs:%1,%0\\" : \\"=r\\" : \\"m\\" (*( &__pcpu_offset($name))));  &__result = *( &__pcpu_type($name) *)( &void *)& &__i; }  &else {  &__result = * &__PCPU_PTR($name); }  &__result; }));
	    }' unless defined(&__PCPU_GET);
	    eval 'sub __PCPU_SET {
	        my($name, $val) = @_;
    		eval q({  &__pcpu_type($name)  &__val = ;  &if ( &sizeof == 1) { \'u_char\'  &__b;  &__b = *& &__val;  &__asm  &__volatile(\\"movb %1,%%fs:%0\\" : \\"=m\\" (*) : \\"r\\" ); }  &else  &if ( &sizeof == 2) { \'u_short __w\';  &__w = *& &__val;  &__asm  &__volatile(\\"movw %1,%%fs:%0\\" : \\"=m\\" (*) : \\"r\\" ); }  &else  &if ( &sizeof == 4) { \'u_int\'  &__i;  &__i = *& &__val;  &__asm  &__volatile(\\"movl %1,%%fs:%0\\" : \\"=m\\" (*( &__pcpu_offset($name))) : \\"r\\" ( &__i)); }  &else { * &__PCPU_PTR($name) =  &__val; } });
	    }' unless defined(&__PCPU_SET);
	    eval 'sub PCPU_GET {
	        my($member) = @_;
    		eval q( &__PCPU_GET( &pc_  $member));
	    }' unless defined(&PCPU_GET);
	    eval 'sub PCPU_PTR {
	        my($member) = @_;
    		eval q( &__PCPU_PTR( &pc_  $member));
	    }' unless defined(&PCPU_PTR);
	    eval 'sub PCPU_SET {
	        my($member, $val) = @_;
    		eval q( &__PCPU_SET( &pc_  $member, $val));
	    }' unless defined(&PCPU_SET);
	    eval 'sub __curthread {
	        my($void) = @_;
    		eval q({ \'struct thread\' * &td;  &__asm  &__volatile(\\"movl %%fs:0,%0\\" : \\"=r\\" ( &td)); ( &td); });
	    }' unless defined(&__curthread);
	    eval 'sub curthread () {( &__curthread());}' unless defined(&curthread);
	} else {
	    die("this\ file\ needs\ to\ be\ ported\ to\ your\ compiler");
	}
    }
}
1;
