require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MACHINE_SMP_H_)) {
    eval 'sub _MACHINE_SMP_H_ () {1;}' unless defined(&_MACHINE_SMP_H_);
    if(defined(&_KERNEL)) {
	if(defined(&SMP)) {
	    unless(defined(&LOCORE)) {
		eval 'sub POSTCODE {
		    my($X) = @_;
    		    eval q( &current_postcode = ($X),  &outb(0x80,  &current_postcode));
		}' unless defined(&POSTCODE);
		eval 'sub POSTCODE_LO {
		    my($X) = @_;
    		    eval q( &current_postcode &= 0xf0,  &current_postcode |= (($X) & 0xf),  &outb(0x80,  &current_postcode));
		}' unless defined(&POSTCODE_LO);
		eval 'sub POSTCODE_HI {
		    my($X) = @_;
    		    eval q( &current_postcode &= 0xf,  &current_postcode |= ((($X) << 4) & 0xf0),  &outb(0x80,  &current_postcode));
		}' unless defined(&POSTCODE_HI);
		require 'sys/bus.ph';
		require 'machine/frame.ph';
		require 'machine/intr_machdep.ph';
		require 'machine/apicvar.ph';
		if(defined(&KDB_STOP_NMI)) {
		}
	    }
	}
    }
}
1;
