require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_ELF_COMMON_H_)) {
    eval 'sub _SYS_ELF_COMMON_H_ () {1;}' unless defined(&_SYS_ELF_COMMON_H_);
    eval 'sub EI_MAG0 () {0;}' unless defined(&EI_MAG0);
    eval 'sub EI_MAG1 () {1;}' unless defined(&EI_MAG1);
    eval 'sub EI_MAG2 () {2;}' unless defined(&EI_MAG2);
    eval 'sub EI_MAG3 () {3;}' unless defined(&EI_MAG3);
    eval 'sub EI_CLASS () {4;}' unless defined(&EI_CLASS);
    eval 'sub EI_DATA () {5;}' unless defined(&EI_DATA);
    eval 'sub EI_VERSION () {6;}' unless defined(&EI_VERSION);
    eval 'sub EI_OSABI () {7;}' unless defined(&EI_OSABI);
    eval 'sub EI_ABIVERSION () {8;}' unless defined(&EI_ABIVERSION);
    eval 'sub OLD_EI_BRAND () {8;}' unless defined(&OLD_EI_BRAND);
    eval 'sub EI_PAD () {9;}' unless defined(&EI_PAD);
    eval 'sub EI_NIDENT () {16;}' unless defined(&EI_NIDENT);
    eval 'sub ELFMAG0 () {0x7f;}' unless defined(&ELFMAG0);
    eval 'sub ELFMAG1 () {ord(\'E\');}' unless defined(&ELFMAG1);
    eval 'sub ELFMAG2 () {ord(\'L\');}' unless defined(&ELFMAG2);
    eval 'sub ELFMAG3 () {ord(\'F\');}' unless defined(&ELFMAG3);
    eval 'sub ELFMAG () {"\\177ELF";}' unless defined(&ELFMAG);
    eval 'sub SELFMAG () {4;}' unless defined(&SELFMAG);
    eval 'sub EV_NONE () {0;}' unless defined(&EV_NONE);
    eval 'sub EV_CURRENT () {1;}' unless defined(&EV_CURRENT);
    eval 'sub ELFCLASSNONE () {0;}' unless defined(&ELFCLASSNONE);
    eval 'sub ELFCLASS32 () {1;}' unless defined(&ELFCLASS32);
    eval 'sub ELFCLASS64 () {2;}' unless defined(&ELFCLASS64);
    eval 'sub ELFDATANONE () {0;}' unless defined(&ELFDATANONE);
    eval 'sub ELFDATA2LSB () {1;}' unless defined(&ELFDATA2LSB);
    eval 'sub ELFDATA2MSB () {2;}' unless defined(&ELFDATA2MSB);
    eval 'sub ELFOSABI_NONE () {0;}' unless defined(&ELFOSABI_NONE);
    eval 'sub ELFOSABI_HPUX () {1;}' unless defined(&ELFOSABI_HPUX);
    eval 'sub ELFOSABI_NETBSD () {2;}' unless defined(&ELFOSABI_NETBSD);
    eval 'sub ELFOSABI_LINUX () {3;}' unless defined(&ELFOSABI_LINUX);
    eval 'sub ELFOSABI_HURD () {4;}' unless defined(&ELFOSABI_HURD);
    eval 'sub ELFOSABI_86OPEN () {5;}' unless defined(&ELFOSABI_86OPEN);
    eval 'sub ELFOSABI_SOLARIS () {6;}' unless defined(&ELFOSABI_SOLARIS);
    eval 'sub ELFOSABI_AIX () {7;}' unless defined(&ELFOSABI_AIX);
    eval 'sub ELFOSABI_IRIX () {8;}' unless defined(&ELFOSABI_IRIX);
    eval 'sub ELFOSABI_FREEBSD () {9;}' unless defined(&ELFOSABI_FREEBSD);
    eval 'sub ELFOSABI_TRU64 () {10;}' unless defined(&ELFOSABI_TRU64);
    eval 'sub ELFOSABI_MODESTO () {11;}' unless defined(&ELFOSABI_MODESTO);
    eval 'sub ELFOSABI_OPENBSD () {12;}' unless defined(&ELFOSABI_OPENBSD);
    eval 'sub ELFOSABI_OPENVMS () {13;}' unless defined(&ELFOSABI_OPENVMS);
    eval 'sub ELFOSABI_NSK () {14;}' unless defined(&ELFOSABI_NSK);
    eval 'sub ELFOSABI_ARM () {97;}' unless defined(&ELFOSABI_ARM);
    eval 'sub ELFOSABI_STANDALONE () {255;}' unless defined(&ELFOSABI_STANDALONE);
    eval 'sub ELFOSABI_SYSV () { &ELFOSABI_NONE;}' unless defined(&ELFOSABI_SYSV);
    eval 'sub ELFOSABI_MONTEREY () { &ELFOSABI_AIX;}' unless defined(&ELFOSABI_MONTEREY);
    eval 'sub IS_ELF {
        my($ehdr) = @_;
	    eval q((($ehdr). $e_ident[ &EI_MAG0] ==  &ELFMAG0  && ($ehdr). $e_ident[ &EI_MAG1] ==  &ELFMAG1  && ($ehdr). $e_ident[ &EI_MAG2] ==  &ELFMAG2  && ($ehdr). $e_ident[ &EI_MAG3] ==  &ELFMAG3));
    }' unless defined(&IS_ELF);
    eval 'sub ET_NONE () {0;}' unless defined(&ET_NONE);
    eval 'sub ET_REL () {1;}' unless defined(&ET_REL);
    eval 'sub ET_EXEC () {2;}' unless defined(&ET_EXEC);
    eval 'sub ET_DYN () {3;}' unless defined(&ET_DYN);
    eval 'sub ET_CORE () {4;}' unless defined(&ET_CORE);
    eval 'sub ET_LOOS () {0xfe00;}' unless defined(&ET_LOOS);
    eval 'sub ET_HIOS () {0xfeff;}' unless defined(&ET_HIOS);
    eval 'sub ET_LOPROC () {0xff00;}' unless defined(&ET_LOPROC);
    eval 'sub ET_HIPROC () {0xffff;}' unless defined(&ET_HIPROC);
    eval 'sub EM_NONE () {0;}' unless defined(&EM_NONE);
    eval 'sub EM_M32 () {1;}' unless defined(&EM_M32);
    eval 'sub EM_SPARC () {2;}' unless defined(&EM_SPARC);
    eval 'sub EM_386 () {3;}' unless defined(&EM_386);
    eval 'sub EM_68K () {4;}' unless defined(&EM_68K);
    eval 'sub EM_88K () {5;}' unless defined(&EM_88K);
    eval 'sub EM_860 () {7;}' unless defined(&EM_860);
    eval 'sub EM_MIPS () {8;}' unless defined(&EM_MIPS);
    eval 'sub EM_S370 () {9;}' unless defined(&EM_S370);
    eval 'sub EM_MIPS_RS3_LE () {10;}' unless defined(&EM_MIPS_RS3_LE);
    eval 'sub EM_PARISC () {15;}' unless defined(&EM_PARISC);
    eval 'sub EM_VPP500 () {17;}' unless defined(&EM_VPP500);
    eval 'sub EM_SPARC32PLUS () {18;}' unless defined(&EM_SPARC32PLUS);
    eval 'sub EM_960 () {19;}' unless defined(&EM_960);
    eval 'sub EM_PPC () {20;}' unless defined(&EM_PPC);
    eval 'sub EM_PPC64 () {21;}' unless defined(&EM_PPC64);
    eval 'sub EM_S390 () {22;}' unless defined(&EM_S390);
    eval 'sub EM_V800 () {36;}' unless defined(&EM_V800);
    eval 'sub EM_FR20 () {37;}' unless defined(&EM_FR20);
    eval 'sub EM_RH32 () {38;}' unless defined(&EM_RH32);
    eval 'sub EM_RCE () {39;}' unless defined(&EM_RCE);
    eval 'sub EM_ARM () {40;}' unless defined(&EM_ARM);
    eval 'sub EM_SH () {42;}' unless defined(&EM_SH);
    eval 'sub EM_SPARCV9 () {43;}' unless defined(&EM_SPARCV9);
    eval 'sub EM_TRICORE () {44;}' unless defined(&EM_TRICORE);
    eval 'sub EM_ARC () {45;}' unless defined(&EM_ARC);
    eval 'sub EM_H8_300 () {46;}' unless defined(&EM_H8_300);
    eval 'sub EM_H8_300H () {47;}' unless defined(&EM_H8_300H);
    eval 'sub EM_H8S () {48;}' unless defined(&EM_H8S);
    eval 'sub EM_H8_500 () {49;}' unless defined(&EM_H8_500);
    eval 'sub EM_IA_64 () {50;}' unless defined(&EM_IA_64);
    eval 'sub EM_MIPS_X () {51;}' unless defined(&EM_MIPS_X);
    eval 'sub EM_COLDFIRE () {52;}' unless defined(&EM_COLDFIRE);
    eval 'sub EM_68HC12 () {53;}' unless defined(&EM_68HC12);
    eval 'sub EM_MMA () {54;}' unless defined(&EM_MMA);
    eval 'sub EM_PCP () {55;}' unless defined(&EM_PCP);
    eval 'sub EM_NCPU () {56;}' unless defined(&EM_NCPU);
    eval 'sub EM_NDR1 () {57;}' unless defined(&EM_NDR1);
    eval 'sub EM_STARCORE () {58;}' unless defined(&EM_STARCORE);
    eval 'sub EM_ME16 () {59;}' unless defined(&EM_ME16);
    eval 'sub EM_ST100 () {60;}' unless defined(&EM_ST100);
    eval 'sub EM_TINYJ () {61;}' unless defined(&EM_TINYJ);
    eval 'sub EM_X86_64 () {62;}' unless defined(&EM_X86_64);
    eval 'sub EM_486 () {6;}' unless defined(&EM_486);
    eval 'sub EM_MIPS_RS4_BE () {10;}' unless defined(&EM_MIPS_RS4_BE);
    eval 'sub EM_ALPHA_STD () {41;}' unless defined(&EM_ALPHA_STD);
    eval 'sub EM_ALPHA () {0x9026;}' unless defined(&EM_ALPHA);
    eval 'sub SHN_UNDEF () {0;}' unless defined(&SHN_UNDEF);
    eval 'sub SHN_LORESERVE () {0xff00;}' unless defined(&SHN_LORESERVE);
    eval 'sub SHN_LOPROC () {0xff00;}' unless defined(&SHN_LOPROC);
    eval 'sub SHN_HIPROC () {0xff1f;}' unless defined(&SHN_HIPROC);
    eval 'sub SHN_LOOS () {0xff20;}' unless defined(&SHN_LOOS);
    eval 'sub SHN_HIOS () {0xff3f;}' unless defined(&SHN_HIOS);
    eval 'sub SHN_ABS () {0xfff1;}' unless defined(&SHN_ABS);
    eval 'sub SHN_COMMON () {0xfff2;}' unless defined(&SHN_COMMON);
    eval 'sub SHN_XINDEX () {0xffff;}' unless defined(&SHN_XINDEX);
    eval 'sub SHN_HIRESERVE () {0xffff;}' unless defined(&SHN_HIRESERVE);
    eval 'sub SHT_NULL () {0;}' unless defined(&SHT_NULL);
    eval 'sub SHT_PROGBITS () {1;}' unless defined(&SHT_PROGBITS);
    eval 'sub SHT_SYMTAB () {2;}' unless defined(&SHT_SYMTAB);
    eval 'sub SHT_STRTAB () {3;}' unless defined(&SHT_STRTAB);
    eval 'sub SHT_RELA () {4;}' unless defined(&SHT_RELA);
    eval 'sub SHT_HASH () {5;}' unless defined(&SHT_HASH);
    eval 'sub SHT_DYNAMIC () {6;}' unless defined(&SHT_DYNAMIC);
    eval 'sub SHT_NOTE () {7;}' unless defined(&SHT_NOTE);
    eval 'sub SHT_NOBITS () {8;}' unless defined(&SHT_NOBITS);
    eval 'sub SHT_REL () {9;}' unless defined(&SHT_REL);
    eval 'sub SHT_SHLIB () {10;}' unless defined(&SHT_SHLIB);
    eval 'sub SHT_DYNSYM () {11;}' unless defined(&SHT_DYNSYM);
    eval 'sub SHT_INIT_ARRAY () {14;}' unless defined(&SHT_INIT_ARRAY);
    eval 'sub SHT_FINI_ARRAY () {15;}' unless defined(&SHT_FINI_ARRAY);
    eval 'sub SHT_PREINIT_ARRAY () {16;}' unless defined(&SHT_PREINIT_ARRAY);
    eval 'sub SHT_GROUP () {17;}' unless defined(&SHT_GROUP);
    eval 'sub SHT_SYMTAB_SHNDX () {18;}' unless defined(&SHT_SYMTAB_SHNDX);
    eval 'sub SHT_LOOS () {0x60000000;}' unless defined(&SHT_LOOS);
    eval 'sub SHT_HIOS () {0x6fffffff;}' unless defined(&SHT_HIOS);
    eval 'sub SHT_LOPROC () {0x70000000;}' unless defined(&SHT_LOPROC);
    eval 'sub SHT_HIPROC () {0x7fffffff;}' unless defined(&SHT_HIPROC);
    eval 'sub SHT_LOUSER () {0x80000000;}' unless defined(&SHT_LOUSER);
    eval 'sub SHT_HIUSER () {0xffffffff;}' unless defined(&SHT_HIUSER);
    eval 'sub SHF_WRITE () {0x1;}' unless defined(&SHF_WRITE);
    eval 'sub SHF_ALLOC () {0x2;}' unless defined(&SHF_ALLOC);
    eval 'sub SHF_EXECINSTR () {0x4;}' unless defined(&SHF_EXECINSTR);
    eval 'sub SHF_MERGE () {0x10;}' unless defined(&SHF_MERGE);
    eval 'sub SHF_STRINGS () {0x20;}' unless defined(&SHF_STRINGS);
    eval 'sub SHF_INFO_LINK () {0x40;}' unless defined(&SHF_INFO_LINK);
    eval 'sub SHF_LINK_ORDER () {0x80;}' unless defined(&SHF_LINK_ORDER);
    eval 'sub SHF_OS_NONCONFORMING () {0x100;}' unless defined(&SHF_OS_NONCONFORMING);
    eval 'sub SHF_GROUP () {0x200;}' unless defined(&SHF_GROUP);
    eval 'sub SHF_TLS () {0x400;}' unless defined(&SHF_TLS);
    eval 'sub SHF_MASKOS () {0xff00000;}' unless defined(&SHF_MASKOS);
    eval 'sub SHF_MASKPROC () {0xf0000000;}' unless defined(&SHF_MASKPROC);
    eval 'sub PT_NULL () {0;}' unless defined(&PT_NULL);
    eval 'sub PT_LOAD () {1;}' unless defined(&PT_LOAD);
    eval 'sub PT_DYNAMIC () {2;}' unless defined(&PT_DYNAMIC);
    eval 'sub PT_INTERP () {3;}' unless defined(&PT_INTERP);
    eval 'sub PT_NOTE () {4;}' unless defined(&PT_NOTE);
    eval 'sub PT_SHLIB () {5;}' unless defined(&PT_SHLIB);
    eval 'sub PT_PHDR () {6;}' unless defined(&PT_PHDR);
    eval 'sub PT_TLS () {7;}' unless defined(&PT_TLS);
    eval 'sub PT_LOOS () {0x60000000;}' unless defined(&PT_LOOS);
    eval 'sub PT_HIOS () {0x6fffffff;}' unless defined(&PT_HIOS);
    eval 'sub PT_LOPROC () {0x70000000;}' unless defined(&PT_LOPROC);
    eval 'sub PT_HIPROC () {0x7fffffff;}' unless defined(&PT_HIPROC);
    eval 'sub PF_X () {0x1;}' unless defined(&PF_X);
    eval 'sub PF_W () {0x2;}' unless defined(&PF_W);
    eval 'sub PF_R () {0x4;}' unless defined(&PF_R);
    eval 'sub PF_MASKOS () {0xff00000;}' unless defined(&PF_MASKOS);
    eval 'sub PF_MASKPROC () {0xf0000000;}' unless defined(&PF_MASKPROC);
    eval 'sub DT_NULL () {0;}' unless defined(&DT_NULL);
    eval 'sub DT_NEEDED () {1;}' unless defined(&DT_NEEDED);
    eval 'sub DT_PLTRELSZ () {2;}' unless defined(&DT_PLTRELSZ);
    eval 'sub DT_PLTGOT () {3;}' unless defined(&DT_PLTGOT);
    eval 'sub DT_HASH () {4;}' unless defined(&DT_HASH);
    eval 'sub DT_STRTAB () {5;}' unless defined(&DT_STRTAB);
    eval 'sub DT_SYMTAB () {6;}' unless defined(&DT_SYMTAB);
    eval 'sub DT_RELA () {7;}' unless defined(&DT_RELA);
    eval 'sub DT_RELASZ () {8;}' unless defined(&DT_RELASZ);
    eval 'sub DT_RELAENT () {9;}' unless defined(&DT_RELAENT);
    eval 'sub DT_STRSZ () {10;}' unless defined(&DT_STRSZ);
    eval 'sub DT_SYMENT () {11;}' unless defined(&DT_SYMENT);
    eval 'sub DT_INIT () {12;}' unless defined(&DT_INIT);
    eval 'sub DT_FINI () {13;}' unless defined(&DT_FINI);
    eval 'sub DT_SONAME () {14;}' unless defined(&DT_SONAME);
    eval 'sub DT_RPATH () {15;}' unless defined(&DT_RPATH);
    eval 'sub DT_SYMBOLIC () {16;}' unless defined(&DT_SYMBOLIC);
    eval 'sub DT_REL () {17;}' unless defined(&DT_REL);
    eval 'sub DT_RELSZ () {18;}' unless defined(&DT_RELSZ);
    eval 'sub DT_RELENT () {19;}' unless defined(&DT_RELENT);
    eval 'sub DT_PLTREL () {20;}' unless defined(&DT_PLTREL);
    eval 'sub DT_DEBUG () {21;}' unless defined(&DT_DEBUG);
    eval 'sub DT_TEXTREL () {22;}' unless defined(&DT_TEXTREL);
    eval 'sub DT_JMPREL () {23;}' unless defined(&DT_JMPREL);
    eval 'sub DT_BIND_NOW () {24;}' unless defined(&DT_BIND_NOW);
    eval 'sub DT_INIT_ARRAY () {25;}' unless defined(&DT_INIT_ARRAY);
    eval 'sub DT_FINI_ARRAY () {26;}' unless defined(&DT_FINI_ARRAY);
    eval 'sub DT_INIT_ARRAYSZ () {27;}' unless defined(&DT_INIT_ARRAYSZ);
    eval 'sub DT_FINI_ARRAYSZ () {28;}' unless defined(&DT_FINI_ARRAYSZ);
    eval 'sub DT_RUNPATH () {29;}' unless defined(&DT_RUNPATH);
    eval 'sub DT_FLAGS () {30;}' unless defined(&DT_FLAGS);
    eval 'sub DT_ENCODING () {32;}' unless defined(&DT_ENCODING);
    eval 'sub DT_PREINIT_ARRAY () {32;}' unless defined(&DT_PREINIT_ARRAY);
    eval 'sub DT_PREINIT_ARRAYSZ () {33;}' unless defined(&DT_PREINIT_ARRAYSZ);
    eval 'sub DT_LOOS () {0x6000000d;}' unless defined(&DT_LOOS);
    eval 'sub DT_HIOS () {0x6ffff000;}' unless defined(&DT_HIOS);
    eval 'sub DT_LOPROC () {0x70000000;}' unless defined(&DT_LOPROC);
    eval 'sub DT_HIPROC () {0x7fffffff;}' unless defined(&DT_HIPROC);
    eval 'sub DF_ORIGIN () {0x1;}' unless defined(&DF_ORIGIN);
    eval 'sub DF_SYMBOLIC () {0x2;}' unless defined(&DF_SYMBOLIC);
    eval 'sub DF_TEXTREL () {0x4;}' unless defined(&DF_TEXTREL);
    eval 'sub DF_BIND_NOW () {0x8;}' unless defined(&DF_BIND_NOW);
    eval 'sub DF_STATIC_TLS () {0x10;}' unless defined(&DF_STATIC_TLS);
    eval 'sub NT_PRSTATUS () {1;}' unless defined(&NT_PRSTATUS);
    eval 'sub NT_FPREGSET () {2;}' unless defined(&NT_FPREGSET);
    eval 'sub NT_PRPSINFO () {3;}' unless defined(&NT_PRPSINFO);
    eval 'sub STB_LOCAL () {0;}' unless defined(&STB_LOCAL);
    eval 'sub STB_GLOBAL () {1;}' unless defined(&STB_GLOBAL);
    eval 'sub STB_WEAK () {2;}' unless defined(&STB_WEAK);
    eval 'sub STB_LOOS () {10;}' unless defined(&STB_LOOS);
    eval 'sub STB_HIOS () {12;}' unless defined(&STB_HIOS);
    eval 'sub STB_LOPROC () {13;}' unless defined(&STB_LOPROC);
    eval 'sub STB_HIPROC () {15;}' unless defined(&STB_HIPROC);
    eval 'sub STT_NOTYPE () {0;}' unless defined(&STT_NOTYPE);
    eval 'sub STT_OBJECT () {1;}' unless defined(&STT_OBJECT);
    eval 'sub STT_FUNC () {2;}' unless defined(&STT_FUNC);
    eval 'sub STT_SECTION () {3;}' unless defined(&STT_SECTION);
    eval 'sub STT_FILE () {4;}' unless defined(&STT_FILE);
    eval 'sub STT_COMMON () {5;}' unless defined(&STT_COMMON);
    eval 'sub STT_TLS () {6;}' unless defined(&STT_TLS);
    eval 'sub STT_LOOS () {10;}' unless defined(&STT_LOOS);
    eval 'sub STT_HIOS () {12;}' unless defined(&STT_HIOS);
    eval 'sub STT_LOPROC () {13;}' unless defined(&STT_LOPROC);
    eval 'sub STT_HIPROC () {15;}' unless defined(&STT_HIPROC);
    eval 'sub STV_DEFAULT () {0x;}' unless defined(&STV_DEFAULT);
    eval 'sub STV_INTERNAL () {0x1;}' unless defined(&STV_INTERNAL);
    eval 'sub STV_HIDDEN () {0x2;}' unless defined(&STV_HIDDEN);
    eval 'sub STV_PROTECTED () {0x3;}' unless defined(&STV_PROTECTED);
    eval 'sub STN_UNDEF () {0;}' unless defined(&STN_UNDEF);
}
1;
