require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MBUF_H_)) {
    eval 'sub _SYS_MBUF_H_ () {1;}' unless defined(&_SYS_MBUF_H_);
    require 'sys/queue.ph';
    if(defined(&_KERNEL)) {
	require 'sys/systm.ph';
	require 'vm/uma.ph';
	if(defined(&WITNESS)) {
	    require 'sys/lock.ph';
	}
    }
    eval 'sub MLEN () {( &MSIZE - $sizeof{\'struct m_hdr\'});}' unless defined(&MLEN);
    eval 'sub MHLEN () {( &MLEN - $sizeof{\'struct pkthdr\'});}' unless defined(&MHLEN);
    eval 'sub MINCLSIZE () {( &MHLEN + 1);}' unless defined(&MINCLSIZE);
    eval 'sub M_MAXCOMPRESS () {( &MHLEN / 2);}' unless defined(&M_MAXCOMPRESS);
    if(defined(&_KERNEL)) {
	eval 'sub mtod {
	    my($m, $t) = @_;
    	    eval q((($t)(($m)-> &m_data)));
	}' unless defined(&mtod);
	eval 'sub dtom {
	    my($x) = @_;
    	    eval q(((( &intptr_t)($x) & ~( &MSIZE-1))));
	}' unless defined(&dtom);
    }
    eval 'sub m_next () { ($m_hdr->{mh_next});}' unless defined(&m_next);
    eval 'sub m_len () { ($m_hdr->{mh_len});}' unless defined(&m_len);
    eval 'sub m_data () { ($m_hdr->{mh_data});}' unless defined(&m_data);
    eval 'sub m_type () { ($m_hdr->{mh_type});}' unless defined(&m_type);
    eval 'sub m_flags () { ($m_hdr->{mh_flags});}' unless defined(&m_flags);
    eval 'sub m_nextpkt () { ($m_hdr->{mh_nextpkt});}' unless defined(&m_nextpkt);
    eval 'sub m_act () { &m_nextpkt;}' unless defined(&m_act);
    eval 'sub m_pkthdr () { ($M_dat->{MH}->{MH_pkthdr});}' unless defined(&m_pkthdr);
    eval 'sub m_ext () { ($M_dat->{MH}->{MH_dat}->{MH_ext});}' unless defined(&m_ext);
    eval 'sub m_pktdat () { ($M_dat->{MH}->{MH_dat}->{MH_databuf});}' unless defined(&m_pktdat);
    eval 'sub m_dat () { ($M_dat->{M_databuf});}' unless defined(&m_dat);
    eval 'sub M_EXT () {0x1;}' unless defined(&M_EXT);
    eval 'sub M_PKTHDR () {0x2;}' unless defined(&M_PKTHDR);
    eval 'sub M_EOR () {0x4;}' unless defined(&M_EOR);
    eval 'sub M_RDONLY () {0x8;}' unless defined(&M_RDONLY);
    eval 'sub M_PROTO1 () {0x10;}' unless defined(&M_PROTO1);
    eval 'sub M_PROTO2 () {0x20;}' unless defined(&M_PROTO2);
    eval 'sub M_PROTO3 () {0x40;}' unless defined(&M_PROTO3);
    eval 'sub M_PROTO4 () {0x80;}' unless defined(&M_PROTO4);
    eval 'sub M_PROTO5 () {0x100;}' unless defined(&M_PROTO5);
    eval 'sub M_SKIP_FIREWALL () {0x4000;}' unless defined(&M_SKIP_FIREWALL);
    eval 'sub M_FREELIST () {0x8000;}' unless defined(&M_FREELIST);
    eval 'sub M_BCAST () {0x200;}' unless defined(&M_BCAST);
    eval 'sub M_MCAST () {0x400;}' unless defined(&M_MCAST);
    eval 'sub M_FRAG () {0x800;}' unless defined(&M_FRAG);
    eval 'sub M_FIRSTFRAG () {0x1000;}' unless defined(&M_FIRSTFRAG);
    eval 'sub M_LASTFRAG () {0x2000;}' unless defined(&M_LASTFRAG);
    eval 'sub M_VLANTAG () {0x10000;}' unless defined(&M_VLANTAG);
    eval 'sub EXT_CLUSTER () {1;}' unless defined(&EXT_CLUSTER);
    eval 'sub EXT_SFBUF () {2;}' unless defined(&EXT_SFBUF);
    eval 'sub EXT_PACKET () {3;}' unless defined(&EXT_PACKET);
    eval 'sub EXT_JUMBOP () {4;}' unless defined(&EXT_JUMBOP);
    eval 'sub EXT_JUMBO9 () {5;}' unless defined(&EXT_JUMBO9);
    eval 'sub EXT_JUMBO16 () {6;}' unless defined(&EXT_JUMBO16);
    eval 'sub EXT_NET_DRV () {100;}' unless defined(&EXT_NET_DRV);
    eval 'sub EXT_MOD_TYPE () {200;}' unless defined(&EXT_MOD_TYPE);
    eval 'sub EXT_DISPOSABLE () {300;}' unless defined(&EXT_DISPOSABLE);
    eval 'sub EXT_EXTREF () {400;}' unless defined(&EXT_EXTREF);
    eval 'sub M_COPYFLAGS () {( &M_PKTHDR| &M_EOR| &M_RDONLY| &M_PROTO1| &M_PROTO1| &M_PROTO2|  &M_PROTO3| &M_PROTO4| &M_PROTO5| &M_SKIP_FIREWALL|  &M_BCAST| &M_MCAST| &M_FRAG| &M_FIRSTFRAG| &M_LASTFRAG|  &M_VLANTAG);}' unless defined(&M_COPYFLAGS);
    eval 'sub CSUM_IP () {0x1;}' unless defined(&CSUM_IP);
    eval 'sub CSUM_TCP () {0x2;}' unless defined(&CSUM_TCP);
    eval 'sub CSUM_UDP () {0x4;}' unless defined(&CSUM_UDP);
    eval 'sub CSUM_IP_FRAGS () {0x8;}' unless defined(&CSUM_IP_FRAGS);
    eval 'sub CSUM_FRAGMENT () {0x10;}' unless defined(&CSUM_FRAGMENT);
    eval 'sub CSUM_IP_CHECKED () {0x100;}' unless defined(&CSUM_IP_CHECKED);
    eval 'sub CSUM_IP_VALID () {0x200;}' unless defined(&CSUM_IP_VALID);
    eval 'sub CSUM_DATA_VALID () {0x400;}' unless defined(&CSUM_DATA_VALID);
    eval 'sub CSUM_PSEUDO_HDR () {0x800;}' unless defined(&CSUM_PSEUDO_HDR);
    eval 'sub CSUM_DELAY_DATA () {( &CSUM_TCP |  &CSUM_UDP);}' unless defined(&CSUM_DELAY_DATA);
    eval 'sub CSUM_DELAY_IP () {( &CSUM_IP);}' unless defined(&CSUM_DELAY_IP);
    eval 'sub MT_NOTMBUF () {0;}' unless defined(&MT_NOTMBUF);
    eval 'sub MT_DATA () {1;}' unless defined(&MT_DATA);
    eval 'sub MT_HEADER () {2;}' unless defined(&MT_HEADER);
    if(0) {
	eval 'sub MT_SOCKET () {3;}' unless defined(&MT_SOCKET);
	eval 'sub MT_PCB () {4;}' unless defined(&MT_PCB);
	eval 'sub MT_RTABLE () {5;}' unless defined(&MT_RTABLE);
	eval 'sub MT_HTABLE () {6;}' unless defined(&MT_HTABLE);
	eval 'sub MT_ATABLE () {7;}' unless defined(&MT_ATABLE);
    }
    eval 'sub MT_SONAME () {8;}' unless defined(&MT_SONAME);
    if(0) {
	eval 'sub MT_SOOPTS () {10;}' unless defined(&MT_SOOPTS);
    }
    eval 'sub MT_FTABLE () {11;}' unless defined(&MT_FTABLE);
    if(0) {
	eval 'sub MT_RIGHTS () {12;}' unless defined(&MT_RIGHTS);
	eval 'sub MT_IFADDR () {13;}' unless defined(&MT_IFADDR);
    }
    eval 'sub MT_CONTROL () {14;}' unless defined(&MT_CONTROL);
    eval 'sub MT_OOBDATA () {15;}' unless defined(&MT_OOBDATA);
    eval 'sub MT_NTYPES () {16;}' unless defined(&MT_NTYPES);
    eval 'sub MT_NOINIT () {255;}' unless defined(&MT_NOINIT);
    eval 'sub MBTOM {
        my($how) = @_;
	    eval q(($how));
    }' unless defined(&MBTOM);
    eval 'sub M_DONTWAIT () { &M_NOWAIT;}' unless defined(&M_DONTWAIT);
    eval 'sub M_TRYWAIT () { &M_WAITOK;}' unless defined(&M_TRYWAIT);
    eval 'sub M_WAIT () { &M_WAITOK;}' unless defined(&M_WAIT);
    eval 'sub MBUF_MEM_NAME () {"mbuf";}' unless defined(&MBUF_MEM_NAME);
    eval 'sub MBUF_CLUSTER_MEM_NAME () {"mbuf_cluster";}' unless defined(&MBUF_CLUSTER_MEM_NAME);
    eval 'sub MBUF_JUMBOP_MEM_NAME () {"mbuf_jumbo_pagesize";}' unless defined(&MBUF_JUMBOP_MEM_NAME);
    eval 'sub MBUF_JUMBO9_MEM_NAME () {"mbuf_jumbo_9k";}' unless defined(&MBUF_JUMBO9_MEM_NAME);
    eval 'sub MBUF_JUMBO16_MEM_NAME () {"mbuf_jumbo_16k";}' unless defined(&MBUF_JUMBO16_MEM_NAME);
    eval 'sub MBUF_PACKET_MEM_NAME () {"mbuf_packet";}' unless defined(&MBUF_PACKET_MEM_NAME);
    eval 'sub MBUF_TAG_MEM_NAME () {"mbuf_tag";}' unless defined(&MBUF_TAG_MEM_NAME);
    if(defined(&_KERNEL)) {
	eval 'sub MEXT_IS_REF {
	    my($m) = @_;
    	    eval q(((($m)-> ($m_ext->{ref_cnt}) !=  &NULL)  && (*(($m)-> ($m_ext->{ref_cnt})) > 1)));
	}' unless defined(&MEXT_IS_REF);
	eval 'sub MEXT_REM_REF {
	    my($m) = @_;
    	    eval q( &do {  &KASSERT(($m)-> ($m_ext->{ref_cnt}) !=  &NULL, (\\"m_ext refcnt lazy NULL\\"));  &KASSERT(*(($m)-> ($m_ext->{ref_cnt})) > 0, (\\"m_ext refcnt < 0\\"));  &atomic_subtract_int(($m)-> ($m_ext->{ref_cnt}), 1); }  &while(0));
	}' unless defined(&MEXT_REM_REF);
	eval 'sub MEXT_ADD_REF {
	    my($m) = @_;
    	    eval q( &do {  &if (-> ($m_ext->{ref_cnt}) ==  &NULL) {  &KASSERT(-> ($m_ext->{ext_type}) ==  &EXT_CLUSTER || -> ($m_ext->{ext_type}) ==  &EXT_PACKET, (\\"Unexpected mbuf type has lazy refcnt\\")); -> ($m_ext->{ref_cnt}) =  &uma_find_refcnt(  &zone_clust, ($m)-> ($m_ext->{ext_buf})); *(($m)-> ($m_ext->{ref_cnt})) = 2; }  &else  &atomic_add_int(($m)-> ($m_ext->{ref_cnt}), 1); }  &while (0));
	}' unless defined(&MEXT_ADD_REF);
	if(defined(&WITNESS)) {
	    eval 'sub MBUF_CHECKSLEEP {
	        my($how) = @_;
    		eval q( &do {  &if ($how ==  &M_WAITOK)  &WITNESS_WARN( &WARN_GIANTOK |  &WARN_SLEEPOK,  &NULL, \\"Sleeping in \\\\\\"%s\\\\\\"\\",  &__func__); }  &while(0));
	    }' unless defined(&MBUF_CHECKSLEEP);
	} else {
	    eval 'sub MBUF_CHECKSLEEP {
	        my($how) = @_;
    		eval q();
	    }' unless defined(&MBUF_CHECKSLEEP);
	}
	if((defined(&MJUMPAGESIZE) ? &MJUMPAGESIZE : 0) != (defined(&MCLBYTES) ? &MCLBYTES : 0)) {
	}
	if(defined(&INVARIANTS)) {
	}
	if((defined(&MJUMPAGESIZE) ? &MJUMPAGESIZE : 0) != (defined(&MCLBYTES) ? &MCLBYTES : 0)) {
	}
	eval 'sub M_MOVE_PKTHDR {
	    my($to, $from) = @_;
    	    eval q( &m_move_pkthdr(($to), ($from)));
	}' unless defined(&M_MOVE_PKTHDR);
	eval 'sub MGET {
	    my($m, $how, $type) = @_;
    	    eval q((($m) =  &m_get(($how), ($type))));
	}' unless defined(&MGET);
	eval 'sub MGETHDR {
	    my($m, $how, $type) = @_;
    	    eval q((($m) =  &m_gethdr(($how), ($type))));
	}' unless defined(&MGETHDR);
	eval 'sub MCLGET {
	    my($m, $how) = @_;
    	    eval q( &m_clget(($m), ($how)));
	}' unless defined(&MCLGET);
	eval 'sub MEXTADD {
	    my($m, $buf, $size, $free, $args, $flags, $type) = @_;
    	    eval q( &m_extadd(, ($buf), ($size), ($free), ($args), ($flags), ($type)));
	}' unless defined(&MEXTADD);
	eval 'sub M_WRITABLE {
	    my($m) = @_;
    	    eval q((!(($m)-> &m_flags &  &M_RDONLY)  && (!(($m)-> &m_flags &  &M_EXT) || ! &MEXT_IS_REF($m))));
	}' unless defined(&M_WRITABLE);
	eval 'sub M_ASSERTPKTHDR {
	    my($m) = @_;
    	    eval q( &KASSERT($m !=  &NULL  &&  ($m->{m_flags}) &  &M_PKTHDR, (\\"%s: no mbuf packet header!\\",  &__func__)));
	}' unless defined(&M_ASSERTPKTHDR);
	eval 'sub M_ASSERTVALID {
	    my($m) = @_;
    	    eval q( &KASSERT((($m)-> &m_flags &  &M_FREELIST) == 0, (\\"%s: attempted use of a free mbuf!\\",  &__func__)));
	}' unless defined(&M_ASSERTVALID);
	eval 'sub M_ALIGN {
	    my($m, $len) = @_;
    	    eval q( &do { ($m)-> &m_data += ( &MLEN - ($len)) & ~($sizeof{\'long\'} - 1); }  &while (0));
	}' unless defined(&M_ALIGN);
	eval 'sub MH_ALIGN {
	    my($m, $len) = @_;
    	    eval q( &do { ($m)-> &m_data += ( &MHLEN - ($len)) & ~($sizeof{\'long\'} - 1); }  &while (0));
	}' unless defined(&MH_ALIGN);
	eval 'sub M_LEADINGSPACE {
	    my($m) = @_;
    	    eval q((($m)-> &m_flags &  &M_EXT ? ( &M_WRITABLE($m) ? ($m)-> &m_data - ($m)-> ($m_ext->{ext_buf}) : 0): ($m)-> &m_flags &  &M_PKTHDR ? ($m)-> &m_data - ($m)-> &m_pktdat : ($m)-> &m_data - ($m)-> &m_dat));
	}' unless defined(&M_LEADINGSPACE);
	eval 'sub M_TRAILINGSPACE {
	    my($m) = @_;
    	    eval q((($m)-> &m_flags &  &M_EXT ? ( &M_WRITABLE($m) ? ($m)-> ($m_ext->{ext_buf}) + ($m)-> ($m_ext->{ext_size})	 - (($m)-> &m_data + ($m)-> &m_len) : 0) : ($m)-> $m_dat[ &MLEN] - (($m)-> &m_data + ($m)-> &m_len)));
	}' unless defined(&M_TRAILINGSPACE);
	eval 'sub M_PREPEND {
	    my($m, $plen, $how) = @_;
    	    eval q( &do { \'struct mbuf\' ** &_mmp = ($m); \'struct mbuf\' * &_mm = * &_mmp; \'int\'  &_mplen = ($plen); \'int\'  &__mhow = ($how);  &MBUF_CHECKSLEEP($how);  &if ( &M_LEADINGSPACE( &_mm) >=  &_mplen) {  ($_$mm->{m_data}) -=  &_mplen;  ($_$mm->{m_len}) +=  &_mplen; }  &else  &_mm =  &m_prepend( &_mm,  &_mplen,  &__mhow);  &if ( &_mm !=  &NULL  &&  ($_$mm->{m_flags}) &  &M_PKTHDR)  ($_$mm->{m_pkthdr}->{len}) +=  &_mplen; * &_mmp =  &_mm; }  &while (0));
	}' unless defined(&M_PREPEND);
	eval 'sub MCHTYPE {
	    my($m, $t) = @_;
    	    eval q( &m_chtype(($m), ($t)));
	}' unless defined(&MCHTYPE);
	eval 'sub M_COPYALL () {1000000000;}' unless defined(&M_COPYALL);
	eval 'sub m_copy {
	    my($m, $o, $l) = @_;
    	    eval q( &m_copym(($m), ($o), ($l),  &M_DONTWAIT));
	}' unless defined(&m_copy);
	eval 'sub MTAG_PERSISTENT () {0x800;}' unless defined(&MTAG_PERSISTENT);
	eval 'sub PACKET_TAG_NONE () {0;}' unless defined(&PACKET_TAG_NONE);
	eval 'sub PACKET_TAG_IPSEC_IN_DONE () {1;}' unless defined(&PACKET_TAG_IPSEC_IN_DONE);
	eval 'sub PACKET_TAG_IPSEC_OUT_DONE () {2;}' unless defined(&PACKET_TAG_IPSEC_OUT_DONE);
	eval 'sub PACKET_TAG_IPSEC_IN_CRYPTO_DONE () {3;}' unless defined(&PACKET_TAG_IPSEC_IN_CRYPTO_DONE);
	eval 'sub PACKET_TAG_IPSEC_OUT_CRYPTO_NEEDED () {4;}' unless defined(&PACKET_TAG_IPSEC_OUT_CRYPTO_NEEDED);
	eval 'sub PACKET_TAG_IPSEC_IN_COULD_DO_CRYPTO () {5;}' unless defined(&PACKET_TAG_IPSEC_IN_COULD_DO_CRYPTO);
	eval 'sub PACKET_TAG_IPSEC_PENDING_TDB () {6;}' unless defined(&PACKET_TAG_IPSEC_PENDING_TDB);
	eval 'sub PACKET_TAG_BRIDGE () {7;}' unless defined(&PACKET_TAG_BRIDGE);
	eval 'sub PACKET_TAG_GIF () {8;}' unless defined(&PACKET_TAG_GIF);
	eval 'sub PACKET_TAG_GRE () {9;}' unless defined(&PACKET_TAG_GRE);
	eval 'sub PACKET_TAG_IN_PACKET_CHECKSUM () {10;}' unless defined(&PACKET_TAG_IN_PACKET_CHECKSUM);
	eval 'sub PACKET_TAG_ENCAP () {11;}' unless defined(&PACKET_TAG_ENCAP);
	eval 'sub PACKET_TAG_IPSEC_SOCKET () {12;}' unless defined(&PACKET_TAG_IPSEC_SOCKET);
	eval 'sub PACKET_TAG_IPSEC_HISTORY () {13;}' unless defined(&PACKET_TAG_IPSEC_HISTORY);
	eval 'sub PACKET_TAG_IPV6_INPUT () {14;}' unless defined(&PACKET_TAG_IPV6_INPUT);
	eval 'sub PACKET_TAG_DUMMYNET () {15;}' unless defined(&PACKET_TAG_DUMMYNET);
	eval 'sub PACKET_TAG_DIVERT () {17;}' unless defined(&PACKET_TAG_DIVERT);
	eval 'sub PACKET_TAG_IPFORWARD () {18;}' unless defined(&PACKET_TAG_IPFORWARD);
	eval 'sub PACKET_TAG_MACLABEL () {(19|  &MTAG_PERSISTENT);}' unless defined(&PACKET_TAG_MACLABEL);
	eval 'sub PACKET_TAG_PF_ROUTED () {21;}' unless defined(&PACKET_TAG_PF_ROUTED);
	eval 'sub PACKET_TAG_PF_FRAGCACHE () {22;}' unless defined(&PACKET_TAG_PF_FRAGCACHE);
	eval 'sub PACKET_TAG_PF_QID () {23;}' unless defined(&PACKET_TAG_PF_QID);
	eval 'sub PACKET_TAG_PF_TAG () {24;}' unless defined(&PACKET_TAG_PF_TAG);
	eval 'sub PACKET_TAG_RTSOCKFAM () {25;}' unless defined(&PACKET_TAG_RTSOCKFAM);
	eval 'sub PACKET_TAG_PF_TRANSLATE_LOCALHOST () {26;}' unless defined(&PACKET_TAG_PF_TRANSLATE_LOCALHOST);
	eval 'sub PACKET_TAG_IPOPTIONS () {27;}' unless defined(&PACKET_TAG_IPOPTIONS);
	eval 'sub PACKET_TAG_CARP () {28;}' unless defined(&PACKET_TAG_CARP);
	eval 'sub MTAG_ABI_COMPAT () {0;}' unless defined(&MTAG_ABI_COMPAT);
	eval 'sub m_tag_get {
	    my($type,$length,$wait) = @_;
    	    eval q({ ( &m_tag_alloc( &MTAG_ABI_COMPAT, $type, $length, $wait)); });
	}' unless defined(&m_tag_get);
	eval 'sub m_tag_find {
	    my($m,$type,$start) = @_;
    	    eval q({ ( &SLIST_EMPTY( ($m->{m_pkthdr}->{tags})) ?  &NULL :  &m_tag_locate($m,  &MTAG_ABI_COMPAT, $type, $start)); });
	}' unless defined(&m_tag_find);
    }
}
1;
