require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MCHAIN_H_)) {
    eval 'sub _SYS_MCHAIN_H_ () {1;}' unless defined(&_SYS_MCHAIN_H_);
    require 'machine/endian.ph';
    unless(defined(&_KERNEL)) {
	if(((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&LITTLE_ENDIAN) ? &LITTLE_ENDIAN : 0))) {
	    eval 'sub htoles {
	        my($x) = @_;
    		eval q((( &u_int16_t)($x)));
	    }' unless defined(&htoles);
	    eval 'sub letohs {
	        my($x) = @_;
    		eval q((( &u_int16_t)($x)));
	    }' unless defined(&letohs);
	    eval 'sub htolel {
	        my($x) = @_;
    		eval q((( &u_int32_t)($x)));
	    }' unless defined(&htolel);
	    eval 'sub letohl {
	        my($x) = @_;
    		eval q((( &u_int32_t)($x)));
	    }' unless defined(&letohl);
	    eval 'sub htoleq {
	        my($x) = @_;
    		eval q((( &int64_t)($x)));
	    }' unless defined(&htoleq);
	    eval 'sub letohq {
	        my($x) = @_;
    		eval q((( &int64_t)($x)));
	    }' unless defined(&letohq);
	    eval 'sub htobes {
	        my($x) = @_;
    		eval q(( &__htons($x)));
	    }' unless defined(&htobes);
	    eval 'sub betohs {
	        my($x) = @_;
    		eval q(( &__ntohs($x)));
	    }' unless defined(&betohs);
	    eval 'sub htobel {
	        my($x) = @_;
    		eval q(( &__htonl($x)));
	    }' unless defined(&htobel);
	    eval 'sub betohl {
	        my($x) = @_;
    		eval q(( &__ntohl($x)));
	    }' unless defined(&betohl);
	    eval 'sub htobeq {
	        my($x) = @_;
    		eval q({ ( &int64_t) &__htonl(( &u_int32_t)($x >> 32)) | ( &int64_t) &__htonl(( &u_int32_t)($x & 0xffffffff)) << 32; });
	    }' unless defined(&htobeq);
	    eval 'sub betohq {
	        my($x) = @_;
    		eval q({ ( &int64_t) &__ntohl(( &u_int32_t)($x >> 32)) | ( &int64_t) &__ntohl(( &u_int32_t)($x & 0xffffffff)) << 32; });
	    }' unless defined(&betohq);
	} else {
	    die("Macros for Big-Endians are incomplete");
	}
    }
    if(defined(&_KERNEL)) {
	eval 'sub MB_MSYSTEM () {0;}' unless defined(&MB_MSYSTEM);
	eval 'sub MB_MUSER () {1;}' unless defined(&MB_MUSER);
	eval 'sub MB_MINLINE () {2;}' unless defined(&MB_MINLINE);
	eval 'sub MB_MZERO () {3;}' unless defined(&MB_MZERO);
	eval 'sub MB_MCUSTOM () {4;}' unless defined(&MB_MCUSTOM);
    }
}
1;
