require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SIGNAL_H_)) {
    eval 'sub _SYS_SIGNAL_H_ () {1;}' unless defined(&_SYS_SIGNAL_H_);
    require 'sys/cdefs.ph';
    require 'sys/_types.ph';
    require 'sys/_sigset.ph';
    require 'machine/signal.ph';
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SIGHUP () {1;}' unless defined(&SIGHUP);
    }
    eval 'sub SIGINT () {2;}' unless defined(&SIGINT);
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SIGQUIT () {3;}' unless defined(&SIGQUIT);
    }
    eval 'sub SIGILL () {4;}' unless defined(&SIGILL);
    if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SIGTRAP () {5;}' unless defined(&SIGTRAP);
    }
    eval 'sub SIGABRT () {6;}' unless defined(&SIGABRT);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub SIGIOT () { &SIGABRT;}' unless defined(&SIGIOT);
	eval 'sub SIGEMT () {7;}' unless defined(&SIGEMT);
    }
    eval 'sub SIGFPE () {8;}' unless defined(&SIGFPE);
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SIGKILL () {9;}' unless defined(&SIGKILL);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) >= 200112|| (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SIGBUS () {10;}' unless defined(&SIGBUS);
    }
    eval 'sub SIGSEGV () {11;}' unless defined(&SIGSEGV);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub SIGSYS () {12;}' unless defined(&SIGSYS);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SIGPIPE () {13;}' unless defined(&SIGPIPE);
	eval 'sub SIGALRM () {14;}' unless defined(&SIGALRM);
    }
    eval 'sub SIGTERM () {15;}' unless defined(&SIGTERM);
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) >= 200112|| (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SIGURG () {16;}' unless defined(&SIGURG);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SIGSTOP () {17;}' unless defined(&SIGSTOP);
	eval 'sub SIGTSTP () {18;}' unless defined(&SIGTSTP);
	eval 'sub SIGCONT () {19;}' unless defined(&SIGCONT);
	eval 'sub SIGCHLD () {20;}' unless defined(&SIGCHLD);
	eval 'sub SIGTTIN () {21;}' unless defined(&SIGTTIN);
	eval 'sub SIGTTOU () {22;}' unless defined(&SIGTTOU);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub SIGIO () {23;}' unless defined(&SIGIO);
    }
    if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SIGXCPU () {24;}' unless defined(&SIGXCPU);
	eval 'sub SIGXFSZ () {25;}' unless defined(&SIGXFSZ);
	eval 'sub SIGVTALRM () {26;}' unless defined(&SIGVTALRM);
	eval 'sub SIGPROF () {27;}' unless defined(&SIGPROF);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub SIGWINCH () {28;}' unless defined(&SIGWINCH);
	eval 'sub SIGINFO () {29;}' unless defined(&SIGINFO);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SIGUSR1 () {30;}' unless defined(&SIGUSR1);
	eval 'sub SIGUSR2 () {31;}' unless defined(&SIGUSR2);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub SIGTHR () {32;}' unless defined(&SIGTHR);
	eval 'sub SIGLWP () { &SIGTHR;}' unless defined(&SIGLWP);
    }
    eval 'sub SIG_DFL () {(( &__sighandler_t *)0);}' unless defined(&SIG_DFL);
    eval 'sub SIG_IGN () {(( &__sighandler_t *)1);}' unless defined(&SIG_IGN);
    eval 'sub SIG_ERR () {(( &__sighandler_t *)-1);}' unless defined(&SIG_ERR);
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	unless(defined(&_SIGSET_T_DECLARED)) {
	    eval 'sub _SIGSET_T_DECLARED () {1;}' unless defined(&_SIGSET_T_DECLARED);
	}
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) >= 199309|| (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0) >= 500) {
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) >= 199309) {
	eval 'sub sigev_signo () { ($__sigev_u->{__sigev_signo});}' unless defined(&sigev_signo);
	if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	    eval 'sub sigev_notify_kqueue () { ($__sigev_u->{__sigev_notify_kqueue});}' unless defined(&sigev_notify_kqueue);
	}
	eval 'sub SIGEV_NONE () {0;}' unless defined(&SIGEV_NONE);
	eval 'sub SIGEV_SIGNAL () {1;}' unless defined(&SIGEV_SIGNAL);
	if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	    eval 'sub SIGEV_KEVENT () {3;}' unless defined(&SIGEV_KEVENT);
	}
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) >= 199309|| (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub sa_handler () { ($__sigaction_u->{__sa_handler});}' unless defined(&sa_handler);
    }
    if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub sa_sigaction () { ($__sigaction_u->{__sa_sigaction});}' unless defined(&sa_sigaction);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SA_NOCLDSTOP () {0x8;}' unless defined(&SA_NOCLDSTOP);
    }
    if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SA_ONSTACK () {0x1;}' unless defined(&SA_ONSTACK);
	eval 'sub SA_RESTART () {0x2;}' unless defined(&SA_RESTART);
	eval 'sub SA_RESETHAND () {0x4;}' unless defined(&SA_RESETHAND);
	eval 'sub SA_NODEFER () {0x10;}' unless defined(&SA_NODEFER);
	eval 'sub SA_NOCLDWAIT () {0x20;}' unless defined(&SA_NOCLDWAIT);
	eval 'sub SA_SIGINFO () {0x40;}' unless defined(&SA_SIGINFO);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub NSIG () {32;}' unless defined(&NSIG);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SI_USER () {0x10001;}' unless defined(&SI_USER);
	eval 'sub SI_QUEUE () {0x10002;}' unless defined(&SI_QUEUE);
	eval 'sub SI_TIMER () {0x10003;}' unless defined(&SI_TIMER);
	eval 'sub SI_ASYNCIO () {0x10004;}' unless defined(&SI_ASYNCIO);
	eval 'sub SI_MESGQ () {0x10005;}' unless defined(&SI_MESGQ);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub SI_UNDEFINED () {0;}' unless defined(&SI_UNDEFINED);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
    }
    if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	} else {
	}
	eval 'sub SS_ONSTACK () {0x1;}' unless defined(&SS_ONSTACK);
	eval 'sub SS_DISABLE () {0x4;}' unless defined(&SS_DISABLE);
	eval 'sub SIGSTKSZ () {( &MINSIGSTKSZ + 32768);}' unless defined(&SIGSTKSZ);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub SV_ONSTACK () { &SA_ONSTACK;}' unless defined(&SV_ONSTACK);
	eval 'sub SV_INTERRUPT () { &SA_RESTART;}' unless defined(&SV_INTERRUPT);
	eval 'sub SV_RESETHAND () { &SA_RESETHAND;}' unless defined(&SV_RESETHAND);
	eval 'sub SV_NODEFER () { &SA_NODEFER;}' unless defined(&SV_NODEFER);
	eval 'sub SV_NOCLDSTOP () { &SA_NOCLDSTOP;}' unless defined(&SV_NOCLDSTOP);
	eval 'sub SV_SIGINFO () { &SA_SIGINFO;}' unless defined(&SV_SIGINFO);
	eval 'sub sv_onstack () { &sv_flags;}' unless defined(&sv_onstack);
    }
    if(defined( &_KERNEL)  && defined( &COMPAT_43)  && !defined( &__i386__)  && !defined( &__alpha__)) {
    }
    if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0) || (defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) > 0 && (defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) <= 200112) {
	eval 'sub sigmask {
	    my($m) = @_;
    	    eval q((1<< (($m)-1)));
	}' unless defined(&sigmask);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub BADSIG () { &SIG_ERR;}' unless defined(&BADSIG);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : 0) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : 0)) {
	eval 'sub SIG_BLOCK () {1;}' unless defined(&SIG_BLOCK);
	eval 'sub SIG_UNBLOCK () {2;}' unless defined(&SIG_UNBLOCK);
	eval 'sub SIG_SETMASK () {3;}' unless defined(&SIG_SETMASK);
    }
}
1;
