require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_WAIT_H_)) {
    eval 'sub _SYS_WAIT_H_ () {1;}' unless defined(&_SYS_WAIT_H_);
    require 'sys/cdefs.ph';
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub _W_INT {
	    my($w) = @_;
    	    eval q((*($w)));
	}' unless defined(&_W_INT);
	eval 'sub WCOREFLAG () {0200;}' unless defined(&WCOREFLAG);
    } else {
	eval 'sub _W_INT {
	    my($i) = @_;
    	    eval q(($i));
	}' unless defined(&_W_INT);
    }
    eval 'sub _WSTATUS {
        my($x) = @_;
	    eval q(( &_W_INT($x) & 0177));
    }' unless defined(&_WSTATUS);
    eval 'sub _WSTOPPED () {0177;}' unless defined(&_WSTOPPED);
    eval 'sub WIFSTOPPED {
        my($x) = @_;
	    eval q(( &_WSTATUS($x) ==  &_WSTOPPED));
    }' unless defined(&WIFSTOPPED);
    eval 'sub WSTOPSIG {
        my($x) = @_;
	    eval q(( &_W_INT($x) >> 8));
    }' unless defined(&WSTOPSIG);
    eval 'sub WIFSIGNALED {
        my($x) = @_;
	    eval q(( &_WSTATUS($x) !=  &_WSTOPPED  &&  &_WSTATUS($x) != 0));
    }' unless defined(&WIFSIGNALED);
    eval 'sub WTERMSIG {
        my($x) = @_;
	    eval q(( &_WSTATUS($x)));
    }' unless defined(&WTERMSIG);
    eval 'sub WIFEXITED {
        my($x) = @_;
	    eval q(( &_WSTATUS($x) == 0));
    }' unless defined(&WIFEXITED);
    eval 'sub WEXITSTATUS {
        my($x) = @_;
	    eval q(( &_W_INT($x) >> 8));
    }' unless defined(&WEXITSTATUS);
    eval 'sub WIFCONTINUED {
        my($x) = @_;
	    eval q(($x == 0x13));
    }' unless defined(&WIFCONTINUED);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub WCOREDUMP {
	    my($x) = @_;
    	    eval q(( &_W_INT($x) &  &WCOREFLAG));
	}' unless defined(&WCOREDUMP);
	eval 'sub W_EXITCODE {
	    my($ret, $sig) = @_;
    	    eval q((($ret) << 8| ($sig)));
	}' unless defined(&W_EXITCODE);
	eval 'sub W_STOPCODE {
	    my($sig) = @_;
    	    eval q((($sig) << 8|  &_WSTOPPED));
	}' unless defined(&W_STOPCODE);
    }
    eval 'sub WNOHANG () {1;}' unless defined(&WNOHANG);
    eval 'sub WUNTRACED () {2;}' unless defined(&WUNTRACED);
    eval 'sub WCONTINUED () {4;}' unless defined(&WCONTINUED);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub WLINUXCLONE () {0x80000000;}' unless defined(&WLINUXCLONE);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	eval 'sub WAIT_ANY () {(-1);}' unless defined(&WAIT_ANY);
	eval 'sub WAIT_MYPGRP () {0;}' unless defined(&WAIT_MYPGRP);
    }
    unless(defined(&_KERNEL)) {
	require 'sys/types.ph';
	if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : 0)) {
	}
    }
}
1;
